/*
 *  WindowMaker window manager
 * 
 *  Copyright (c) 1997 Alfredo K. Kojima
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef WMSETUP_H_
#define WMSETUP_H_

#define WDS_REQUEST_FAILED	0x00
#define WDS_REQUEST_SUCCEED	0x01
#define WDS_BAD_REQUEST		0x02

/* request code */
#define WDS_SEND_VERSION	0x10
#define WDS_SEND_FONTS		0x11
#define WDS_SEND_FORE_COLORS	0x12
#define WDS_REPAINT		0x1e
#define WDS_CLOSEDOWN		0x1f

/* request/repply code headers */
#define WDS_WINDOW_TITLE_FONT	0x20
#define WDS_MENU_TITLE_FONT	0x21
#define WDS_MENU_ENTRY_FONT	0x22
/*
#define WDS_ICON_TITLE_FONT	0x23
#define WDS_DISPLAY_FONT	0x24
#define WDS_DIALOG_FONT		0x25
#define WDS_DIALOG_MSG_FONT	0x26
*/
#define WDS_FTITLE_FORE_COLOR		0x30
#define WDS_UTITLE_FORE_COLOR		0x31
#define WDS_MENU_TITLE_FORE_COLOR	0x32
#define WDS_MENU_TEXT_FORE_COLOR	0x33
#define WDS_MENU_TEXT_DISABLED_COLOR	0x34

#define WDS_FTITLE_COLOR		0x40
#define WDS_UTITLE_COLOR		0x41
#define WDS_MENU_TITLE_COLOR		0x42
#define WDS_MENU_TEXT_COLOR		0x43


void wSetupCheck(WScreen *scr);
void wSetupOpen(WScreen *scr, char *prog);
void wSetupClose(WScreen *scr);




#endif /* WMSETUP_H_ */
