.\" t
.\" @(#)FvwmIdent.1	1/12/94
.TH FvwmIdent 1.20 "Jan 28 1994"
.UC
.SH NAME
FvwmIdent \- the FVWM identify-window module
.SH SYNOPSIS
FvwmIdent is spawned by fvwm, so no command line invocation will work.

.SH DESCRIPTION
The FvwmIdent module prompts the user to select a target window, if
the module was not launched from within a window context in Fvwm.
After that, it pops up a window with information about the window
which was selected.

FvwmIdent reads the same .fvwmrc file as fvwm reads when it starts up,
and looks for lines similar to "*FvwmIdentFore green".

.SH COPYRIGHTS
The FvwmIdent program, and the concept for
interfacing this module to the Window Manager, are all original work
by Robert Nation Nobutaka Suzuki.

Copyright 1994, Robert Nation and Nobutaka Suzuki. No guarantees or
warranties or anything 
are provided or implied in any way whatsoever. Use this program at your
own risk. Permission to use this program for any purpose is given,
as long as the copyright is kept intact. 


.SH INITIALIZATION
During initialization, \fIFvwmIdent\fP will eventually search a 
configuration file which describes the colors and font to use.
The configuration file is the same file that fvwm used during initialization.

If the FvwmIdent executable is linked to another name, ie ln -s
FvwmIdent MoreIdentify, then another module called MoreIdentify can be
started, with a completely different configuration than FvwmIdent,
simply by changing the keyword  FvwmIdent to MoreIdentify. This way multiple
clutter-reduction programs can be used.

.SH INVOCATION
FvwmIdent can be invoked by binding the action 'Module
FvwmIdent' to a menu or key-stroke in the .fvwmrc file.
Fvwm will search
directory specified in the ModulePath configuration option to attempt
to locate FvwmIdent. Although nothing keeps you from launching
FvwmIdent at start-up time, you probably don't want to.

.SH CONFIGURATION OPTIONS
FvwmIdent reads the same .fvwmrc file as fvwm reads when it starts up,
and looks for lines as listed below:

.IP "*FvwmIdentFore \fIcolor\fP"
Tells the module to use \fIcolor\fP instead of black for text.

.IP "*FvwmIdentBack \fIcolor\fP"
Tells the module to use \fIcolor\fP instead of black for the window
background.

.IP "*FvwmIdentFont \fIfontname\fP"
Tells the module to use \fIfontname\fP instead of fixed for text.


.SH AUTHOR
Robert Nation and  and Nobutaka
Suzuki (nobuta-s@is.aist-nara.ac.jp).

