.TH XTOPO 6X
.SH NAME
xtopo \- calculate and display an artificial fractal landscape topographically
.SH SYNOPSIS
.in +8n
.ti -8n
\fIxtopo\fR
[-druFRTV] [-w width] [-h height] [-o filename] [-S level] [-H beta] [-m index] [-c colorwheel] [-n count] [-a min] [-b max]
.in -8n
.SH DESCRIPTION
\fIxtopo\fR
generates and graphically displays an artificial fractal landscape.
.SH OPTIONS
.TP 8
-H \fIr\fP
Specifies the value of beta (determines fractal dimension).
Larger values of beta give rise to "smoother" fractal
landscapes. The default value of beta is 0.5.
.TP
-R
Indicates the display will be in the root window. In this mode, the  default
color map will be used and no spinning of the color wheel is possible.
.TP
-S \fIr\fP
Specifies the value of sea level. Values can range from 0 to 1. Default is 0.35.
.TP
-T
Indicates the use of a Thin array (512x512) rather than the 1K x 1K array.
.TP
-V
Indicates the use of a Very thin array (256x256) rather than the 1K x 1K array.
.TP
-a \fImin\fP
Specifies the lower bound from which a random value of beta will be selected.
This is only used if -r is also selected. Default value is 0.0.
.TP
-b \fImax\fP
Specifies the upper bound from which a random value of beta will be selected.
This is only used if -r is also selected. Default value is 1.0.
.TP
-c \fIn\fP
Selects one of ten different color wheels to use. The default color
wheel is a rainbow palette.
.TP
-d
Indicates demo mode. In this mode, the landscape will be calculated, displayed,
spun, then the program will exit.
.TP
-w \fIn\fP
Specifies the width of the window. Default is 512.
.TP
-h \fIn\fP
Specifies the height of the window. Default is 512.
.TP
-m \fIn\fP
Specifies the minimum color index to be used for the  upper end of the color
wheel
.TP
-n \fInumpics\fP
Specifies how many topographic maps to compute before exiting. During display
(see NOTES below), pressing 'n' or 'N' will skip to the next map.
.TP
-o \fIfilename\fP
Specifies the output filename to be used. If the -o option is given, this
file will automatically be written out at the completion of the drawing.
If it is not specified, a default filename of xtopo.ppm is used and only
written if the 'f' or 'F' keys are pressed during a run. The format of the
output file is PPM. The parameters used to calculate the picture are included 
as comments at the beginning of the output file.
.TP
-r
Indicates to randomly select a value of beta between 0 and 1 for each
landscape.
-s
Indicates to spin the color wheel immediately upon completion of display.
.TP
-u
Produces a usage message.
.TP
.sp 2
.SH NOTES
.sp
During display, use of the keys 
\fI+-><0123456789fFnNrswW?hqQ\fP
indicates:
.sp
.ti 10
(+) Increment minimum color index.
.ti 10
(+) Decrement minimum color index.
.ti 10
(<) Decrement sea level and redraw.
.ti 10
(>) Increment sea level and redraw.
.ti 10
(0-9) Set sea level to 0.0 thru 0.9.
.ti 10
(n or N) Skip to the next fractal landscape.
.ti 10
(s) Spin the color wheel in the positive direction.
.ti 10
(r) Spin the color wheel in the negative direction.
.ti 10
(W or w) Increment or decrement the color map index.
.ti 10
(Q or q) quit
.sp 2
.SH AUTHOR
.nf
        Ronald Joe Record
     The Santa Cruz Operation 
          P.O. Box 1900
       Santa Cruz, CA 95061
            rr@sco.com
.fi
.sp 2
.SH ACKNOWLEDGEMENTS
.PP
The algorithm, which uses the technique of midpoint displacement, was derived 
from lectures given by Dietmar Saupe at the University of California at Santa 
Cruz. Assistance with colormaps and spinning color wheels and X was gleaned 
from Hiram Clawson and Stacey Campbell.
