#include <iostream.h>  //???

#include <qlined.h>
#include <qcombo.h>

#define FIELD_HEIGHT 20

#define DATE_X       1
#define DATE_Y       1
#define DATE_W       40
#define DATE_H       FIELD_HEIGHT

#define YEAR_X       1
#define YEAR_Y       22
#define YEAR_W       40
#define YEAR_H       FIELD_HEIGHT

#define NUM_X        42
#define NUM_Y        1
#define NUM_W        40
#define NUM_H        FIELD_HEIGHT

#define TTYP_X       42
#define TTYP_Y       22
#define TTYP_W       40
#define TTYP_H       FIELD_HEIGHT

#define DESC_X       84
#define DESC_Y       1
#define DESC_W       250
#define DESC_H       FIELD_HEIGHT

#define MEMO_X       84
#define MEMO_Y       22
#define MEMO_W       125
#define MEMO_H       FIELD_HEIGHT

#define XFER_X       211
#define XFER_Y       22
#define XFER_W       124
#define XFER_H       FIELD_HEIGHT

#define RECN_X       336
#define RECN_Y       1
#define RECN_W       15
#define RECN_H       FIELD_HEIGHT

#define DEBIT_X      353
#define DEBIT_Y      1
#define DEBIT_W      80
#define DEBIT_H      FIELD_HEIGHT

#define CREDIT_X     435
#define CREDIT_Y     1
#define CREDIT_W     80
#define CREDIT_H     FIELD_HEIGHT

#define TOTAL_X      517
#define TOTAL_Y      1
#define TOTAL_W      80
#define TOTAL_H      FIELD_HEIGHT

/*******************************************************************\
\*******************************************************************/
class QRegisterEntry : public QWidget
{
public:
  QRegisterEntry( QWidget *parent=0, const char *name=0 );
  ~QRegisterEntry();
private:
  QLineEdit *dateField;
  QLineEdit *yearField;
  QLineEdit *numField;
  QLineEdit *descField;
  QLineEdit *memoField;
  QLineEdit *recnField;
  QLineEdit *creditField;
  QLineEdit *debitField;
  QLineEdit *totalField;
  
  QComboBox *xferAccField;
  QComboBox *trnsTypField;
};

QRegisterEntry::QRegisterEntry( QWidget *parent, const char *name )
: QWidget( parent, name )
  {
  /**** SET UP DIMENSIONS OF THIS WIDGET ****/
  setFRect( QRect(0,0,599,42) );
  
  /**** MAKE THE FIELDS ****/
  dateField   = new QLineEdit( this, "QegisterEntryLineEdit" );
  dateField->setFrame(FALSE);
  dateField->setGeometry( DATE_X, DATE_Y, DATE_W, DATE_H );
  
  yearField   = new QLineEdit( this, "QegisterEntryLineEdit" );
  yearField->setFrame(FALSE);
  yearField->setGeometry( YEAR_X, YEAR_Y, YEAR_W, YEAR_H );
    
  numField    = new QLineEdit( this, "QegisterEntryLineEdit" );
  numField->setFrame(FALSE);
  numField->setGeometry( NUM_X, NUM_Y, NUM_W, NUM_H );
  
  descField   = new QLineEdit( this, "QegisterEntryLineEdit" );
  descField->setFrame(FALSE);
  descField->setGeometry( DESC_X, DESC_Y, DESC_W, DESC_H );
  
  memoField   = new QLineEdit( this, "QegisterEntryLineEdit" );
  memoField->setFrame(FALSE);
  memoField->setGeometry( MEMO_X, MEMO_Y, MEMO_W, MEMO_H );
  
  recnField   = new QLineEdit( this, "QegisterEntryLineEdit" );
  recnField->setFrame(FALSE);
  recnField->setGeometry( RECN_X, RECN_Y, RECN_W, RECN_H );
  
  debitField  = new QLineEdit( this, "QegisterEntryLineEdit" );
  debitField->setFrame(FALSE);
  debitField->setGeometry( DEBIT_X, DEBIT_Y, DEBIT_W, DEBIT_H );
  
  creditField = new QLineEdit( this, "QegisterEntryLineEdit" );
  creditField->setFrame(FALSE);
  creditField->setGeometry( CREDIT_X, CREDIT_Y, CREDIT_W, CREDIT_H );
  
  totalField  = new QLineEdit( this, "QegisterEntryLineEdit" );
  totalField->setFrame(FALSE);
  totalField->setGeometry( TOTAL_X, TOTAL_Y, TOTAL_W, TOTAL_H );
  
  /**** ADD COMBOBOXES ****/
  xferAccField = new QComboBox ( FALSE, this, "QegisterEntryComboBox" );
  xferAccField->setGeometry( XFER_X, XFER_Y, XFER_W, XFER_H );
  
  trnsTypField = new QComboBox ( FALSE, this, "QegisterEntryComboBox" );
  trnsTypField->setGeometry( TTYP_X, TTYP_Y, TTYP_W, TTYP_H );
  }

QRegisterEntry::~QRegisterEntry()
  {
  // All child widgets are deleted by Qt.
  // The top-level layout and all its sub-layouts are deleted by Qt.
  }


/*******************************************************************\
\*******************************************************************/
#include <qtablevw.h>
#include <qpainter.h>

class QRegister : public QTableView
{
public:
  QRegister( QWidget *parent=0, const char *name=0 );
  ~QRegister();
  
protected:
  void paintCell( QPainter *p, int row, int col );
  void mousePressEvent( QMouseEvent* me );
#if 0
  void focusInEvent( QFocusEvent* );
  void focusOutEvent( QFocusEvent* );
#endif
  // paintTransaction() draws non-active transactions.  The
  // active transaction is handled by floating a QRegisterEntry
  // over the current cell.  This is re-implemented in derived
  // classes with transaction entries that look different:
  virtual void paintTransaction( QPainter *p, int row, int col );
  
private:
  // We float a QRegisterEntry over the active cell in the QRegister
  QRegisterEntry *activeEntry;

  int curRow;
  int curCol;
};

QRegister::QRegister( QWidget *parent=0, const char *name=0 )
: QTableView(parent,name)
  {
  /**** INITIALIZE STUFF ****/
  curRow = curCol = 0;                      // set currently selected cell
  setNumRows(15);
  setNumCols(1);
  setFocusPolicy(StrongFocus);              // we accept keyboard focus
  setBackgroundMode(PaletteBase);           // set widgets background
  setTableFlags( Tbl_vScrollBar |           // always vertical scroll bar
		 Tbl_hScrollBar |           // ditto for horizontal
		 Tbl_clipCellPainting |     // avoid drawing outside cell
		 Tbl_smoothScrolling);      // easier to see the scrolling
  
  /**** MAKE A REGISTERENTRY TO MAP OVER THE CURRENT TRANSACTION ****/
  activeEntry = new QRegisterEntry( this, "QRegisterEntry" );
  
  // Set the size of a cell to match the size of a QRegisterEntry:
  setCellWidth( activeEntry->width()+1 );   // set width of cell in pixels
  setCellHeight( activeEntry->height()+1 ); // set height of cell in pixels
  }

QRegister::~QRegister()
  {}

void
QRegister::paintCell( QPainter *p, int row, int col )
  {
  int w = cellWidth( col );
  int h = cellHeight( row );
  int x2 = w - 1;
  int y2 = h - 1;
  
  // Draw frame:
  p->drawLine( x2, 0, x2, y2 );             // draw vertical line on right
  p->drawLine( 0, y2, x2, y2 );             // Draw horiz. line at bottom
  
  // If this is the current row, then float the activeEntry
  // over this cell...
  if( row == curRow )
    {
    int xPos, yPos;
    colXPos( col, &xPos );
    rowYPos( row, &yPos );
    cout << "(" << row << "," << col << "), (" << xPos << "," << yPos << ")" << endl;
    activeEntry->move( xPos, yPos );
    }
  // ... Otherwise, just draw the contents of the cell
  else
    paintTransaction( p, row, col );
  }

void
QRegister::paintTransaction( QPainter *p, int row, int col )
  {
  int w = cellWidth( col );                 // width of cell in pixels
  int h = cellHeight( row );                // height of cell in pixels
  int x2 = w - 1;
  int y2 = h - 1;
  
  p->setPen(DotLine);
  
  // Draw horizontal:
  p->drawLine( 0, FIELD_HEIGHT, x2, FIELD_HEIGHT );
  
  // Draw verticals:
  p->drawLine( NUM_X, 0, NUM_X, y2 );
  p->drawLine( DESC_X, 0, DESC_X, y2 );
  p->drawLine( XFER_X, FIELD_HEIGHT, XFER_X, y2 );
  p->drawLine( RECN_X, 0, RECN_X, y2 );
  p->drawLine( DEBIT_X, 0, DEBIT_X, y2 );
  p->drawLine( CREDIT_X, 0, CREDIT_X, y2 );
  p->drawLine( TOTAL_X, 0, TOTAL_X, y2 );
  
  p->setPen(SolidLine);

  // Draw text:
  // ???
  }

void
QRegister::mousePressEvent( QMouseEvent* me )
  {
  int oldRow = curRow;                      // store previous current cell
  int oldCol = curCol;
  QPoint clickedPos = me->pos();            // extract pointer position
  
  curRow = findRow( clickedPos.y() );       // map to row; set current cell
  curCol = findCol( clickedPos.x() );       // map to col; set current cell
  if( (curRow != oldRow) ||                 // if current cell has moved,
      (curCol != oldCol) )
    {
    updateCell( oldRow, oldCol );           // erase previous marking
    updateCell( curRow, curCol );           // show new current cell
    }
  }

/*******************************************************************\
\*******************************************************************/
#include <qapp.h>

int main( int argc, char **argv )
  {
  QApplication a( argc, argv );
  
  QWidget *f = new QRegister;
  f->show();
  
  a.setMainWidget(f);
  return a.exec();
  }
