/*
 * Copyright(c) 1995,1996 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/*	$Id: choose_folder.c,v 1.30 1996/12/15 14:22:24 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

FD_Choose_Folder *choose;
FD_Create_Folder *create;
static int ready = 0;
static int crready = 0;
static int wrkfolder = 0;
#define	MAX_PUP_FOLDERS	32

void
choose_browse(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
choose_dbl(obj, param)
FL_OBJECT *obj;
long param;
{
fl_trigger_object(choose->Ready_Button);
}

void
New_Folder_Call(obj, param)
FL_OBJECT *obj;
long param;
{
int i;
struct _mail_folder *fld;

fl_deactivate_form(choose->Choose_Folder);

if ((fld = create_folder(NULL, 0)) == NULL) {
	fl_activate_form(choose->Choose_Folder);
	return;
					    }

redraw_fld_win();

fl_freeze_form(choose->Choose_Folder);
fl_clear_browser(choose->Folder_Browse);
for (i = 0; i < folders_num; i++) 
	fl_add_browser_line(choose->Folder_Browse, get_fld_line(mailbox[i]));
fl_select_browser_line(choose->Folder_Browse, 1);
fl_set_browser_topline(choose->Folder_Browse, 1);
wrkfolder = 0;
fl_unfreeze_form(choose->Choose_Folder);

fl_activate_form(choose->Choose_Folder);

return;
}

void
choose_init()
{
choose = create_form_Choose_Folder();
}

struct _mail_folder *
choose_folder()
{
int i;
struct _mail_folder *fld;
FL_OBJECT *obj;

if (ready) {
        XRaiseWindow(fl_display, choose->Choose_Folder->window);
        display_msg(MSG_WARN, "choose folder", "Dialog is currently in use, close it and open again");
	return NULL; }

ready = 1;

 if ((wrkfolder >= folders_num) || (wrkfolder < 0))
	wrkfolder = 0;

 fl_clear_browser(choose->Folder_Browse);
 fl_freeze_form(choose->Choose_Folder);
 for (i = 0; i < folders_num; i++)
	fl_add_browser_line(choose->Folder_Browse, get_fld_line(mailbox[i]));
 fl_unfreeze_form(choose->Choose_Folder);

 fl_set_browser_fontsize(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderFSize", FL_DEFAULT_SIZE));
 fl_set_browser_fontstyle(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderFStyle", FL_NORMAL_STYLE));
 fl_set_object_color(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderBgCol", FL_TOP_BCOL), b_getcfg_int(conf_name, "ChooseFolderFgCol", FL_YELLOW));

 fl_select_browser_line(choose->Folder_Browse, wrkfolder + 1);
 fl_set_browser_topline(choose->Folder_Browse, wrkfolder + 1);

 fl_set_browser_dblclick_callback(choose->Folder_Browse, choose_dbl, 0);

 fl_show_form(choose->Choose_Folder,FL_PLACE_MOUSE, FL_TRANSIENT, "Choose Folder");

 while (ready == 1) 	{
  obj = fl_do_only_forms();

  if (obj == choose->Ready_Button)
	ready = 2;
  else
  if (obj == choose->Cancel_Button)
	ready = 3;
			}

 i = fl_get_browser(choose->Folder_Browse);

 fl_hide_form(choose->Choose_Folder);

 if (ready == 2) {
	ready = 0;
	if (i <= 0)
		return NULL;

 	fld = get_folder_by_index(i - 1);
	if (fld)
		wrkfolder = i - 1;

	return fld;
		}

 ready = 0;
 return NULL;
}

struct _mail_folder *
pup_choose_folder(form)
FL_FORM *form;
{
int fpup, i;
char ptext[32];

  fpup = fl_newpup(form ? form->window : main_form->window);
  fl_addtopup(fpup, "Folders %t");
  i = 0;
  for (i = 0; i< folders_num;i++) {
	if (mailbox[i]->flags & SYSTEM)
		sprintf(ptext, "%-16.16s%%l", get_folder_full_name(mailbox[i]));
	else
		sprintf(ptext, "%-16.16s", get_folder_full_name(mailbox[i]));

	fl_addtopup(fpup, ptext);
	if (i > MAX_PUP_FOLDERS)
		break;
                                  }

  i = fl_dopup(fpup);
  fl_freepup(fpup);
  if (i <= 0)
	return NULL;
  i--;

  return get_folder_by_index(i);
}

void
Create_Name_Call(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
Create_Local_Call(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
Create_Remote_Call(obj, param)
FL_OBJECT *obj;
long param;
{
}

struct _mail_folder *
create_folder(name, ftype)
char *name;
int ftype;
{
struct _mail_folder *folder;
char *p, fname[MAX_FOLD_NAME_LEN];

 if (crready) {
        XRaiseWindow(fl_display, create->Create_Folder->window);
        display_msg(MSG_WARN, "create folder", "Dialog is currently in use, close it and open again");
	return NULL; }

 folder = NULL;
 crready = 1;

 create = create_form_Create_Folder();

 fl_set_input(create->Create_Name, name ? name : "");

 switch (ftype) {
  case F_MH:
	fl_set_button(create->Create_Local, 1);
  break;

  case F_IMAP:
	fl_set_button(create->Create_Remote, 1);
  break;

  default:
	fl_set_button(create->Create_Local, 1);
	ftype = F_MH;
  break;
		}

  if (!imap_isconnected())
	fl_deactivate_object(create->Create_Remote);

 fl_show_form(create->Create_Folder,FL_PLACE_MOUSE, FL_TRANSIENT, "Create Folder");
 fl_do_only_forms();

 name = (char *)fl_get_input(create->Create_Name);
 if (strlen(name) < 1)
	goto crexit;

 if (strlen(name) >= MAX_FOLD_NAME_LEN) 	{
	display_msg(MSG_WARN, "create", "Folder name too long");
	goto crexit;
						}

 p = name;
 while (*p != '\0') {
   if (!isgraph(*p)) {
	display_msg(MSG_WARN, "create", "Illegal character in folder name");
	name = NULL;
	break;
		     }
   p++; 
		    }

 if (name == NULL)
	goto crexit;

 strcpy(fname, name);
 name = rem_tr_space(fname);

 folder = NULL;
 if (fl_get_button(create->Create_Local)) {
	if (name[0] == '.')  {
		display_msg(MSG_WARN, "create", "Illegal character in folder name");
		goto crexit; }
	folder = create_mh_folder(NULL, name);
					  }
 else
 if (fl_get_button(create->Create_Remote))
	folder = create_imap_folder(NULL, name);

crexit:
 fl_hide_form(create->Create_Folder);
 fl_free_form(create->Create_Folder);
 fl_free(create);
 create = NULL;

 crready = 0;

 return folder;
}
