/*
 * Copyright(c) 1995,1996 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: msg.c,v 1.221 1996/12/22 13:56:55 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>
#define	MSG_XPM
#include <X11/xpm.h>
#include <pixmaps.h>
#include <fl_edit.h>


#define MAX_MSG_FORMS		7

#define MAX_EDITABLE_LINES	4096
#define MAX_EDITABLE_SIZE	65535

#define MAX_VIEWABLE_LINES	4096
#define MAX_VIEWABLE_SIZE	131072

#define	EDIT_MENU	"Insert file (Alt+I)|Uuencode file|Save to File|Append to File%l|Sign Message (Alt+S)|Quote original (Alt+Q)|Spelling check (Alt+P)"

struct msg_form {
	struct _mail_msg	*me_msg;
	FL_FORM			*me_form;
	FL_OBJECT		*me_from,
				*me_to,
				*me_to_list,
				*me_to_type,
				*me_subj,
				*me_text,
				*me_pixmap,
				*me_bitmap,
				*me_date,
				*me_mime;
	int			me_lang;
#define me_sender	me_to
	int			me_flags;
#define	MF_VIEW		0x01
#define MF_HEADER	0x02
#define	MF_CHANGED	0x04
#define	MF_LOCKED	0x08
	u_long			tofft;
};

static struct msg_form		*mf_arr[MAX_MSG_FORMS];
static int			mf_x,mf_y;
static int			num_cascade = 0;
static	FL_OBJECT		*tobj = NULL;
int menuind;
int ttips = -1;

void end_msg();
void destruct_msg();
char *form_to_msg();
void ext_edit_msg(int num);
void ext_edit_exit(struct _proc_info *pinfo);
void ext_view_msg(int num, int asis);
void display_msg_text();
void ext_view_exit(struct _proc_info *pinfo);
char *compose_msg_text(struct msg_form *mf, int update);
void display_addresses(int id);
struct _mail_addr *get_msgaddr_byline(int id, int line, int *type);
int update_msg(int id);
void cb_mime(FL_OBJECT *obj, long num);
void cb_msg_edit(FL_OBJECT *obj, long num);
void cb_addr_addto(FL_OBJECT *obj, long num);
void cb_mbutton_exit_edit(FL_OBJECT *obj, long num);
void cb_mbutton_delete(FL_OBJECT *obj, long num);
void cb_spell_button(FL_OBJECT *obj, long num);
void cb_pgp_encode_button(FL_OBJECT *obj, long num);
void cb_pgp_decode_button(FL_OBJECT *obj, long num);
void cb_pgp_signencode_button(FL_OBJECT *obj, long num);
void cb_pgp_sign_button(FL_OBJECT *obj, long num);
void cb_pgp_verify_button(FL_OBJECT *obj, long num);
void cb_pgp_extkey_button(FL_OBJECT *obj, long num);
void cb_pgp_addkey_button(FL_OBJECT *obj, long num);
void pgp_message(long num, int mode);
int  pgp_sign_file(struct _mail_msg *msg, char *mfile);
void release_orig(int id);

void
msg_form_init()
{
int i;
	for (i=0;i<MAX_MSG_FORMS;i++) {
		mf_arr[i] = NULL;
	}
	sscanf(b_getcfg_str(conf_name, "msgformsize", "800 600"), "%d%d",
								&mf_x,&mf_y);
}

void
msg_form_shutdown()
{
char	buf[20];
int i;

	for (i=0;i<MAX_MSG_FORMS;i++) {
		if (mf_arr[i])
			end_msg(i);
	}

	sprintf(buf,"%d %d",mf_x,mf_y);
	b_putcfg_str(conf_name, "msgformsize", buf);
}

void
switch_ttips()
{
 switch (ttips) {
  case -2:
	ttips = 1;
  break;

  case 1:
	ttips = -2;
  break;

		}
}

void
cb_ttip_timer(FL_OBJECT *obj, long param)
{
  if (!tobj || (ttips <= 0))
	return;

  fl_show_oneliner(tobj->u_vdata, tobj->form->x + tobj->x,
	tobj->form->y + tobj->y + tobj->h + 5);
}

int
post_handler(ob,event,mx,my,key,xev)
FL_OBJECT *ob;
int event;
FL_Coord mx;
FL_Coord my;
int key;
void *xev;
{

  if (ob->u_vdata == NULL)
	return 0;

  if (ttips == -1)
	ttips = b_getcfg_int(conf_name, "tooltips", 1);

  if (ttips <= 0)
	return 0;

  switch(event) {
   case FL_ENTER:
	tobj = ob;
	fl_set_timer(ttip_timer, TTIP_DELAY);
   break;

   default:
	if (tobj &&
	     (event != FL_MOTION)) {
		fl_hide_oneliner();
		fl_set_timer(ttip_timer, 0);
		tobj = NULL;
		  		   }
   break;
		  }

  return 0;
}

void
cb_txtedit(obj, num)
	FL_OBJECT       *obj;
	int num;
{
  mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_editor(obj, num)
	FL_OBJECT       *obj;
	int num;
{
long res;
int epup = fl_defpup(mf_arr[num]->me_form->window, EDIT_MENU);

 res = fl_dopup(epup);
 fl_freepup(epup);
 if (res > 0)
	cb_msg_edit(obj, -res);
}

void
cb_browser(obj, num)
	FL_OBJECT       *obj;
	int num;
{
}

void
cb_conf_delivery(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= C_DELIVERY;
 else
	mf_arr[num]->me_msg->flags &= ~C_DELIVERY;
}

void
cb_conf_read(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= C_READ;
 else
	mf_arr[num]->me_msg->flags &= ~C_READ;
}

void
cb_urgent(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= URGENT;
 else
	mf_arr[num]->me_msg->flags &= ~URGENT;
}

void
abook_addr_add(adr, type, num)
struct _mail_addr *adr;
int type, num;
{
struct	msg_form	*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*adr1;

	if (adr == NULL)
		return;
	mf_ptr = mf_arr[num];
	msg = mf_ptr->me_msg;

	if (count_recipients(msg) > MAX_RECP_NUM) {
		display_msg(MSG_WARN, "edit", "Can not add more then %d recipients", MAX_RECP_NUM);
		return;			 	  }
	adr = copy_address_chain(adr);

	switch (type) {
		case TO_TYPE:
		 if (msg->header->To == NULL)
			msg->header->To = adr;
		 else	{
			adr1 = msg->header->To;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = adr;
			}
		 break;
		case CC_TYPE:
		 if (msg->header->Cc == NULL)
			msg->header->Cc = adr;
		 else	{
			adr1 = msg->header->Cc;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = adr;
			}
		 break;
		case BCC_TYPE:
		 if (msg->header->Bcc == NULL)
			msg->header->Bcc = adr;
		 else	{
			adr1 = msg->header->Bcc;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = adr;
			}
		 break;
				}

	fl_freeze_form(mf_ptr->me_form);
	display_addresses(num);

	fl_select_browser_line(mf_ptr->me_to_list, 1);
	fl_unfreeze_form(mf_ptr->me_form);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_addr_add(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct	msg_form	*mf_ptr;

	mf_ptr = mf_arr[num];
	if (mf_ptr->me_flags & MF_LOCKED)
		return;

	mf_ptr->me_flags |= MF_LOCKED;
	addr_book_set_placement(mf_ptr->me_form->x + mf_ptr->me_text->x +xofft,
				mf_ptr->me_form->y + mf_ptr->me_text->y +yofft);
	addr_book(NULL, abook_addr_add, num);
	mf_ptr->me_flags &= ~MF_LOCKED;

	return;
}

void
cb_addr_addto(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
struct	msg_form	*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*ma, *adr1;
char *addr;

	mf_ptr = mf_arr[num];
	msg = mf_ptr->me_msg;

	if (count_recipients(msg) > MAX_RECP_NUM) {
		display_msg(MSG_WARN, "edit", "Can not add more then %d recipients", MAX_RECP_NUM);
		fl_set_input(mf_ptr->me_to, "");
		return;			 	  }

	addr = (char *)fl_get_input(mf_ptr->me_to);

	if (strlen(addr) < 1)
		return;

	if (*addr != ';') {
	 if ((ma = get_address(addr, ADDR_IGNORE_COMMAS)) == NULL)   {
		fl_set_input(mf_ptr->me_to, "");
		return;				}

	 discard_address(ma->next_addr);
	 ma->next_addr = NULL;
			 }
	else	{
	 addr++;
	 if ((adr1 = find_alias(addr)) == NULL) {
		display_msg(MSG_WARN, "add", "No such alias");
		return;				}
	 ma = copy_address_chain(adr1);
		}

	switch (fl_get_choice(mf_ptr->me_to_type)) {
	  case 1:
		 if (msg->header->To == NULL)
			msg->header->To = ma;
		 else	{
			adr1 = msg->header->To;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = ma;
			}
	  break;

	  case 2:
		 if (msg->header->Cc == NULL)
			msg->header->Cc = ma;
		 else	{
			adr1 = msg->header->Cc;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = ma;
			}
	  break;

	  case 3:
		 if (msg->header->Bcc == NULL)
			msg->header->Bcc = ma;
		 else	{
			adr1 = msg->header->Bcc;
			while (adr1->next_addr != NULL)
			 adr1 = adr1->next_addr;
			adr1->next_addr = ma;
			}
	  break;

	  default:
		discard_address(ma);
	  break;
						   }

	fl_freeze_form(mf_ptr->me_form);
	display_addresses(num);
	fl_set_input(mf_ptr->me_to, "");
	fl_set_object_focus(mf_ptr->me_form, mf_ptr->me_text);
	fl_set_textedit_cursorpos(mf_ptr->me_text, 0, 0, -1);
	fl_unfreeze_form(mf_ptr->me_form);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_addr_list(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
}

void
cb_addr_list_dbl(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
int lnum, i;
struct _mail_addr *ma, *addr;

  lnum=fl_get_browser(obj);
  if ((ma = get_msgaddr_byline(num, lnum, &i)) == NULL)
	return;

  addr = copy_address(ma);
  addr->next_addr = NULL;

  if (display_msg(MSG_QUEST, NULL, "Append to address book?")) 	{
	add_book(addr, 1);
	save_book();
								}

  discard_address(addr);

  return;
}

void
cb_addr_modify(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct _mail_addr	*adr, *ma;
struct	msg_form	*mf_ptr;
struct _mail_msg	*msg;
int			type, oldtype, line;

	mf_ptr = mf_arr[num];
	msg = mf_ptr->me_msg;

	line = fl_get_browser(mf_ptr->me_to_list);

	if ((adr = get_msgaddr_byline(num, line, &oldtype)) == NULL)
		return;

	type = oldtype;
	fl_deactivate_form(mf_ptr->me_form);
	if (mod_addr(adr, &type) == -1) {
		fl_activate_form(mf_ptr->me_form);
		return;			}

	fl_activate_form(mf_ptr->me_form);
	if (type == oldtype) {
		fl_freeze_form(mf_ptr->me_form);
		display_addresses(num);
		fl_unfreeze_form(mf_ptr->me_form);
		return;	     }

	switch (oldtype) {
		case TO_TYPE:
		 if (msg->header->To == adr)
			msg->header->To = adr->next_addr;
		 else	{
			ma = msg->header->To;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
			break;
		case CC_TYPE:
		 if (msg->header->Cc == adr)
			msg->header->Cc = adr->next_addr;
		 else	{
			ma = msg->header->Cc;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
			break;
		case BCC_TYPE:
		 if (msg->header->Bcc == adr)
			msg->header->Bcc = adr->next_addr;
		 else	{
			ma = msg->header->Bcc;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
			break;
	}

	adr->next_addr = NULL;

	switch (type)	{
	 case TO_TYPE:
	  if (msg->header->To == NULL)
			msg->header->To = adr;
	   else	{
		ma = msg->header->To;
		while (ma->next_addr != NULL)
		 ma = ma->next_addr;
		ma->next_addr = adr;
		}
	 break;

	 case CC_TYPE:
	  if (msg->header->Cc == NULL)
			msg->header->Cc = adr;
	   else	{
		ma = msg->header->Cc;
		while (ma->next_addr != NULL)
		 ma = ma->next_addr;
		ma->next_addr = adr;
		}
	 break;

	 case BCC_TYPE:
	  if (msg->header->Bcc == NULL)
			msg->header->Bcc = adr;
	   else	{
		ma = msg->header->Bcc;
		while (ma->next_addr != NULL)
		 ma = ma->next_addr;
		ma->next_addr = adr;
		}
	 break;
			}

	fl_freeze_form(mf_ptr->me_form);
	display_addresses(num);
	fl_select_browser_line(mf_ptr->me_to_list, 1);
	fl_unfreeze_form(mf_ptr->me_form);
	mf_ptr->me_flags |= MF_CHANGED;
	return;
}

void
cb_addr_del(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*adr, *ma;
int			line, type;

	mf_ptr = mf_arr[num];
	msg = mf_ptr->me_msg;
	line = fl_get_browser(mf_ptr->me_to_list);
	if ((adr = get_msgaddr_byline(num, line, &type)) == NULL)
		return;

	switch (type) {
		case TO_TYPE:
		 if (msg->header->To == adr)
			msg->header->To = adr->next_addr;
		 else	{
			ma = msg->header->To;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
		 adr->next_addr = NULL;
		 discard_address(adr);
			break;
		case CC_TYPE:
		 if (msg->header->Cc == adr)
			msg->header->Cc = adr->next_addr;
		 else	{
			ma = msg->header->Cc;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
		 adr->next_addr = NULL;
		 discard_address(adr);
			break;
		case BCC_TYPE:
		 if (msg->header->Bcc == adr)
			msg->header->Bcc = adr->next_addr;
		 else	{
			ma = msg->header->Bcc;
			while (ma->next_addr != adr)
				ma = ma->next_addr;
			ma->next_addr = adr->next_addr;
			}
		 adr->next_addr = NULL;
		 discard_address(adr);
			break;
	}

	fl_freeze_form(mf_ptr->me_form);
	display_addresses(num);
	fl_select_browser_line(mf_ptr->me_to_list, 1);
	fl_unfreeze_form(mf_ptr->me_form);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_msg_help(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
	switch (n) {
		case 1:
			if (mf->me_flags & MF_VIEW)
			  help("%Viewmsg");
			else
			  help("%Editmsg");
		break;
		   }
}

void
cb_feelings_menu(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
char *feeling;

  feeling = NULL;

  switch (fl_get_menu(obj)) {
   case 1:
	feeling = ":-)";
   break;

   case 2:
	feeling = ":-(";
   break;

   case 3:
	feeling = ";-)";
   break;
			    }


 if (feeling)
	fl_insert_textedit(mf_arr[num]->me_text, feeling);
}

void
cb_msg_edit(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
struct msg_form		*mf;
int			n;
u_long 	offt;
const char *fname;
FILE *afd;
struct stat sb;
char *tfile;

	mf = mf_arr[obj->u_ldata];

	n = num < 0 ? abs(num) : fl_get_menu(obj);
	num = obj->u_ldata;

	if (!mf)
		return;

	if (!mf->me_msg)
		return;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	mf->me_flags |= MF_CHANGED;

	switch (n) {
		case 1: 	/* Insert file */
			fl_set_fselector_title("Choose file to insert");
			if (!(fname = fl_show_file_selector("Insert file","","","")))
				break;

			tfile = form_to_msg(num, 0);
			fl_get_textedit_cursorpos(mf->me_text, NULL, NULL, &offt);
			add_file_to_msg(tfile, (char *)fname, offt);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 2: 	/* Uuencode file */
			if (mf->me_msg->mime) 	{
			 if ((mf->me_msg->mime->encoding->c_trans_enc == CE_QPRT) ||
				(mf->me_msg->mime->encoding->c_trans_enc == CE_BASE64))	
				display_msg(MSG_WARN, "uuencode", "uuencoding is not recommended with BASE64\nor quoted-printable message encoding\nsome e-mail clients may have problems with decoding of this message");
						}
			fl_set_fselector_title("Choose file to uuencode");
			if (!(fname = fl_show_file_selector("Uuencode file","","","")))
				break;

			tfile = form_to_msg(num, 0);
			uuencode(tfile, (char *)fname);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 3:		/* Save to file */
			fl_set_fselector_title("Choose file to save");
			if (!(fname = fl_show_file_selector("Save as","","","")))
				break;

			compose_msg_text(mf, 1);

                        if (stat(mf->me_msg->get_file(mf->me_msg), &sb) == -1) {
                                display_msg(MSG_WARN, "stat", "Failed to stat %s", mf->me_msg->get_file(mf->me_msg));
                                break; }

                        if (fastcopy(mf->me_msg->get_file(mf->me_msg), (char *)fname, &sb) == 1)
                                display_msg(MSG_WARN, "copy", "Failed to copy");
		break;

		case 4:		/* Append to file */
			fl_set_fselector_title("Choose file to append");
			if (!(fname = fl_show_file_selector("Append to","","","")))
				break;

			compose_msg_text(mf, 1);

                        if (!(afd = fopen(fname, "a"))) {
                                display_msg(MSG_WARN, "add", "Can not open %s", fname);
                                break; }

                        print_message(mf->me_msg, afd, 0);
                        fclose(afd);
		break;

		case 5:		/* Sign Message */
			tfile = form_to_msg(num, 0);
			add_signature_to_msg(mf->me_msg, tfile); 
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 6:		/* Quote original */
			if ((mf->me_msg->data != MSG_DAT_ORIG) ||
				(mf->me_msg->pdata == NULL)) {
				display_msg(MSG_WARN, "Insert original", "Nothing to insert");
				break;
						}

			tfile = form_to_msg(num, 0);
			fl_get_textedit_cursorpos(mf->me_text, NULL, NULL, &offt);
	  		insert_orig(tfile, (struct _mail_msg *)mf->me_msg->pdata, 0, offt);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 7:		/* run external spellchecker */
			cb_spell_button(NULL, num);
		break;

		default:
		break;
		   }

	fl_activate_form(mf->me_form);
	set_cursor(mf->me_form, 0);

}

void
set_menu_chset(menu, charset)
	int	menu;
	struct _mime_charset *charset;
{
int k = 0, line = 0;

  while (supp_charsets[k].charset_code != CHAR_UNKNOWN)  {
        if (is_charset_alias(supp_charsets[k].charset_name)) {
                k++;
                continue;				     }
	line++;
	if (supp_charsets[k].charset_code == charset->charset_code) {
		fl_setpup_selection(menu, line);
		return;						    }

	k++;						 }
}

void
set_msg_chset(charset, num)
struct _mime_charset *charset;
int num;
{
struct msg_form *mf;
struct _mime_msg *mime;
char buf[255];

  mf = mf_arr[num];

  fl_set_textedit_fontstyle(mf->me_text, charset->font_style);
  fl_set_textedit_fontsize(mf->me_text, charset->font_size);

  fl_set_browser_fontsize(mf->me_mime, charset->font_size);
  fl_set_browser_fontstyle(mf->me_mime, charset->font_style);

  fl_set_object_lsize(mf->me_subj, charset->font_size);
  fl_set_object_lstyle(mf->me_subj, charset->font_style);

  fl_set_object_lsize(mf->me_from, charset->font_size);
  fl_set_object_lstyle(mf->me_from, charset->font_style);

  fl_set_object_lsize(mf->me_sender, charset->font_size);
  fl_set_object_lstyle(mf->me_sender, charset->font_style);

  if (!(mf->me_flags & MF_VIEW))	{
	  mime = get_text_part(mf->me_msg);
	  if (mime)	{
		mime->charset = charset;
		sprintf(buf, "%s/%s; charset=%s", mime->mailcap->type_text, mime->mailcap->subtype_text, charset->charset_name);
		replace_mime_field(mime, MIME_C_TYPE, buf);
			}
	  mf->me_flags |= MF_CHANGED;
					}
}

void
cb_lang_menu(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
int i, k, line;
struct _mime_charset *chset;

 if ((i = fl_get_menu(obj)) == 0)
	return;

  k = 0;
  line = 0;
  chset = NULL;
  while (supp_charsets[k].charset_code != CHAR_UNKNOWN)  {
        if (is_charset_alias(supp_charsets[k].charset_name)) {
                k++;
                continue;				     }
	line++;
	if (line == i)	{
		chset = &supp_charsets[k];
		break;	}
	k++;						 }

  if (!chset)
	return;

  set_msg_chset(chset, num);

  return;
}


void
cb_pgp_menu(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form *mf;
int n;

	mf = mf_arr[num];
	n = fl_get_menu(obj);
	if (!mf || !mf->me_msg)
		return;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	mf->me_flags |= MF_CHANGED;

	switch (n) {
		case 1: 	/* PGP sign message */
			cb_pgp_sign_button(NULL,num);
		break;

		case 2: 	/* PGP encode message */
			cb_pgp_encode_button(NULL,num);
		break;

		case 3:		/* PGP sign and encode message */
			cb_pgp_signencode_button(NULL,num);
		break;

		case 4:		/* PGP add key */
			cb_pgp_addkey_button(NULL,num);
		break;

		case 5:		/* PGP decode message */
			cb_pgp_decode_button(NULL,num);
		break;

		case 6:		/* PGP verify signature */
			cb_pgp_verify_button(NULL,num);
		break;

		case 7:		/* PGP extract key */
			cb_pgp_extkey_button(NULL,num);
		break;

		default:
		break;
		   }

	fl_activate_form(mf->me_form);
	set_cursor(mf->me_form, 0);
}

void
cb_mime_list(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form	*mf;
XEvent *xev;
int apup;

	xev = (XEvent *)fl_last_event();
	mf = mf_arr[num];

	if ((xev->type == ButtonPress) || (xev->type == ButtonRelease)) {
	if ((mf->me_flags & MF_VIEW) && (xev->xbutton.state & Button3Mask)) {
	 apup = fl_defpup(mf->me_form->window, "Attachment%t|Save|View|Print");
	 menuind = fl_dopup(apup);
	 cb_mime(NULL, num);
	 fl_freepup(apup);
									    }
									}
}

struct _mime_msg *
mime_selected(num)
int num;
{
struct _mime_msg *mime;
struct msg_form	*mf;
int n;

	mf = mf_arr[num];
	n = fl_get_browser(mf->me_mime);
	if (n == 0)
		return NULL;

	mime = mf->me_msg->mime;
	while (n && mime) {
	  if (!(mime->flags == ATTACHMENT)) {
	  	mime = mime->mime_next;
		continue;		    }
	  n--;
	  if (!n)
		break;

	  mime = mime->mime_next;
			  }

	return mime;
}

void
cb_mime_list_dbl(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct _mime_msg *mime;
struct _mail_msg *msg;
struct msg_form	*mf;

	mf = mf_arr[num];
	msg = mf->me_msg;
	mime = mime_selected(num);

	if (!(mf->me_flags & MF_VIEW) || !mime)
		return;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	view_part(msg, mime);
	set_cursor(mf->me_form, 0);
	fl_activate_form(mf->me_form);

	return;
}

void
cb_mime(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
struct _mime_msg *mime, *mime1;
struct _mail_msg *msg;
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];
	msg = mf->me_msg;
	mime = mime_selected(num);

	if (obj == NULL)
		n = menuind;
	else
		n = fl_get_menu(obj);

	if (!mime && (n != 4))
		return;

	switch (n) 	{
	  case 1:	/* Save attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		save_part(msg, mime, NULL, 0);
		set_cursor(mf->me_form, 0);
		fl_activate_form(mf->me_form);
	  break;

	  case 2:	/* View attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		view_part(msg, mime);
		set_cursor(mf->me_form, 0);
		fl_activate_form(mf->me_form);
	  break;

	  case 3:	/* Print attachment */
		set_cursor(mf->me_form, XC_watch);
		if (mime->mailcap->print)
		   (*mime->mailcap->print)(msg, mime);
		else
		   display_msg(MSG_WARN, "Don't know how to print", "%s/%s", mime->mailcap->type_text, mime->mailcap->subtype_text);
		set_cursor(mf->me_form, 0);
	  break;

	  case 4:	/* Add attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		mime1 = compose_attachment(NULL);
		if (mime1 != NULL) {
		 form_to_msg(num, 0);
		 fl_check_only_forms();
		 mime1->mime_next = msg->mime;
		 msg->mime = mime1;
		 if (update_mime(msg) == -1)
			display_msg(MSG_WARN, "MIME", "Mime update failed");

		 update_msg(num);
				}
		set_cursor(mf->me_form, 0);
		mf->me_flags |= MF_CHANGED;
		fl_activate_form(mf->me_form);
	  break;

	  case 5:	/* Delete attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		form_to_msg(num, 0);
		mime->flags &= ~ATTACHMENT;
		update_mime(msg);
		update_msg(num);
		set_cursor(mf->me_form, 0);
		mf->me_flags |= MF_CHANGED;
		fl_activate_form(mf->me_form);
	  break;

	  case 6:	/* Edit attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		mime1 = compose_attachment(mime);
		if (mime1 != NULL)	{
		 form_to_msg(num, 0);
		 fl_check_only_forms();
		 if (update_mime(msg) == -1)
			display_msg(MSG_WARN, "MIME", "Mime update failed");

		 update_msg(num);
					}

		set_cursor(mf->me_form, 0);
		mf->me_flags |= MF_CHANGED;
		fl_activate_form(mf->me_form);
	  break;

	  default:
	  break;

			}
}

void
cb_msg_message(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;
FILE *afd;
struct stat sb;
const char *fname;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
	switch (n) {
		case 1: /* Reply to sender */
			fl_deactivate_form(mf->me_form);
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_reply_msg(mf->me_msg, 0));
			redraw_fld(outbox);
			redraw_fld_line(mf->me_msg->folder);
		break;

		case 2: /* Reply to all */
			fl_deactivate_form(mf->me_form);
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_reply_msg(mf->me_msg, 1));
			redraw_fld(outbox);
			redraw_fld_line(mf->me_msg->folder);
		break;

		case 3: /* Forward */
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_fwd_msg(mf->me_msg));
			redraw_fld(outbox);
        		set_cursor(mf->me_form, 0); 
		break;

		case 4: 
			mf->me_msg->flags &= ~LOCKED;
			fl_deactivate_form(mf->me_form);
			mf->me_msg = move_message(mf->me_msg, NULL);
			fl_activate_form(mf->me_form);
			if (mf->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
				update_msg(num);
			else
				end_msg(num);
		break;

		case 5:
			cb_mbutton_delete(NULL, num);
		break;

		case 6: /* Show header */
			if (mf->me_flags & MF_HEADER) {
				mf->me_flags &= ~MF_HEADER;
				fl_set_menu_item_mode(obj, 6, FL_PUP_BOX);
			} else {
				mf->me_flags |= MF_HEADER;
				fl_set_menu_item_mode(obj, 6, FL_PUP_CHECK);
			}
			fl_freeze_form(mf->me_form);
			display_msg_text(mf);
			fl_unfreeze_form(mf->me_form);
			break;
		case 7: /* Save from field */
			add_book(mf->me_msg->header->From, 1);
			save_book();
			break;

		case 8: /* Save to file */
			if (!mf->me_msg)
				break;

			fl_set_fselector_title("Choose file to save as");
			if (!(fname = fl_show_file_selector("Save as","","","")))
                                break;

                        if (stat(mf->me_msg->get_file(mf->me_msg), &sb) == -1) {
                                display_msg(MSG_WARN, "stat", "Failed to stat %s", mf->me_msg->get_file(mf->me_msg));
                                break; }

                        if (fastcopy(mf->me_msg->get_file(mf->me_msg), (char *)fname, &sb) == 1)
                                display_msg(MSG_WARN, "copy", "Failed to copy");

				break;

		case 9: /* Append to file */
			if (!mf->me_msg)
				break;

			fl_set_fselector_title("Choose file to append");
			if (!(fname = fl_show_file_selector("Append to","","","")))
                                break;

                        if (!(afd = fopen(fname, "a"))) {
                                display_msg(MSG_WARN, "add", "Can not open %s", fname);
                                break; }

                        print_message(mf->me_msg, afd, 0);
                        fclose(afd);

			break;

		case 10: /* Uudecode */
			if (!mf->me_msg)
				break;

			uudecode(mf->me_msg);
			break;

		case 11: /* Save all addresses */
			add_msg_addr(mf->me_msg);
			save_book();
			break;

		case 12: /* Print */
        		set_cursor(mf->me_form, XC_watch); 
			lpr_message(mf->me_msg);
			set_cursor(mf->me_form, 0);
			break;

		default:
			break;
	}
}


void
cb_msg_file_view(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
        switch(n) {
		case 1:
			end_msg(num);
	}
}

void
cb_msg_file_edit(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
struct _mail_msg	*msg;
char			*tfile;
int			n, qu, oldoffline;

	mf = mf_arr[num];
	if (mf == NULL)
		return;

	if (mf->me_flags & MF_LOCKED)
		return;

	msg = mf->me_msg;
	if (msg == NULL)
		return;

	qu = 0;
	oldoffline = 0;

	n = fl_get_menu(obj);
        switch(n) {
		case 2:	/* Queue */
			qu = 1;
		case 1: /* Send */
			if (msg->header->To == NULL) {
				display_msg(MSG_WARN, "send", "Please specify at least one recipient");
				break;		     }

			if (!(msg->flags & SIGNED) &&
				(b_getcfg_int(conf_name, "sattach", 2) == 3)) {
			  tfile = form_to_msg(num, 0);
			  add_signature_to_msg(mf->me_msg, tfile); 
			  if (!(msg->flags & PGP_SIGNED) &&
				b_getcfg_int(conf_name, "pgpsign", 0))	       {
				pgp_sign_file(mf->me_msg, tfile);
	  			fl_textedit_readonly(mf_arr[num]->me_text, 1); }
			  update_mime(mf->me_msg);
									      }
			else
			if (!(msg->flags & PGP_SIGNED) &&
				b_getcfg_int(conf_name, "pgpsign", 0)) 	{
			  tfile = form_to_msg(num, 0);
			  pgp_sign_file(mf->me_msg, tfile);
	  		  fl_textedit_readonly(mf_arr[num]->me_text, 1);
			  update_mime(msg);
						   		   	}
			else
			  form_to_msg(num, 1);

			msg->flags &= ~LOCKED;
			msg->flags &= ~MSGNEW;
			msg->flags &= ~M_SFAILED;
			release_orig(num);
		 	set_cursor(mf->me_form, XC_watch);
			my_deactivate();
			if (qu)	{
				oldoffline = offline;
				offline = 1;
				}

			if (send_message(msg) == -1) {
		 		set_cursor(mf->me_form, 0);
				display_msg(MSG_WARN, "send", "Failed to send");
				msg->flags |= LOCKED;
				update_msg(num);
				my_activate();
				if (qu)
					offline = oldoffline;
				break; }

			if (qu)
				offline = oldoffline;

			my_activate();

			redraw_fld(outbox);
			redraw_fld(sentm);
		 	set_cursor(mf->me_form, 0);

			mf_arr[num]->me_msg = NULL;	
       			end_msg(num);

			break;

		case 3: /* Exit */
			cb_mbutton_exit_edit(NULL, num);
			break;
	}
}

void
cb_attach_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mime_msg *mime;
struct _mail_msg *msg;
struct msg_form  *mf;

	mf = mf_arr[num];
	msg = mf->me_msg;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	mime = compose_attachment(NULL);
	if (mime != NULL) {
	 form_to_msg(num, 0);
	 fl_check_only_forms();
	 mime->mime_next = msg->mime;
	 msg->mime = mime;
	 if (update_mime(msg) == -1)
		display_msg(MSG_WARN, "MIME", "Mime update failed");

	 update_msg(num);
			}
	set_cursor(mf->me_form, 0);
	mf->me_flags |= MF_CHANGED;
	fl_activate_form(mf->me_form);

	return;
}

void
cb_spell_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;
struct _proc_info pinfo;
char command[255];
char *e;
int i;
int added = 0;

 tfile = form_to_msg(num, 0);
 if (!tfile)
	return;

 e = b_getcfg_str(conf_name, "extspell", "/usr/bin/X11/xterm -e /usr/local/bin/ispell");
 command[0] = '\0';
 for (i = 0; i < strlen(e); i++) {
  if ((e[i] == '$') && (e[i] == 'f')) {
	added = 1;
	strcat(command, tfile); }
  else 	{
	command[strlen(command) + 1] = '\0';
	command[strlen(command)] = e[i];
	}
				}

 if (!added) {
	strcat(command, " ");
	strcat(command, tfile);
	added = 1;
		}

 init_pinfo(&pinfo);
 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(tfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_edit_exit;

 fl_deactivate_form(mf_arr[num]->me_form);
 mf_arr[num]->me_flags |= MF_CHANGED;
 if (exec_child(command, &pinfo) == -1)
	ext_edit_exit(&pinfo);

 return;
}

void
cb_mbutton_insorig(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;
u_long offt;

	if ((mf_arr[num]->me_msg->data != MSG_DAT_ORIG) ||
		(mf_arr[num]->me_msg->pdata == NULL)) {
		display_msg(MSG_WARN, "Insert original", "Nothing to insert");
		return;
						}

	tfile = form_to_msg(num, 0);
	fl_get_textedit_cursorpos(mf_arr[num]->me_text, NULL, NULL, &offt);
	if (fl_get_button_numb(obj) == 3)
	  insert_orig(tfile, (struct _mail_msg *)mf_arr[num]->me_msg->pdata, 1, offt);
	else
	  insert_orig(tfile, (struct _mail_msg *)mf_arr[num]->me_msg->pdata, 0, offt);
	update_mime(mf_arr[num]->me_msg);
	update_msg(num);
	mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_view(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  if (fl_get_button_numb(obj) == 3)
	ext_view_msg(num, 1);
  else
	ext_view_msg(num, 0);
}

void
cb_mbutton_print(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	if (!mf_arr[num])
		return;

        set_cursor(mf_arr[num]->me_form, XC_watch); 
        lpr_message(mf_arr[num]->me_msg);
        set_cursor(mf_arr[num]->me_form, 0);
}

void
cb_mbutton_edit(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	ext_edit_msg(num);
}

int
pgp_sign_file(struct _mail_msg *msg, char *mfile)
{
char *passphrase;

  passphrase=input_passphrase();

  if (pgp_action(mfile,SIGN,passphrase,"") != 0) {
   if (passphrase)
	free(passphrase);
   return -1;					 }
  if (passphrase)
	free(passphrase);

  msg->flags |= PGP_SIGNED;
  return 0;
}

void
pgp_message(long num, int mode)
{
  struct msg_form *mf;
  char *mfile, *action, *passphrase=NULL;
  char buf[255], recp[1024];
  struct _mail_msg *msg;
  struct _mime_msg *mime;
  struct _mail_addr *ptr;
  struct _proc_info pinfo;
  FILE *mfd, *pfd;
   
  mf = mf_arr[num];
  msg = mf->me_msg;

  if (!mf)
	return;

  if ((mode & SIGN) && (msg->flags & PGP_SIGNED)) {
	display_msg(MSG_WARN, "PGP", "Already signed");
	return;					  }

  if ((mode & ENCODE) && (msg->flags & PGP_ENCRYPTED)) {
	display_msg(MSG_WARN, "PGP", "Already encrypted");
	return;					  }

  if (mode & ADDKEY) {
   if (mf->me_flags & MF_VIEW)
	return;
   action = (char *)fl_show_input("Include key", user_n);
   if (!action || !*action)
	return;
   strcpy(recp, action);
   mfile = strdup(get_temp_file("pgptmp"));
   goto startpgp;
		     }

  if (mf->me_flags & MF_VIEW) 	{
   if (!(mode & DECODE) && !(mode & VERIFY) && !(mode & EXTKEY))
	return;
   mfile = get_temp_file("pgptmp");
   if (save_part(msg, get_text_part(msg), mfile, 0) == -1)
	return;
				}
  else	{
   if ((mime = get_text_part(msg)) == NULL) {
	if (!(mode & DECODE) && !(mode & VERIFY))
		return;

	if ((mime = mime_selected(num)) == NULL)
	 return;

	if (mime->mailcap != &mailcap[PGP_MAILCAP])
	 return;

	mime->mailcap = &mailcap[DEFAULT_MAILCAP];
	sprintf(buf, "%s/%s; charset=%s", mailcap[DEFAULT_MAILCAP].type_text, mailcap[DEFAULT_MAILCAP].subtype_text, supp_charsets[def_charset].charset_name);
	replace_mime_field(mime, MIME_C_TYPE, buf);

	mfile = get_temp_file("pgptmp");
	if (save_part(msg, mime, mfile, 0) == -1)
		return;
	mime->src_info = strdup(mfile);
	mime->flags |= FILE_TEMP;
					    }
   else
   if ((mfile = form_to_msg(num, 0)) == NULL)
	return;
	}

  *recp='\0';

  ptr = msg->header->To;
  while (ptr) 	{
   if ((strlen(ptr->addr) + strlen(recp) + 1) >= sizeof(recp))
	break;
   strcat(recp,ptr->addr);
   if (ptr->next_addr)
	strcat(recp," ");
   ptr=ptr->next_addr;
		}

  ptr = msg->header->Cc;
  while (ptr) 	{
   if ((strlen(ptr->addr) + strlen(recp) + 1) >= sizeof(recp))
	break;
   strcat(recp,ptr->addr);
   if (ptr->next_addr)
	strcat(recp," ");
   ptr=ptr->next_addr;
		}

  if(!*recp && (mode&ENCODE)) {
    display_msg(MSG_WARN, "PGP encode", "Please specify recipient first");
    update_mime(msg);
    update_msg(num);
    unlink(mfile);
    return;
  }

startpgp:
  mfile = strdup(mfile);

  if(mode&(DECODE|SIGN))
    passphrase=input_passphrase();

  if (pgp_action(mfile,mode,passphrase,recp) != 0) {
   if (passphrase)
	free(passphrase);
   update_mime(msg);
   update_msg(num);
   unlink(mfile);
   free(mfile);
   return;					   }

  if (mode & SIGN) {
	msg->flags |= PGP_SIGNED;
	fl_textedit_readonly(mf->me_text, 1);
		   }

  if (mode & ENCODE)
	msg->flags |= PGP_ENCRYPTED;

  if ((mode & DECODE) && !(mf->me_flags & MF_VIEW)) {
	msg->flags &= ~PGP_ENCRYPTED;
	msg->flags &= ~PGP_SIGNED;
	fl_textedit_readonly(mf->me_text, 0);	    }

  if ((mode & VERIFY) && !(mf->me_flags & MF_VIEW)) {
	msg->flags &= ~PGP_SIGNED;
	fl_textedit_readonly(mf->me_text, 0);	    }

  if (passphrase)
	free(passphrase);

  if (mf->me_flags & MF_VIEW) 	{
   if (!(mode & DECODE)) {
	unlink(mfile);
	free(mfile);
	return;	         }

   init_pinfo(&pinfo);
   pinfo.wait = WAIT_ASYNC;
   pinfo.u_data = mfile;
   pinfo.ul_data = num;
   pinfo.handle = ext_view_exit;

   fl_deactivate_form(mf->me_form);
   mf->me_flags |= MF_LOCKED;
   if (file_view(mfile, &pinfo) == -1)
	ext_view_exit(&pinfo);
				}
  else	{
   if (((mode & ENCODE) || (mode & SIGN)) &&
	b_getcfg_int(conf_name, "pgpmime", 0))  {
	if ((mode & ENCODE) && (mode & SIGN))			{
		action = "encryptsign";
		strcpy(buf, "encrypted and signed PGP message");}
	else
	if (mode & ENCODE)					{
		action = "encrypt";
		strcpy(buf, "encrypted PGP message");		}
	else							{
		action = "sign";
		strcpy(buf, "signed PGP message");		}

	replace_mime_field(mime, MIME_C_DESCR, buf);
	if (mime->c_descr)
		free(mime->c_descr);
	mime->c_descr = strdup(buf);

	sprintf(buf, "%s/%s; format=text; x-action=%s", mailcap[PGP_MAILCAP].type_text, mailcap[PGP_MAILCAP].subtype_text, action);
	replace_mime_field(mime, MIME_C_TYPE, buf);
	mime->mailcap = &mailcap[PGP_MAILCAP];
	mime->encoding = &supp_encodings[DEFAULT_ENCODING];
	replace_mime_field(mime, MIME_C_ENCR, mime->encoding->encoding_name);
	mime->flags |= ATTACHMENT;
	mime->flags &= ~TEXT_PART;
						}

   if (mode & ADDKEY) 	{
	if (b_getcfg_int(conf_name, "pgpmime", 0))  {
	 mime = create_mime();

	 sprintf(buf, "public PGP key of '%s'", recp);
	 replace_mime_field(mime, MIME_C_DESCR, buf);
	 if (mime->c_descr)
		free(mime->c_descr);
	 mime->c_descr = strdup(buf);

	 sprintf(buf, "%s/%s; format=keys-only", mailcap[PGP_MAILCAP].type_text, mailcap[PGP_MAILCAP].subtype_text);
	 replace_mime_field(mime, MIME_C_TYPE, buf);
	 mime->mailcap = &mailcap[PGP_MAILCAP];
	 mime->encoding = &supp_encodings[DEFAULT_ENCODING];
	 replace_mime_field(mime, MIME_C_ENCR, mime->encoding->encoding_name);
	 mime->flags |= ATTACHMENT;
	 mime->flags &= ~TEXT_PART;
	 mime->src_info = strdup(mfile);
	 mime->mime_next = msg->mime;
	 msg->mime = mime;
						    }
	else	{
	 if ((action = form_to_msg(num, 0)) == NULL)	{
		unlink(mfile);
		free(mfile);
		return;					}

	 if ((mfd = fopen(action, "a")) == NULL) {
		display_msg(MSG_WARN, "Add Key", "Can not append to %s",action);
		unlink(mfile);
		free(mfile);
		return;				 }

	 fputc('\n', mfd);
	 if ((pfd = fopen(mfile, "r")) == NULL) {
		display_msg(MSG_WARN, "Add Key", "Can not open to %s",mfile);
		unlink(mfile);
		free(mfile);
		return;				 }

	 while (fgets(buf, 255, pfd))
		fputs(buf, mfd);
	 fclose(mfd);
	 fclose(pfd);
		}
			}

   update_mime(msg);
   update_msg(num);
   mf->me_flags |= MF_CHANGED;
   unlink(mfile);
   free(mfile);
	}
}

void
cb_pgp_sign_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,SIGN);
}

void
cb_pgp_encode_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,ENCODE);
}

void
cb_pgp_signencode_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,ENCODE|SIGN);
}

void
cb_pgp_decode_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,DECODE);
}

void
cb_pgp_verify_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,VERIFY);
}

void
cb_pgp_extkey_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,EXTKEY);
}

void
cb_pgp_addkey_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  pgp_message(num,ADDKEY);
}

void
cb_mbutton_sign(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;

 tfile = form_to_msg(num, 0);
 if (fl_get_button_numb(obj) == 3)
	signform = mf_arr[num]->me_form;
 else
	signform = NULL;
 add_signature_to_msg(mf_arr[num]->me_msg, tfile); 
 signform = NULL;
 update_mime(mf_arr[num]->me_msg);
 update_msg(num);
 mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_insert(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
const char *fname;
char *tfile;
u_long offt;

 fl_set_fselector_title("Choose file to insert");
 if (!(fname = fl_show_file_selector("Insert file","","","")))
	return;

 tfile = form_to_msg(num, 0);
 fl_get_textedit_cursorpos(mf_arr[num]->me_text, NULL, NULL, &offt);
 add_file_to_msg(tfile, (char *)fname, offt);
 update_mime(mf_arr[num]->me_msg);
 update_msg(num);
 mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_reply(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	fl_deactivate_form(mf_arr[num]->me_form);
       	set_cursor(mf_arr[num]->me_form, XC_watch); 
	if (fl_get_button_numb(obj) == 3)
	 edit_msg(get_reply_msg(mf_arr[num]->me_msg, 0));
	else
	 edit_msg(get_reply_msg(mf_arr[num]->me_msg, 1));
	redraw_fld(outbox);
}

void
cb_mbutton_forward(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	edit_msg(get_fwd_msg(mf_arr[num]->me_msg));
	redraw_fld(outbox);
}

void
cb_mbutton_move(obj, num)
        FL_OBJECT               *obj;
        long                    num;
{
struct _mail_msg *msg;
struct _mail_folder *fld;

	if (mf_arr[num]->me_flags & MF_LOCKED)
		return;

	if (fl_get_button_numb(obj) == 3) {
		if ((fld = pup_choose_folder(mf_arr[num]->me_form)) == NULL)
			return;
					  }
	else
		fld = NULL;

	mf_arr[num]->me_msg->flags &= ~LOCKED;

	fl_deactivate_form(mf_arr[num]->me_form);
	msg = move_message(mf_arr[num]->me_msg, fld);
	fl_activate_form(mf_arr[num]->me_form);

	if (msg)
		msg->flags |= LOCKED;

	if (msg == mf_arr[num]->me_msg)
		return;

	mf_arr[num]->me_msg = msg;

	if (mf_arr[num]->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
		update_msg(num); 
	else 
		end_msg(num);

	return;
}


void
cb_mbutton_delete(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	if (mf_arr[num]->me_flags & MF_LOCKED)
		return;

	mf_arr[num]->me_msg->flags &= ~LOCKED;
	if (mf_arr[num]->me_msg->flags & M_TEMP) {
		trash->move(mf_arr[num]->me_msg, trash);
		mf_arr[num]->me_msg = NULL;
		redraw_fld(trash);
						}
	else
		mf_arr[num]->me_msg = delete_msg(mf_arr[num]->me_msg);

	if (mf_arr[num]->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
		update_msg(num);
	else
		end_msg(num);
}

void
cb_mbutton_np(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mail_msg	*msg;
int mnum = obj->u_ldata;

	if (!mf_arr[mnum])
		return;
	
	msg = mf_arr[mnum]->me_msg;
	if (!msg)
		return;

	if (mf_arr[mnum]->me_flags & MF_LOCKED)
		return;

	fl_set_object_callback(obj,NULL,num);

	switch(num) {
		case 1:
			msg = prev_msg(1, msg);
			break;
		case 2:
			msg = prev_msg(0, msg);
			break;
		case 3:
			msg = next_msg(0, msg);
			break;
		case 4:
			msg = next_msg(1, msg);
			break;
			
	}

	if (msg) {
		mf_arr[obj->u_ldata]->me_msg->flags &= ~LOCKED;
		msg->free_text(mf_arr[obj->u_ldata]->me_msg);
		mf_arr[obj->u_ldata]->me_msg->update(mf_arr[obj->u_ldata]->me_msg);
		redraw_msg(mf_arr[obj->u_ldata]->me_msg);
	
		mf_arr[obj->u_ldata]->me_msg = msg;
		update_msg(obj->u_ldata);
	}

	fl_set_object_callback(obj,cb_mbutton_np,num);
}


void
cb_mbutton_exit_view(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	fl_set_object_callback(obj,NULL,0);
       	end_msg(num);
}

void
cb_mbutton_exit_edit(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
int	res;
struct _mail_msg *msg;

	if (mf_arr[num] == NULL)
		return;

	if (mf_arr[num]->me_flags & MF_LOCKED)
		return;

	if (obj)
		fl_set_object_callback(obj,NULL,0);

	msg = mf_arr[num]->me_msg;

	if (fl_get_textedit_bufchanged(mf_arr[num]->me_text))
		mf_arr[num]->me_flags |= MF_CHANGED;

	if (!(msg->flags & MSGNEW)) {
		if ((mf_arr[num]->me_flags & MF_CHANGED) &&
			fl_show_question("Save changes?", NULL, NULL))
			form_to_msg(num, 1);

		end_msg(num);
		redraw_msg(msg);
		return;		    }

		fl_set_choices_shortcut("Yy#y", "Nn#n", "Cc#c");
		if (!(mf_arr[num]->me_flags & MF_CHANGED))
		   res = 2;
		else
		   res = fl_show_choice("Changes were made to this message.",
			       "Do you want to save as draft?","",3,
				"Yes","No","Cancel");

		if (res == 3) {
			if (obj)
			   fl_set_object_callback(obj,cb_mbutton_exit_edit,num);
			return;
		}


		msg->flags &= ~LOCKED;
		msg->flags &= ~MSGNEW;
		msg->flags &= ~M_SFAILED;

		if (res == 2) {
			msg->flags |= (DELETED|DELPERM);

        		end_msg(num);
			redraw_fld(outbox);
			return;
		}

		form_to_msg(num, 1);
		msg->flags |= MOVED;

        	end_msg(num);
		redraw_fld(outbox);
}

int
close_edit_form(form, data)
FL_FORM *form;
void *data;
{
FL_OBJECT *obj = (FL_OBJECT *)data;

 if (!form->deactivated)
	cb_mbutton_exit_edit(obj, obj->u_ldata);

 return FL_IGNORE;
}

int
close_view_form(form, data)
FL_FORM *form;
void *data;
{
FL_OBJECT *obj = (FL_OBJECT *)data;

 if (!form->deactivated)
	cb_mbutton_exit_view(obj, obj->u_ldata);

 return FL_IGNORE;
}

void
cb_mbutton_send(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mail_msg *msg;
struct _mail_folder *fld;
char *tfile;

	if (mf_arr[num] == NULL)
		return;

	if (mf_arr[num]->me_flags & MF_LOCKED)
		return;

	msg = mf_arr[num]->me_msg;
	if (msg == NULL)
		return;

	if (msg->header->To == NULL) {
		display_msg(MSG_WARN, "send", "Please specify at least one recipient");
		return;		     }

	fld = msg->folder;

	if (!(msg->flags & SIGNED) &&
		(b_getcfg_int(conf_name, "sattach", 2) == 3)) {
	  tfile = form_to_msg(num, 0);
	  add_signature_to_msg(msg, tfile); 
	  if (!(msg->flags & PGP_SIGNED) &&
			b_getcfg_int(conf_name, "pgpsign", 0)) {
		pgp_sign_file(msg, tfile);
		fl_textedit_readonly(mf_arr[num]->me_text, 1); }
	  update_mime(msg);
							      }
	else
	if (!(msg->flags & PGP_SIGNED) &&
		b_getcfg_int(conf_name, "pgpsign", 0)) 	{
	  tfile = form_to_msg(num, 0);
	  pgp_sign_file(msg, tfile);
	  fl_textedit_readonly(mf_arr[num]->me_text, 1);
	  update_mime(msg);
						   	}
	else
	  form_to_msg(num, 1);

	msg->flags &= ~LOCKED;
	msg->flags &= ~MSGNEW;

	set_cursor(mf_arr[num]->me_form, XC_watch);
	my_deactivate();
	release_orig(num);

	if (send_message(msg) == -1) {
		set_cursor(mf_arr[num]->me_form, 0);
		display_msg(MSG_WARN, "send", "Failed to send");
		msg->flags |= LOCKED;
		my_activate();
		update_msg(num);
		return; }
	my_activate();
	set_cursor(mf_arr[num]->me_form, 0);

	redraw_fld(outbox);
	redraw_fld(sentm);
	redraw_fld(fld);

	mf_arr[num]->me_msg = NULL;	
       	end_msg(num);
}

int
cb_pgupdown(FL_FORM *form, void *event)
{
XEvent *xev;
int i;

 xev = (XEvent *)event;
 if (xev->type != KeyPress)
	return 0;

 for (i=0;i<MAX_MSG_FORMS;i++) 	{
   if ((mf_arr[i] != NULL) && (mf_arr[i]->me_form == form))
	break;			}

 if (mf_arr[i] == NULL)
	return 0;

 switch (XKeycodeToKeysym(fl_display,xev->xkey.keycode, 0)) {
  case XK_Next:
	fl_scroll_textedit(mf_arr[i]->me_text, FL_TEXTEDITSCROLL_PGDOWN);
	return 1;
  break;

  case XK_Prior:
	fl_scroll_textedit(mf_arr[i]->me_text, FL_TEXTEDITSCROLL_PGUP);
	return 1;
  break;
							    }

 return 0;
}

struct msg_form *
create_msg_form(msg_f,num)
  	struct msg_form		*msg_f;
	int			num;
{
  FL_FORM   		*form;
  FL_OBJECT 		*obj;
  int menubox_bottom = 1;
  int menus_y_offset = menubox_bottom + 5;
  int buttons_y_bottom = menubox_bottom + 36;
  int box_y_bottom = buttons_y_bottom + 40;
  int box_y_height = 120;
  int browserbottom = 200;
  int browserheight = 335;
  int k, lpup;
  char chdescr[32];
  XWMHints *xwmh;

  form = fl_bgn_form(FL_NO_BOX, 805, 605);
  msg_f->me_form = form;
  
  obj = fl_add_box(FL_FLAT_BOX,0,0,805,605,"");
  obj->u_ldata = num;

  obj = fl_add_box(FL_UP_BOX,1,menubox_bottom,804,29,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,0);

  obj = fl_add_menu(FL_PULLDOWN_MENU,5,menus_y_offset,30,20,"File");
  obj->u_ldata = num;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);
    fl_set_object_resize(obj,FL_RESIZE_NONE);
    fl_set_object_gravity(obj,NorthWestGravity,0);

  if (msg_f->me_flags & MF_VIEW) {
    fl_set_menu(obj,"Exit (Alt+X)");
    fl_set_object_callback(obj,cb_msg_file_view,num);
    fl_set_menu_item_shortcut(obj, 1, "Xx#xQq#q");
  } else {
    fl_set_menu(obj,"Send (Ctrl+S)|Queue|Exit (Ctrl+X)");
    fl_set_object_callback(obj,cb_msg_file_edit,num);
    fl_set_menu_item_shortcut(obj, 1, "Ss#s");
    fl_set_menu_item_shortcut(obj, 2, "Qq#q");
    fl_set_menu_item_shortcut(obj, 3, "Xx#x");
  }

  obj = fl_add_menu(FL_PULLDOWN_MENU,755,menus_y_offset,40,20,"Help");
  obj->u_ldata = num;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT);
   fl_set_menu(obj,"Contents");
   fl_set_menu_item_shortcut(obj, 1, "Cc#c");
   fl_set_object_callback(obj,cb_msg_help,num);
   fl_set_object_resize(obj,FL_RESIZE_X);
   fl_set_object_gravity(obj,NorthGravity,EastGravity);

  obj = fl_add_menu(FL_PULLDOWN_MENU,130,menus_y_offset,80,20,"Attachment");
  obj->u_ldata = num;
  fl_set_object_boxtype(obj,FL_FLAT_BOX);
  fl_set_object_lalign(obj,FL_ALIGN_LEFT);
  fl_set_object_callback(obj,cb_mime,num);
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,0);

  if (msg_f->me_flags & MF_VIEW) {
   	fl_set_object_shortcut(obj, "#A", 1);
    	fl_set_menu(obj,"Save|View|Print");
	fl_set_menu_item_shortcut(obj, 1, "Ss#s");
	fl_set_menu_item_shortcut(obj, 2, "Vv#v");
	fl_set_menu_item_shortcut(obj, 3, "Pp#p");

	obj = fl_add_menu(FL_PULLDOWN_MENU,60,menus_y_offset,60,20,"Message");
	obj->u_ldata = num;
	    	fl_set_object_boxtype(obj,FL_FLAT_BOX);
	    	fl_set_object_lalign(obj,FL_ALIGN_LEFT);
		fl_set_object_resize(obj,FL_RESIZE_NONE);
		fl_set_object_gravity(obj,NorthWestGravity,0);
   		fl_set_object_shortcut(obj, "#G", 1);
    	fl_set_menu(obj,"Reply to Sender|Reply to All (Alt+R)|Forward (Alt+F)%l|Move to Folder (Alt+M)|Delete (Alt+D)%l|Show Header|Save From Field%l|Save to File|Append to File|Uudecode|Save All Addr|Print (Alt+P)");
	fl_set_menu_item_shortcut(obj, 1, "Tt#t");
	fl_set_menu_item_shortcut(obj, 2, "Rr#r");
	fl_set_menu_item_shortcut(obj, 3, "Ff#f");
	fl_set_menu_item_shortcut(obj, 4, "Mm#m");
	fl_set_menu_item_shortcut(obj, 5, "Dd#d");
	fl_set_menu_item_shortcut(obj, 6, "Hh#h");
	fl_set_menu_item_shortcut(obj, 7, "Ll#l");
	fl_set_menu_item_shortcut(obj, 8, "Ss#s");
	fl_set_menu_item_shortcut(obj, 9, "Aa#a");
	fl_set_menu_item_shortcut(obj,10, "Uu#u");
	fl_set_menu_item_shortcut(obj,11, "Vv#v");
	fl_set_menu_item_shortcut(obj,12, "Pp#p");

	if (b_getcfg_int(conf_name, "sheader", 0))
	  fl_set_menu_item_mode(obj, 6, FL_PUP_CHECK);
	else
	  fl_set_menu_item_mode(obj, 6, FL_PUP_BOX);

        fl_set_object_callback(obj,cb_msg_message,num);

        obj = fl_add_menu(FL_PULLDOWN_MENU,230,menus_y_offset,40,20,"PGP");
        obj->u_ldata = num;
   	  fl_set_object_shortcut(obj, "#P", 1);
          fl_set_object_boxtype(obj,FL_FLAT_BOX);
          fl_set_object_lalign(obj,FL_ALIGN_LEFT);
          fl_set_object_resize(obj,FL_RESIZE_NONE);
          fl_set_object_gravity(obj,NorthWestGravity,0);
          fl_set_menu(obj,"Decode%x5|Verify%x6|Extract key%x7");
          fl_set_object_callback(obj,cb_pgp_menu,num);

	fl_set_menu_item_shortcut(obj, 1, "Dd#d");
	fl_set_menu_item_shortcut(obj, 2, "Vv#v");
	fl_set_menu_item_shortcut(obj, 3, "Ee#e");

  } else {
    	fl_set_menu(obj,"Add (Alt+T) %x4|Delete %x5|Edit %x6");
	fl_set_menu_item_shortcut(obj, 1, "Aa#a");
	fl_set_menu_item_shortcut(obj, 2, "Dd#d");
	fl_set_menu_item_shortcut(obj, 3, "Ee#e");

  	obj = fl_add_menu(FL_PULLDOWN_MENU,60,menus_y_offset,40,20,"Edit");
  	obj->u_ldata = num;
    		fl_set_object_boxtype(obj,FL_FLAT_BOX);
    		fl_set_object_lalign(obj,FL_ALIGN_LEFT);
		fl_set_object_resize(obj,FL_RESIZE_NONE);
		fl_set_object_gravity(obj,NorthWestGravity,0);
    	fl_set_menu(obj,EDIT_MENU);
        fl_set_object_callback(obj,cb_msg_edit,num);

	fl_set_menu_item_shortcut(obj, 1, "Ii#i");
	fl_set_menu_item_shortcut(obj, 2, "Uu#u");
	fl_set_menu_item_shortcut(obj, 3, "Ss#s");
	fl_set_menu_item_shortcut(obj, 4, "Aa#a");
	fl_set_menu_item_shortcut(obj, 5, "Ss#s");
	fl_set_menu_item_shortcut(obj, 6, "Qq#q");
	fl_set_menu_item_shortcut(obj, 6, "Pp#p");
 
        obj = fl_add_menu(FL_PULLDOWN_MENU,230,menus_y_offset,40,20,"PGP");
        obj->u_ldata = num;
   	  fl_set_object_shortcut(obj, "#P", 1);
          fl_set_object_boxtype(obj,FL_FLAT_BOX);
          fl_set_object_lalign(obj,FL_ALIGN_LEFT);
          fl_set_object_resize(obj,FL_RESIZE_NONE);
          fl_set_object_gravity(obj,NorthWestGravity,0);
          fl_set_menu(obj,"Sign|Encode|Sign and Encode|Add Key|Decode|Verify");
          fl_set_object_callback(obj,cb_pgp_menu,num);

	fl_set_menu_item_shortcut(obj, 1, "Ss#s");
	fl_set_menu_item_shortcut(obj, 2, "Ee#e");
	fl_set_menu_item_shortcut(obj, 3, "Nn#n");
	fl_set_menu_item_shortcut(obj, 4, "Aa#a");
	fl_set_menu_item_shortcut(obj, 5, "Dd#d");
	fl_set_menu_item_shortcut(obj, 6, "Vv#v");

        obj = fl_add_menu(FL_PULLDOWN_MENU,370,menus_y_offset,50,20,"Feelings");
        obj->u_ldata = num;
   	  fl_set_object_shortcut(obj, "#F", 1);
          fl_set_object_boxtype(obj,FL_FLAT_BOX);
          fl_set_object_lalign(obj,FL_ALIGN_LEFT);
          fl_set_object_resize(obj,FL_RESIZE_NONE);
          fl_set_object_gravity(obj,NorthWestGravity,0);
          fl_set_menu(obj,"Happy|Sad|Wink");
          fl_set_object_callback(obj,cb_feelings_menu,num);

	fl_set_menu_item_shortcut(obj, 1, "Hh#h");
	fl_set_menu_item_shortcut(obj, 2, "Ss#s");
	fl_set_menu_item_shortcut(obj, 3, "Ww#w");
  }

  obj = fl_add_menu(FL_PULLDOWN_MENU,300,menus_y_offset,60,20,"Language");
  obj->u_ldata = num;
  fl_set_object_shortcut(obj, "#L", 1);
  fl_set_object_boxtype(obj,FL_FLAT_BOX);
  fl_set_object_lalign(obj,FL_ALIGN_LEFT);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  fl_set_object_callback(obj,cb_lang_menu,num);
  k = 0;
  lpup = fl_newpup(main_form->window);
  msg_f->me_lang = lpup;
  while (supp_charsets[k].charset_code != CHAR_UNKNOWN)  {
        if (is_charset_alias(supp_charsets[k].charset_name)) {
                k++;
                continue;				     }

        sprintf(chdescr, "%s (%s)%%r1", supp_charsets[k].charset_name, supp_charsets[k].charset_descr);
        fl_addtopup(lpup, chdescr);
        k++;
                                                        }
  fl_setpup_shadow(lpup, 0);
  fl_setpup_softedge(lpup, 0);

  fl_set_menu_popup(obj, lpup);

  obj = fl_add_box(FL_FRAME_BOX,10,box_y_bottom,785,box_y_height,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,EastGravity);

  obj = fl_add_text(FL_NORMAL_TEXT,120,box_y_bottom+4,40,20,"Date:");
  obj->u_ldata = num;
  fl_set_object_boxtype(obj,FL_FLAT_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);

  obj = fl_add_text(FL_NORMAL_TEXT,160,box_y_bottom+4,300,20,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  msg_f->me_date = obj;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  obj = fl_add_text(FL_NORMAL_TEXT,205,box_y_bottom+22,100,18,"From:");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  obj = fl_add_input(FL_NORMAL_INPUT,90,box_y_bottom+39,345,25,"");
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  obj->u_ldata = num;
  msg_f->me_from = obj;
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
  fl_set_object_callback(obj,cb_txtedit,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);

  obj = fl_add_text(FL_NORMAL_TEXT,20,box_y_bottom+68,77,18,"Subject:");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  msg_f->me_subj = obj = fl_add_input(FL_NORMAL_INPUT,90,box_y_bottom+64,345,25,"");
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_txtedit,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);

  if (msg_f->me_flags & MF_VIEW) {
	obj = fl_add_text(FL_NORMAL_TEXT,550,box_y_bottom+22,150,18,"Sender:");
	obj->u_ldata = num;
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
	fl_set_object_boxtype(obj,FL_FLAT_BOX);
	fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  	obj = fl_add_input(FL_NORMAL_INPUT,445,box_y_bottom+39,340,25,"");
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
    	fl_set_object_lalign(obj,FL_ALIGN_TOP);
  	obj->u_ldata = num;
	msg_f->me_to = obj;
	fl_set_object_callback(obj,cb_txtedit,num);
  } else {
  	obj = fl_add_choice(FL_NORMAL_CHOICE,445,box_y_bottom+40,30,23,"");
	fl_set_object_boxtype(obj,FL_UP_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
	msg_f->me_to_type = obj;

  	obj = fl_add_input(FL_NORMAL_INPUT,475,box_y_bottom+40,310,23,"");
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  	obj->u_ldata = num;
	fl_set_object_callback(obj, cb_addr_addto, num);
	fl_set_input_return(obj, FL_RETURN_END);
	msg_f->me_to = obj;

  	obj = fl_add_text(FL_NORMAL_TEXT,70,box_y_bottom+90,60,25,"Confirm:");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
	fl_set_object_boxtype(obj,FL_NO_BOX);
  	obj->u_ldata = num;

	obj = fl_add_roundbutton(FL_PUSH_BUTTON,130, box_y_bottom+90, 25, 25, "Delivery");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_conf_delivery,num);

	obj = fl_add_roundbutton(FL_PUSH_BUTTON,230, box_y_bottom+90, 25, 25, "Read");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_conf_read,num);

	obj = fl_add_checkbutton(FL_PUSH_BUTTON,330, box_y_bottom+90, 25, 25, "Urgent");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_urgent,num);
  }

  obj = fl_add_browser(FL_HOLD_BROWSER,445,box_y_bottom+65,340,50,"");
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_addr_list,num);
  fl_set_browser_dblclick_callback(obj,cb_addr_list_dbl,num);
  msg_f->me_to_list = obj;

  if (!(msg_f->me_flags & MF_VIEW)) {
  	obj = fl_add_button(FL_NORMAL_BUTTON,445,box_y_bottom+5,80,25,"Address");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_add,num);
	fl_set_button_shortcut(obj, "#A", 0);

  	obj = fl_add_button(FL_NORMAL_BUTTON,535,box_y_bottom+5,165,25,"Modify");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_modify,num);

  	obj = fl_add_button(FL_NORMAL_BUTTON,705,box_y_bottom+5,80,25,"Delete");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthGravity, EastGravity);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_del,num);
  }

  obj = fl_add_bitmap(FL_NORMAL_BITMAP,27,box_y_bottom+7,54,54,"");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  fl_set_object_color(obj,FL_WHITE, FL_WHITE);
  obj->u_ldata = num;
  msg_f->me_bitmap = obj;

  obj = fl_add_pixmap(FL_NORMAL_PIXMAP,27,box_y_bottom+7,54,54,"");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  fl_set_object_color(obj,FL_WHITE, FL_WHITE);
  obj->u_ldata = num;
  msg_f->me_pixmap = obj;

  obj = fl_add_browser(FL_HOLD_BROWSER,10,566,785,35,"");
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,SouthWestGravity,SouthEastGravity);
  fl_set_object_color(obj,b_getcfg_int(conf_name, "ViewBgCol", FL_MCOL), FL_YELLOW);
  fl_set_object_lcol(obj, b_getcfg_int(conf_name, "ViewFgCol", FL_BLACK));
  msg_f->me_mime = obj;
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_mime_list,num);
  fl_set_browser_dblclick_callback(obj,cb_mime_list_dbl,num);

  if (msg_f->me_flags &  MF_VIEW) {
  obj = fl_add_textedit(FL_NORMAL_TEXTEDIT,10,browserbottom ,785,browserheight + 30,"");
  fl_set_object_resize(obj,FL_RESIZE_ALL);
  fl_set_object_gravity(obj,NorthWestGravity,SouthEastGravity);
  fl_set_textedit_color(obj, b_getcfg_int(conf_name, "ViewBgCol", FL_MCOL), b_getcfg_int(conf_name, "ViewFgCol", FL_BLACK), FL_BLUE, 0);
  fl_set_textedit_wrap(obj, -abs(b_getcfg_int(conf_name, "viewrap", 80)), 0);
  fl_textedit_readonly(obj, 1);
  fl_set_object_callback(obj,cb_browser,num);
  msg_f->me_text = obj;
	 			} else {
  obj = fl_add_textedit(FL_NORMAL_TEXTEDIT,10,browserbottom ,785,browserheight + 30,"");
  fl_set_object_resize(obj,FL_RESIZE_ALL);
  fl_set_object_gravity(obj,NorthWestGravity,SouthEastGravity);
  fl_set_textedit_color(obj, b_getcfg_int(conf_name, "EditBgCol", FL_MCOL), b_getcfg_int(conf_name, "EditFgCol", FL_BLACK), FL_BLUE, 0);
  fl_set_textedit_wrap(obj, b_getcfg_int(conf_name, "editwrap", 80), 0);
  fl_set_object_callback(obj,cb_editor,num);
  msg_f->me_text = obj;
					}

  obj->u_ldata = num;

  if (msg_f->me_flags &  MF_VIEW) {
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,20,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  obj->u_ldata = num;
	  obj->u_vdata = "Exit viewer";
	  fl_set_pixmapbutton_data(obj,exit_xpm);
	  fl_set_object_callback(obj,cb_mbutton_exit_view,num);
	  fl_set_button_shortcut(obj, "#X", 0);
	  fl_set_object_posthandler(obj, post_handler);

	  fl_set_form_atclose(form, close_view_form, obj);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,80,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Previous unread message";
		     fl_set_pixmapbutton_data(obj,prevu_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,1);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,117,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Previous message";
		     fl_set_pixmapbutton_data(obj,prev_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,2);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,154,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Next message";
		     fl_set_pixmapbutton_data(obj,next_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,3);
		     fl_set_button_shortcut(obj, "#N", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,191,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Next unread message";
		     fl_set_pixmapbutton_data(obj,nextu_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,4);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,240,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Reply to message";
		     fl_set_pixmapbutton_data(obj,reply_xpm);
		     fl_set_object_callback(obj,cb_mbutton_reply,num);
		     fl_set_button_shortcut(obj, "#R", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,277,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Forward message";
		     fl_set_pixmapbutton_data(obj,forward_xpm);
		     fl_set_object_callback(obj,cb_mbutton_forward,num);
		     fl_set_button_shortcut(obj, "#F", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,330,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Move to another folder";
		     fl_set_pixmapbutton_data(obj,move_xpm);
		     fl_set_object_callback(obj,cb_mbutton_move,num);
		     fl_set_button_shortcut(obj, "#M", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,367,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Delete";
		     fl_set_pixmapbutton_data(obj,delete_xpm);
		     fl_set_object_callback(obj,cb_mbutton_delete,num);
		     fl_set_button_shortcut(obj, "#D", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,410,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "External viewer";
		     fl_set_pixmapbutton_data(obj,view_xpm);
		     fl_set_object_callback(obj,cb_mbutton_view,num);
		     fl_set_button_shortcut(obj, "#V", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,445,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Print";
		     fl_set_pixmapbutton_data(obj,print_xpm);
		     fl_set_object_callback(obj,cb_mbutton_print,num);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,480,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Help";
		     fl_set_pixmapbutton_data(obj,help_xpm);
		     fl_set_object_callback(obj,cb_help_button,10);
		     fl_set_button_shortcut(obj, "#H", 0);
  } else {
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,57,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Send";
		     fl_set_pixmapbutton_data(obj,send_xpm);
		     fl_set_object_callback(obj,cb_mbutton_send,num);
		     fl_set_button_shortcut(obj, "^S", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,20,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Exit editor";
		     fl_set_pixmapbutton_data(obj,exit_xpm);
		     fl_set_object_callback(obj,cb_mbutton_exit_edit,num);
		     fl_set_button_shortcut(obj, "^X", 0);

	  fl_set_form_atclose(form, close_edit_form, obj);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,120,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Insert file";
		     fl_set_pixmapbutton_data(obj,insert_xpm);
		     fl_set_object_callback(obj,cb_mbutton_insert,num);
		     fl_set_button_shortcut(obj, "#I", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,160,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Include original";
		     fl_set_pixmapbutton_data(obj,insorig_xpm);
		     fl_set_object_callback(obj,cb_mbutton_insorig,num);
		     fl_set_button_shortcut(obj, "#Q", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,200,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Add signature";
		     fl_set_pixmapbutton_data(obj,sign_xpm);
		     fl_set_object_callback(obj,cb_mbutton_sign,num);
		     fl_set_button_shortcut(obj, "#S", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,240,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "External editor";
		     fl_set_pixmapbutton_data(obj,edit_xpm);
		     fl_set_object_callback(obj,cb_mbutton_edit,num);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,280,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Spell check";
		     fl_set_pixmapbutton_data(obj,spell_xpm);
		     fl_set_object_callback(obj,cb_spell_button,num);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,320,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Attach";
		     fl_set_pixmapbutton_data(obj,attach_xpm);
		     fl_set_object_callback(obj,cb_attach_button,num);
		     fl_set_button_shortcut(obj, "#T", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,360,buttons_y_bottom,35,33,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Help";
		     fl_set_pixmapbutton_data(obj,help_xpm);
		     fl_set_object_callback(obj,cb_help_button,11);
		     fl_set_button_shortcut(obj, "#H", 0);
  }


  fl_end_form();
  fl_register_raw_callback(form, KeyPressMask, cb_pgupdown);
  fl_set_form_minsize(form, 600, 300);
  num_cascade = num % 12;
  if (b_getcfg_int(conf_name, "wplace", 1))
   fl_set_initial_placement(form, 150+20*num_cascade,100+20*num_cascade
							, mf_x, mf_y);
  else
   fl_set_form_size(form, mf_x, mf_y);

  fl_set_object_focus(form, msg_f->me_text);

  if (msg_f->me_flags &  MF_VIEW) {
	msg_f->me_to->wantkey = FL_KEY_SPECIAL;
	msg_f->me_from->wantkey = FL_KEY_SPECIAL;
	msg_f->me_subj->wantkey = FL_KEY_SPECIAL;
	fl_show_form(form,FL_PLACE_FREE,FL_FULLBORDER,"MSGView");
				  }
  else	 {
	fl_addto_choice(msg_f->me_to_type, "To");
	fl_addto_choice(msg_f->me_to_type, "Cc");
	fl_addto_choice(msg_f->me_to_type, "Bcc");
	fl_set_choice(msg_f->me_to_type, 1);
	fl_show_form(form,FL_PLACE_FREE,FL_FULLBORDER,"MSGEdit");
	}

  if ((xwmh=XAllocWMHints()) != NULL)   {
	xwmh->icon_pixmap = icon_MailEdit;
	xwmh->icon_mask = icon_MailEdit_sh;
	xwmh->flags = IconPixmapHint | IconMaskHint;
	XSetWMHints(fl_display, form->window, xwmh);
	XFree(xwmh);
					}

  return msg_f;
}


int
view_msg(msg, openwin)
struct	_mail_msg	*msg;
int openwin;
{
struct msg_form		*mf_ptr;
int			i,id;

	if (msg == NULL)
		return 4;

	if (msg->flags & LOCKED) {
	  for (i=0;i<MAX_MSG_FORMS;i++) {
		if ((mf_arr[i] != NULL) && (mf_arr[i]->me_msg == msg))
		 XMapRaised(fl_display, mf_arr[i]->me_form->window);
					}
		return 1;
				}

	if (!openwin) 	{
	 for (i = 0;i < MAX_MSG_FORMS;i++) {
		if ((mf_arr[i] != NULL) &&
			!(mf_arr[i]->me_flags & MF_LOCKED)) {
		 mf_arr[i]->me_msg->flags &= ~LOCKED;
		 msg->free_text(mf_arr[i]->me_msg);
		 mf_arr[i]->me_msg->update(mf_arr[i]->me_msg);
		 redraw_msg(mf_arr[i]->me_msg);
	
		 mf_arr[i]->me_msg = msg;
		 update_msg(i);
		 return 0;				    }
					   }
			}

	for (i = 0;i < MAX_MSG_FORMS;i++) {
		if (mf_arr[i] == NULL)
			break;	          }

	if (i == MAX_MSG_FORMS)
		return 2;
	id=i;

  	if ((mf_ptr = malloc(sizeof(struct msg_form)))==NULL) {
		display_msg(MSG_FATAL, "view", "malloc failed");
		exit(1); }

	mf_arr[id] = mf_ptr;

	mf_ptr->me_form = NULL;
	mf_ptr->me_from = mf_ptr->me_to = NULL;
	mf_ptr->me_to_list = mf_ptr->me_to_type = mf_ptr->me_subj = NULL;
	mf_ptr->me_text = mf_ptr->me_pixmap = mf_ptr->me_bitmap = NULL;
	mf_ptr->me_date = mf_ptr->me_mime = NULL;

	mf_ptr->me_flags = MF_VIEW;
	mf_ptr->tofft = 0L;
	
	mf_ptr->me_msg = msg;
	switch_ttips();
	create_msg_form(mf_ptr,id);

	if (b_getcfg_int(conf_name, "sheader", 0))
	  mf_ptr->me_flags |= MF_HEADER;

	update_msg(id);
	switch_ttips();

	return 0;
}

void
set_edit_cursor(msg, cx, cy)
struct _mail_msg *msg;
int cx, cy;
{
int i;

 if (!msg || !(msg->flags & LOCKED))
	return;

 for (i=0;i<MAX_MSG_FORMS;i++) 	{
	if ((mf_arr[i] != NULL) && (mf_arr[i]->me_msg == msg) &&
		!(mf_arr[i]->me_flags & MF_VIEW)) {
		fl_set_textedit_cursorpos(mf_arr[i]->me_text, cx, cy, -1);
		return;				  }
				}
}

int
edit_msg(msg)
	struct	_mail_msg		*msg;
{
struct msg_form		*mf_ptr;
int			i,id;

	if (msg == NULL)
		return 4;

	if (msg->flags & LOCKED) {
	  for (i=0;i<MAX_MSG_FORMS;i++) {
		if ((mf_arr[i] != NULL) && (mf_arr[i]->me_msg == msg))
		 XMapRaised(fl_display, mf_arr[i]->me_form->window);
					}
		return 1;	}

	for (i = 0;i<MAX_MSG_FORMS;i++) 
		if (mf_arr[i] == NULL)
			break;

	if (i == MAX_MSG_FORMS)
		return 2;
	id = i;

	if (msg->flags & M_IMAP)
		display_msg(MSG_WARN, "edit", "Editing changes will not be stored on the server");

  	if ((mf_ptr = malloc(sizeof(struct msg_form)))==NULL) {
		display_msg(MSG_FATAL, "edit", "malloc failed");
		exit(1); }

	mf_arr[id] = mf_ptr;

	mf_ptr->me_form = NULL;
	mf_ptr->me_from = mf_ptr->me_to = NULL;
	mf_ptr->me_to_list = mf_ptr->me_to_type = mf_ptr->me_subj = NULL;
	mf_ptr->me_text = mf_ptr->me_pixmap = mf_ptr->me_bitmap = NULL;
	mf_ptr->me_date = mf_ptr->me_mime = NULL;

        mf_ptr->me_flags = 0;
	mf_ptr->tofft = 0L;
	
	mf_ptr->me_msg = msg;
	switch_ttips();
	create_msg_form(mf_ptr,id);

	update_msg(id);
	switch_ttips();

	return 0;
}

struct _mail_addr
	*get_msgaddr_byline(id, line, type)
int id, line;
int *type;
{
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*to_p;
int i;

 mf_ptr = mf_arr[id];
 if (!mf_ptr)
	return NULL;

 msg = mf_ptr->me_msg;
 if (!msg)
	return NULL;

 i = 0;
 for (to_p = msg->header->To; to_p; to_p = to_p->next_addr) {
	i++;
	if (i == line) {
	  *type = TO_TYPE;
	  return to_p; }
							    }

 for (to_p = msg->header->Cc; to_p; to_p = to_p->next_addr) {
	i++;
	if (i == line) {
	  *type = CC_TYPE;
	  return to_p; }
							    }

 for (to_p = msg->header->Bcc; to_p; to_p = to_p->next_addr) {
	i++;
	if (i == line) {
	  *type = BCC_TYPE;
	  return to_p; }
							     }

 return NULL;
}

void
display_addresses(id)
int id;
{
static int		ftype;
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*to_p;

 mf_ptr = mf_arr[id];
 if (!mf_ptr)
	return;

 msg = mf_ptr->me_msg;
 if (!msg)
	return;

 fl_clear_browser(mf_ptr->me_to_list);

 ftype = -1;
 for (to_p = msg->header->To; to_p; to_p = to_p->next_addr)
	fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("To: ", to_p, ftype < 0 ? &ftype : NULL));

 for (to_p = msg->header->Cc; to_p; to_p = to_p->next_addr)
	fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("Cc: ", to_p, ftype < 0 ? &ftype : NULL));

 for (to_p = msg->header->Bcc; to_p; to_p = to_p->next_addr)
	fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("Bcc:", to_p, ftype < 0 ? &ftype : NULL));

 fl_select_browser_line(mf_ptr->me_to_list, 1);

 if (ftype >= 0) {
	fl_set_browser_fontstyle(mf_ptr->me_to_list, supp_charsets[ftype].font_style);
	fl_set_browser_fontsize(mf_ptr->me_to_list, supp_charsets[ftype].font_size);
	}
 else 	{
	fl_set_browser_fontstyle(mf_ptr->me_to_list, supp_charsets[def_charset].font_style);
	fl_set_browser_fontsize(mf_ptr->me_to_list, supp_charsets[def_charset].font_size);
	}

 return;
}

int
update_msg(id)
	int	id;
{
static int		ftype;
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _head_field	*hf;
char			str[255];
char			*face;

	mf_ptr = mf_arr[id];
	if (!mf_ptr)
		return -1;

	msg = mf_ptr->me_msg;
	if (!msg)
		return -1;

	fl_freeze_form(mf_ptr->me_form);

	strftime(str,40,"%c", localtime(&msg->header->snt_time));
	fl_set_object_label(mf_ptr->me_date, ((hf = find_field(msg, "Date")) || (hf = find_field(msg, "X-RDate")) ) ? hf->f_line : str);

	ftype = 0;
	face = NULL;
	if ((mf_ptr->me_flags & MF_VIEW) && b_getcfg_int(conf_name, "usefaces", 0))
	{
#ifdef	FACES
	if ((face = get_msg_face(msg)) != NULL) {
		fl_hide_object(mf_ptr->me_pixmap);
		fl_show_object(mf_ptr->me_bitmap);
		fl_set_bitmap_data(mf_ptr->me_bitmap, 48, 48, (unsigned char *)face);
						}
	else
#endif
	  if ((face = find_face(msg->header->From, &ftype)) != NULL) {
	  switch(ftype) {
		case FACE_XPM:
		fl_hide_object(mf_ptr->me_bitmap);
		fl_free_pixmap_pixmap(mf_ptr->me_pixmap);
		fl_set_pixmap_file(mf_ptr->me_pixmap, face);
		fl_show_object(mf_ptr->me_pixmap);
		break;

		case FACE_XBM:
		fl_hide_object(mf_ptr->me_pixmap);
		fl_set_bitmap_file(mf_ptr->me_bitmap, face);
		fl_show_object(mf_ptr->me_bitmap);
		break;

		default:
		break;
			}
								}	
	}

	if (!face) {
	fl_hide_object(mf_ptr->me_bitmap);
	if (mf_ptr->me_flags & MF_VIEW)
		fl_free_pixmap_pixmap(mf_ptr->me_pixmap);
	if (msg->flags & UNREAD)
		fl_set_pixmap_data(mf_ptr->me_pixmap, icon_mail_xpm);
	else
		fl_set_pixmap_data(mf_ptr->me_pixmap, icon_nomail_xpm);
	fl_show_object(mf_ptr->me_pixmap);
		}

	ftype = -1;
	fl_set_input(mf_ptr->me_from, get_charset_addr_line(NULL, msg->header->From, &ftype));
	if (ftype >= 0) {
		fl_set_object_lstyle(mf_ptr->me_from, supp_charsets[ftype].font_style);
		fl_set_object_lsize(mf_ptr->me_from, supp_charsets[ftype].font_size);
		}
	else 	{
		fl_set_object_lstyle(mf_ptr->me_from, supp_charsets[def_charset].font_style);
		fl_set_object_lsize(mf_ptr->me_from, supp_charsets[def_charset].font_size);
		}

	if (mf_ptr->me_flags & MF_VIEW) {
		if (msg->header->Sender) {
			fl_show_object(mf_ptr->me_sender);
	ftype = -1;
	fl_set_input(mf_ptr->me_sender,get_charset_addr_line(NULL, msg->header->Sender, &ftype));
	if (ftype >= 0) {
		fl_set_object_lstyle(mf_ptr->me_sender, supp_charsets[ftype].font_style);
		fl_set_object_lsize(mf_ptr->me_sender, supp_charsets[ftype].font_size);
		}
	else 	{
		fl_set_object_lstyle(mf_ptr->me_sender, supp_charsets[def_charset].font_style);
		fl_set_object_lsize(mf_ptr->me_sender, supp_charsets[def_charset].font_size);
		}
		} else
			fl_hide_object(mf_ptr->me_sender);
	}

	display_addresses(id);

	ftype = -1;
  	if (msg->header->Subject) {
		strncpy(str, rfc1522_decode(msg->header->Subject, &ftype), 64);
		str[64] = '\0';
		fl_set_input(mf_ptr->me_subj, str);
		if (ftype) {
	        fl_set_object_lsize(mf_ptr->me_subj, supp_charsets[ftype].font_size);
	        fl_set_object_lstyle(mf_ptr->me_subj, supp_charsets[ftype].font_style);
			}
	}
  	else	{
		fl_set_input(mf_ptr->me_subj, "");

		if (mf_ptr->me_flags & MF_VIEW)
	 	  strcpy(str,"*No Subject*");
		else
	 	  strcpy(str,"*New Mail*");
		}

	if (ftype == -1) {
	        fl_set_object_lsize(mf_ptr->me_subj, supp_charsets[def_charset].font_size);
	        fl_set_object_lstyle(mf_ptr->me_subj, supp_charsets[def_charset].font_style);
			}

	fl_set_input_cursorpos(mf_ptr->me_subj, 0, 0);
	fl_set_input_cursorpos(mf_ptr->me_from, 0, 0);
	fl_set_input_cursorpos(mf_ptr->me_sender, 0, 0);

	fl_set_form_title(mf_ptr->me_form, str);
	XSetIconName(fl_display,mf_ptr->me_form->window,str);

	if ( (msg->flags & UNREAD) && 
	   ( (hf = find_field(msg, XFRECEIPT)) ||
		(hf = find_field(msg, "X-Chameleon-Return-To")) )     )
	 {
	   fl_clear_textedit(mf_ptr->me_text);

	   fl_clear_browser(mf_ptr->me_mime);

	   fl_unfreeze_form(mf_ptr->me_form);
	   switch(b_getcfg_int(conf_name, "vconfirm", 1)) {
	    case 2:
		if (display_msg(MSG_QUEST, "Confirm reading", "Send confirmation to %s?", hf->f_line))	{
			fl_deactivate_all_forms();
			set_cursor(mf_ptr->me_form, XC_watch);
			read_confirm(msg);
			set_cursor(mf_ptr->me_form, 0);
			fl_activate_all_forms();
			}
	    break;

	    case 3:
	    break;

	    case 1:
	    default:
		fl_deactivate_all_forms();
		set_cursor(mf_ptr->me_form, XC_watch);
		read_confirm(msg);
		set_cursor(mf_ptr->me_form, 0);
		fl_activate_all_forms();
	    break;
							  }
	   fl_freeze_form(mf_ptr->me_form);
	 }

	if (msg->flags & UNREAD) {
	msg->flags &= ~UNREAD;
	if (msg->folder && msg->folder->unread_num) {
		msg->folder->unread_num--;
		redraw_fld_line(msg->folder);	    }
	update_title();
				  }
	display_msg_text(mf_ptr);

	msg->flags |= LOCKED;
	if (!(mf_ptr->me_flags & MF_VIEW))
		fl_textedit_readonly(mf_ptr->me_text, (msg->flags & PGP_SIGNED) ? 1 : 0);

	mf_ptr->me_text->redraw = 1;
	fl_unfreeze_form(mf_ptr->me_form);
	redraw_msg(msg);

	return 0;
}

void
release_orig(id)
int id;
{
int i, released;

	  released = 0;
	  if (mf_arr[id] && mf_arr[id]->me_msg &&
		(mf_arr[id]->me_msg->data == MSG_DAT_ORIG) &&
		mf_arr[id]->me_msg->pdata) {
	    for (i = 0;i < MAX_MSG_FORMS;i++) {
		if (mf_arr[i] && (mf_arr[i]->me_msg ==
			(struct _mail_msg *)mf_arr[id]->me_msg->pdata)) {
		set_cursor(mf_arr[i]->me_form, 0);
		fl_activate_form(mf_arr[i]->me_form);
		released = 1;
		break;
									}
					      }
	    if (!released) {
	      ((struct _mail_msg *)mf_arr[id]->me_msg->pdata)->flags &= ~LOCKED;
	      redraw_msg((struct _mail_msg *)mf_arr[id]->me_msg->pdata);
			   }

	    mf_arr[id]->me_msg->data = MSG_DAT_EMPTY;
	    mf_arr[id]->me_msg->pdata = NULL;
					   }

	return;
}

void
end_msg(id)
	int	id;
{
struct _mail_folder *fld;

	if (mf_arr[id] == NULL)
		return;
	
	if (mf_arr[id]->me_flags & MF_LOCKED)
		return;

	switch_ttips();
	tobj = NULL;
	if (mf_arr[id]->me_msg) {
	  fld = mf_arr[id]->me_msg->folder;
	  release_orig(id);
	  mf_arr[id]->me_msg->flags &= ~LOCKED;
	  mf_arr[id]->me_msg->update(mf_arr[id]->me_msg);
	  redraw_msg(mf_arr[id]->me_msg);

	  if (mf_arr[id]->me_msg->flags & M_TEMP)	    {
		mf_arr[id]->me_msg->flags &= ~M_TEMP;
		mf_arr[id]->me_msg->flags |= DELPERM;
		mf_arr[id]->me_msg->delete(mf_arr[id]->me_msg);
		mf_arr[id]->me_msg = NULL;
					    }
	  else
	  if ((mf_arr[id]->me_msg->flags & DELETED) &&
		mf_arr[id]->me_msg->folder) {
		mf_arr[id]->me_msg->flags &= ~DELETED;
		mf_arr[id]->me_msg->flags |= DELPERM;
		mf_arr[id]->me_msg->delete(mf_arr[id]->me_msg);
		mf_arr[id]->me_msg = NULL;
		redraw_fld(trash);
		redraw_fld(fld);
					    }
	  else
	  if ((mf_arr[id]->me_msg->flags & MOVED) &&
		mf_arr[id]->me_msg->folder) {
		mf_arr[id]->me_msg->flags &= ~MOVED;
		draft->move(mf_arr[id]->me_msg, draft);
		mf_arr[id]->me_msg = NULL;
		redraw_fld(draft);
		redraw_fld(fld);
					    }
				}

	destruct_msg(mf_arr[id]);
	mf_arr[id] = NULL;
	switch_ttips();
}

void
destruct_msg(mf)
	struct msg_form			*mf;
{
	mf_x = mf->me_form->w;
	mf_y = mf->me_form->h;

	fl_hide_form(mf->me_form);
	fl_free_form(mf->me_form);
	fl_freepup(mf->me_lang);
	free(mf);
}

char *
form_to_msg(num, update)
	int		num;
	int		update;
{
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
char			*adr;

	mf_ptr = mf_arr[num];
	if (mf_ptr == NULL)
		return NULL;

	msg = mf_ptr->me_msg;
	if (msg == NULL)
		return NULL;

	adr = (char *)fl_get_input(mf_ptr->me_subj);
	if (msg->header->Subject)
		free(msg->header->Subject);
	msg->header->Subject = strlen(adr) ? strdup(adr) : NULL;

	discard_address(msg->header->From);
	msg->header->From=get_address((char *)fl_get_input(mf_ptr->me_from), ADDR_IGNORE_COMMAS);
	discard_address(msg->header->From->next_addr);
	msg->header->From->next_addr = NULL;

	cb_addr_addto(mf_ptr->me_to, num);

	return compose_msg_text(mf_ptr, update);
}

void
ext_view_exit(pinfo)
struct _proc_info *pinfo;
{
struct msg_form *mf;

  if (!pinfo)
	return;

  unlink((char *)pinfo->u_data);
  free(pinfo->u_data);
  mf = mf_arr[pinfo->ul_data];
  if (mf) {
	mf->me_flags &= ~MF_LOCKED;
	fl_activate_form(mf->me_form);
	  }
}

void
ext_view_msg(num, asis)
int num, asis;
{
struct msg_form *mf;
struct _mail_msg *msg;
struct _mime_msg *mime;
struct _proc_info pinfo;
char mfile[64];
char buf[255];
FILE *m_tmp, *mmfd;
char *p;
int i;
 
 mf = mf_arr[num];

 if (!mf || !(mf->me_flags & MF_VIEW))
	return;

 if ((msg = mf->me_msg) == NULL)
	return;

 strcpy(mfile, get_temp_file("extview"));
 if ((m_tmp = fopen(mfile, "w")) == NULL) {
        display_msg(MSG_WARN, "ext view", "Can not open file %s", mfile);
        return; }

 if (!(mmfd = fopen(msg->get_file(mf->me_msg), "r"))) {
	display_msg(MSG_WARN, "Can not open message file", "%s", mf->me_msg->get_file(mf->me_msg));
 	fclose(m_tmp);
	return; }

 if (mf->me_flags & MF_HEADER)  {
   while(fgets(buf, 255, mmfd) && (strlen(buf) > 1))
 	fputs(buf, m_tmp);

   fputs("\n", m_tmp);
				}
 else
 	fseek(mmfd, msg->header->header_len, SEEK_SET);

 if (asis) {
 while(fgets(buf, 255, mmfd))
 	fputs(buf, m_tmp);
 } else {
 mime = get_text_part(msg);

 if (mime == NULL) {
	mime = msg->mime;
	while (mime) {
		if ((mime->flags & PREAMBLE) ||
			(mime->flags & EPILOG))
			break;
		mime = mime->mime_next;
		     }
		 }

 if (mime == NULL) {
  fclose(m_tmp);
  fclose(mmfd);
  display_msg(MSG_WARN, "ext editor", "Empty message");
  return;
		   }

 fseek(mmfd, mime->m_start, SEEK_SET);
 if (mime->boundary && (mime->flags & TEXT_PART)) {
	 while(fgets(buf, 255, mmfd)) {
	   if (strlen(buf) <= 1)
		break;
				      }	
						 }

 (*mime->encoding->ce_dec)(NULL, &i);
 while ((ftell(mmfd) < mime->m_end) && fgets(buf, 255, mmfd)) {
	if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
		continue;
 	fputs(p, m_tmp);
							      }
 p = (*mime->encoding->ce_dec)(NULL, &i);
 if (p && (strlen(p) > 1))
 	fputs(p, m_tmp);
	}

 fclose(m_tmp);
 fclose(mmfd);

 init_pinfo(&pinfo);
 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(mfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_view_exit;

 fl_deactivate_form(mf->me_form);
 mf->me_flags |= MF_LOCKED;
 if (file_view(mfile, &pinfo) == -1)
	ext_view_exit(&pinfo);

 return;
}

void
ext_edit_exit(pinfo)
struct _proc_info *pinfo;
{
struct msg_form *mf;

  if (!pinfo)
	return;

  mf = mf_arr[pinfo->ul_data];
  if (!mf)
	return;

  fl_activate_form(mf->me_form);

  update_mime(mf->me_msg);

  fl_freeze_form(mf->me_form);
  display_msg_text(mf);
  fl_unfreeze_form(mf->me_form);

  free(pinfo->u_data);
}

void
ext_edit_msg(num)
int num;
{
struct msg_form *mf;
struct _proc_info pinfo;
char command[255];
char *mfile;
char *e;
int i;
int added = 0;
 
 mf = mf_arr[num];

 if (!mf || (mf->me_flags & MF_VIEW))
	return;

 mfile = compose_msg_text(mf, 0);
 if (!mfile)
	return;

 mf->me_flags |= MF_CHANGED;

 e = b_getcfg_str(conf_name, "extedit", "/usr/bin/X11/xedit");
 command[0] = '\0';
 for (i = 0; i < strlen(e); i++) {
  if ((e[i] == '$') && (e[i] == 'f')) {
	added = 1;
	strcat(command, mfile); }
  else 	{
	command[strlen(command) + 1] = '\0';
	command[strlen(command)] = e[i];
	}
				}

 if (!added) {
	strcat(command, " ");
	strcat(command, mfile);
	added = 1;
		}

 init_pinfo(&pinfo);
 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(mfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_edit_exit;

 fl_deactivate_form(mf->me_form);
 if (exec_child(command, &pinfo) == -1)
	ext_edit_exit(&pinfo);

 return;
}

void
display_msg_text(mf)
struct msg_form *mf;
{
char buf[255];
char prefix[17];
u_long len;
int nl, markincl, col;
struct _mime_msg *mime;
int i;
char *p, *p1;
struct _mail_msg *msg;
int msize;
char mdescr[128];
char mtype[64];
char *mname;
FILE *mfd = NULL;
char *text = NULL;

 if (!mf)
	return;

 if (!mf->me_msg)
	return;

 msg = mf->me_msg;

 fl_clear_browser(mf->me_mime);
 fl_clear_textedit(mf->me_text);

 if (msg->flags & H_ONLY) {
	fl_unfreeze_form(mf->me_form);
	if (msg->flags & M_IMAP) {
		my_deactivate();
		set_cursor(mf->me_form, XC_watch);
		msg->flags |= LOCKED;
		p = msg->get_file(msg);
		msg->flags &= ~LOCKED;
		set_cursor(mf->me_form, 0);
		my_activate();
		fl_freeze_form(mf->me_form);
		if (p == NULL)
			return;
				 }
	else {
	if (display_msg(MSG_QUEST, "Message body resides on the POP server", "Do you want to retrieve it?")) 	{
		my_deactivate();
		set_cursor(mf->me_form, XC_watch);
		pop_getfull_msg(msg);
		set_cursor(mf->me_form, 0);
		my_activate();
		fl_freeze_form(mf->me_form);
				}
	else 	{
		fl_freeze_form(mf->me_form);
		return;
		}
	     }
		         }

 if (msg->mime == NULL)
	mime_scan(msg);

 mime = msg->mime;

 i = 0;
 while (mime) {
  if (mime->flags != ATTACHMENT) {
  	mime = mime->mime_next;
	continue; }

  i++;
  sprintf(mtype,"%s/%s", mime->mailcap->type_text, mime->mailcap->subtype_text);
  msize = get_mime_fsize(mime);
  mname = get_mime_fname(mime);

  if (mname) {
	if (msize > 0)
		sprintf(mdescr, "%-12.12s %7d %-43s", mname , msize , mime->c_descr ? mime->c_descr : "");
	else
		sprintf(mdescr, "%-12.12s %-50s", mname , mime->c_descr ? mime->c_descr : "");
	     }
  else
	sprintf(mdescr, "%-63s", mime->c_descr ? mime->c_descr : "");

  sprintf(buf, "%d %-22.22s %-10.10s %-10.10s %-63s", i, mtype, mime->encoding->encoding_name, mime->charset->charset_name, mdescr);
  fl_add_browser_line(mf->me_mime, buf);

  mime = mime->mime_next;
			}

 fl_select_browser_line(mf->me_mime, 1);

 len = 0;
 nl = 0;

if (mf->me_flags & MF_VIEW) {
	strncpy(prefix, b_getcfg_str(conf_name, "prefix", ">"), 16);
	markincl = b_getcfg_int(conf_name,  "markincl", 0);

	mime = get_text_part(msg);

	if (mime == NULL) {
		mime = msg->mime;
		while (mime) {
			if (mime->flags & PREAMBLE)
				break;
			if (mime->flags & EPILOG)
				break;
			mime = mime->mime_next;
			     }
			 }

	if (mime && mime->charset && 
		(mime->charset->charset_code != CHAR_UNKNOWN)) {

	  set_menu_chset(mf->me_lang, mime->charset);
	  fl_set_textedit_fontstyle(mf->me_text, mime->charset->font_style);
	  fl_set_textedit_fontsize(mf->me_text, mime->charset->font_size);

	  fl_set_browser_fontsize(mf->me_mime, mime->charset->font_size);

	  fl_set_browser_fontstyle(mf->me_mime, mime->charset->font_style);
								}
	else 	{
	  set_menu_chset(mf->me_lang, &supp_charsets[DEFAULT_CHARSET]);
	  fl_set_browser_fontsize(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_size);
	  fl_set_textedit_fontsize(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_size);

	  fl_set_browser_fontstyle(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_style);
	  fl_set_textedit_fontstyle(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_style);
		}

	if (mf->me_flags & MF_HEADER) {
#ifndef MMAP_MSG
	if ((mfd = fopen(msg->get_file(mf->me_msg), "r")) == NULL) {
		display_msg(MSG_WARN, "Can not open message file", "%s", msg->get_file(mf->me_msg));
		return; 					   }
#else
	if (msg->get_text(msg, NULL, msg->header->header_len + 255) != 0) {
		display_msg(MSG_WARN, "view", "Can not access message");
		return;							  }
#endif

	  col = b_getcfg_int(conf_name, "headcolor", FL_BLUE);

	  while((msg_tell(mfd) < msg->header->header_len) && msg_gets(buf, 255, mfd) && (strlen(buf) > 1)) {
	   strip_newline(buf);
	   p = (mime && mime->charset && mime->charset->decode) ? (*mime->charset->decode)(buf) : buf;
	   if (p == NULL)
		continue;
	   fl_add_textedit_line(mf->me_text, p);
	   fl_set_textedit_line_color(mf->me_text, fl_get_textedit_maxline(mf->me_text) - 1, -1, col);
	  		   }
	 fl_add_textedit_line(mf->me_text, "");
					}

 	if (mime == NULL) {
		display_msg(MSG_STAT, NULL, "View: Nothing to display");
#ifndef MMAP_MSG
		fclose(mfd);
#endif
		return;	}

#ifndef MMAP_MSG
	if ((mfd == NULL) &&
		(mfd = fopen(msg->get_file(mf->me_msg), "r")) == NULL) {
		display_msg(MSG_WARN, "Can not open message file", "%s", msg->get_file(mf->me_msg));
		return; 					       }
#else
	msg->free_text(msg);
	if (msg->get_text(msg, mime, MAX_VIEWABLE_SIZE + 512) != 0) {
		display_msg(MSG_WARN, "view", "Can not access message");
		return;						    }
#endif

	msg_seek(mfd, mime->m_start, SEEK_SET);

	if (mime->boundary && (mime->flags & TEXT_PART)) {
	 while(msg_gets(buf, 255, mfd)) {
	   strip_newline(buf);
	   if (strlen(buf) < 1)
		break;
				        }	
							 }
        else
	if (mime->boundary && (mime->flags & EPILOG))
		msg_gets(buf, 255, mfd);

#ifndef	MMAP_MSG
	if (ferror(mfd) || feof(mfd)) {
		display_msg(MSG_WARN, "VIEW", "Error reading message");
		fclose(mfd);
		return;	}
#endif

	(*mime->encoding->ce_dec)(NULL, &i);
	while ((msg_tell(mfd) < mime->m_end) && msg_gets(buf, 255, mfd)) {

	  strip_newline(buf);
	  if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
		continue;

	  p1 = mime->charset->decode ? (*mime->charset->decode)(p) : p;

	  while (1) {
	  if ((p = strchr(p1, '\n')) != NULL) {
		*p = '\0';
		p++;
		 			      }

	  nl++;
	  len += strlen(p1);
	  if ((nl > MAX_VIEWABLE_LINES) || (len > MAX_VIEWABLE_SIZE)) 	{
		display_msg(MSG_WARN, "view", "XFMail can not show the whole message since it's too big\nuse external viewer.");
		break;							}

	  fl_add_textedit_line(mf->me_text, p1);

	  col = 0;
	  if (markincl) {
	   if (!strncmp(p1,prefix, strlen(prefix)))
		col = markincl;
	   else {
		mname = p1;
		if ((*mname == ' ') || (*mname == '\t'))
			mname++;
		if ((*mname == ':') || (*mname == '>') ||
			(*mname == '|'))
			col = markincl;
		}
			}
	  if (col)
	  	fl_set_textedit_line_color(mf->me_text, fl_get_textedit_maxline(mf->me_text) - 1, -1, col);
	  if (!p || !*p)
		break;
	  p1 = p;
	  }

	  if ((nl > MAX_VIEWABLE_LINES) || (len > MAX_VIEWABLE_SIZE))
		break;
				}

	p = (*mime->encoding->ce_dec)(NULL, &i);
	if (p && (strlen(p) > 1))
	  if (mime->charset->decode)
		p = (*mime->charset->decode)(p);
	  fl_add_textedit_line(mf->me_text, p);
			} else {
	mime = get_text_part(msg);

	if (mime && mime->charset && 
		(mime->charset->charset_code != CHAR_UNKNOWN)) {
	  set_menu_chset(mf->me_lang, mime->charset);
	  fl_set_textedit_fontstyle(mf->me_text, mime->charset->font_style);
	  fl_set_textedit_fontsize(mf->me_text, mime->charset->font_size);

	  fl_set_browser_fontsize(mf->me_mime, mime->charset->font_size);
	  fl_set_browser_fontstyle(mf->me_mime, mime->charset->font_style);
								}
	else 	{
	  set_menu_chset(mf->me_lang, &supp_charsets[DEFAULT_CHARSET]);
	  fl_set_browser_fontsize(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_size);
	  fl_set_textedit_fontsize(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_size);

	  fl_set_browser_fontstyle(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_style);
	  fl_set_textedit_fontstyle(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_style);
		}

 	if (mime == NULL) {
		display_msg(MSG_STAT, NULL, "Edit: Nothing to display");
		return;	  }

#ifndef MMAP_MSG
	if ((mfd == NULL) &&
		(mfd = fopen(msg->get_file(mf->me_msg), "r")) == NULL) {
		display_msg(MSG_WARN, "Can not open message file", "%s", msg->get_file(mf->me_msg));
		return; 					       }
#else
	msg->free_text(msg);
	if (msg->get_text(msg, mime, MAX_EDITABLE_SIZE + 512) != 0) {
		display_msg(MSG_WARN, "edit", "Can not access message");
		return;						    }
#endif

	msg_seek(mfd, mime->m_start, SEEK_SET);

	if (mime->boundary) {
	 while(msg_gets(buf, 255, mfd)) {
	   strip_newline(buf);
	   if (strlen(buf) < 1)
		break;
				     }	
					}

#ifndef MMAP_MSG
	if (ferror(mfd) || feof(mfd)) {
		display_msg(MSG_WARN, "EDIT", "Error reading message");
		fclose(mfd);
		return;	}
#endif

	nl = 0;
	(*mime->encoding->ce_dec)(NULL, &i);
	while (((mf->tofft = msg_tell(mfd)) < mime->m_end) && msg_gets(buf, 255, mfd)) {

		if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
			continue;

		len += strlen(p);
		p1 = p;
		while ((p1 = strchr(p1, '\n')) != NULL) {
		  nl++;
		  p1++;
						       }
		if (nl >= MAX_EDITABLE_LINES) {
			display_msg(MSG_STAT, NULL, "Too many lines in message. Use external editor");
			break; }

		if (len >= MAX_EDITABLE_SIZE) {
			display_msg(MSG_STAT, NULL, "Message is too big. Use external editor");
			break; }

		if (!text) {
		 text = (char *)malloc(len + 1);
		 if (text == NULL) {
		  display_msg(MSG_FATAL, "EDIT", "malloc failed");
		  break;
				  }
		 text[0] = '\0';
			   }
		else
		 text = (char *)realloc(text, len + 1);

		strcat(text, p);
					}

 if (text) {
   fl_set_textedit(mf->me_text, text, -1);	
   free(text);
	   }	
				}

 fl_set_textedit_cursorpos(mf->me_text, 0, 0, -1);
 fl_set_textedit_bufchanged(mf->me_text, 0);

#ifndef MMAP_MSG
 fclose(mfd);
#else
 msg->free_text(msg);
#endif

 return;

}

char *
compose_msg_text(mf, update)
struct msg_form *mf;
int update;
{
static char nfile[64];
struct _mime_msg *mime;
FILE *mfd, *nfd;
char buf[255];
char *ntext, *p;
int i;

 sprintf(nfile, "%s.mai", get_temp_file("nfile"));

 if ((nfd = fopen(nfile, "w")) == NULL) {
	display_msg(MSG_WARN, "Can not open file", "%s", nfile);
	return NULL; }

 ntext = (char *)fl_get_textedit(mf->me_text, NULL);
 if ((mime = get_text_part(mf->me_msg)) == NULL) {
	if (update && (!ntext || (strlen(ntext) < 1))) {
		free(ntext);
		fclose(nfd);
		return nfile;  }

	mime = create_mime();
	if (!mime) {
	  display_msg(MSG_WARN, "compose text", "Can not open MIME");
	  fclose(nfd);
	  free(ntext);
	  return NULL;
		   }
	mime->flags = TEXT_PART;
	mime->mime_next = mf->me_msg->mime;
	mf->me_msg->mime = mime;
						}

 if ((mfd = fopen(mf->me_msg->get_file(mf->me_msg), "r")) == NULL) {
	display_msg(MSG_WARN, "Can not open message file", "%s", mf->me_msg->get_file(mf->me_msg));
	fclose(nfd);
	fclose(mfd);
	free(ntext);
	return NULL; }

 if (ntext && strlen(ntext))
	fputs(ntext, nfd);
 if (ntext)
	free(ntext);

 if (mf->tofft > 0) {
 if (fseek(mfd, mf->tofft, SEEK_SET) == -1) {
	display_msg(MSG_WARN, "edit", "Failed to compose message (seek failed)");
	fclose(nfd);
	fclose(mfd);
	return NULL;
					    }
		    }
 else 	{
 if (fseek(mfd, mime->m_start, SEEK_SET) == -1) {
	display_msg(MSG_WARN, "edit", "Failed to compose message (seek failed)");
	fclose(nfd);
	fclose(mfd);
	return NULL;			        }
	}

 if (mime->m_end > 0) 	{
 (*mime->encoding->ce_dec)(NULL, &i);
 while ((ftell(mfd) < mime->m_end) && fgets(buf, 255, mfd)) {
	  if ((p = (*mime->encoding->ce_dec)(buf, &i)) != NULL)
		fputs(p, nfd); 
							    }

 if ((p = (*mime->encoding->ce_dec)(NULL, &i)) != NULL)
	fputs(p, nfd); 
			}

 if (ftell(nfd) == 0)  {
    if (update) {
	unlink(nfile);
	mime->flags = 0;
		}
		       }
 fclose(nfd);
 fclose(mfd);

 mime->src_info = strdup(nfile);
 mime->flags |= FILE_TEMP;

 if (update)
	update_mime(mf->me_msg);

 return nfile;
}

