/*
 * Copyright(c) 1995,1996 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: pop_smtp.c,v 1.21 1996/12/15 14:22:33 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

FD_POPacc    *pacc_obj;
static FD_POP_Conf  *pop_obj;
static FD_SMTP_Conf *smtp_obj;
static FD_SmartPOP    *spop_obj;
static int ready = 0;
static int ready1 = 0;

void SMTP_Host_Call(FL_OBJECT *obj, long param)
{
}

void SPOP_Call(FL_OBJECT *obj, long param)
{
}

void POP_DMark_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "Every retrieved message", "will remain be marked as unretrieved");
}

void POP_2_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "SmartPOP features", "will not work with POP2 server");
}

void SPOP_UID_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "This feature works only", "on last 3000 messages retrieved");
}

void SPOP_XLST_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "This feature is not part of RFC", "and most POP servers does not support it");
}
void POP_Smart_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(pop_obj->POP_Conf);
 smart_pop_conf();
 fl_activate_form(pop_obj->POP_Conf);
}

void SMTP_POP_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "This feature is supported only by few", "POP server implementations");
}

void SMTP_Port_Call(FL_OBJECT *obj, long param)
{
}

void SMTP_Bg_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "If background sending is enabled you will not be able", "to recover from errors occured during send process");
}

void SMTP_SMTP_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(obj))
        fl_show_message("Warning!", "XFMail will send mail directly to SMTP gateway", "Make sure that host name is correct and the gateway is accessible from your computer");
}
 
void Misc_SMail_Call(FL_OBJECT *obj, long param)
{
}

void POP_Host_Call(FL_OBJECT *obj, long param)
{
}

void POP_Port_Call(FL_OBJECT *obj, long param)
{
}

void POP_User_Call(FL_OBJECT *obj, long param)
{
}

void POP_Pwd_Call(FL_OBJECT *obj, long param)
{
}

void P_Call(FL_OBJECT *obj, long param)
{
}

void POP_Store_Pwd_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(pop_obj->POP_Store_Pwd)) {
	fl_show_alert("WARNING", "This is very unsecure option", "make sure your config file (~/.xfmailrc) is not readable by anyone else", 1);
	b_setcfg_flags("popasswd", 0); }
}

void POP_Delete_Call(FL_OBJECT *obj, long param)
{
}

void
pop_conf() 
{

 if (ready)
        return;

 ready = 1;

 pop_obj = create_form_POP_Conf();
 fl_set_input(pop_obj->POP_Host, b_getcfg_str(conf_name, "pophost", "127.0.0.1"));
 fl_set_input(pop_obj->POP_Port, b_getcfg_str(conf_name, "poport", "110"));
 fl_set_input(pop_obj->POP_User, b_getcfg_str(conf_name, "popuser", ""));
 fl_set_input(pop_obj->POP_Pwd, b_getcfg_str(conf_name, "popasswd", ""));

 fl_set_button(pop_obj->POP_Delete, b_getcfg_int(conf_name,"popdelete", 0));
 fl_set_button(pop_obj->POP_DMark, b_getcfg_int(conf_name,"popdmark", 0));
 fl_set_button(pop_obj->POP_Store_Pwd, b_getcfg_int(conf_name,"popstorpwd", 0));
 fl_set_button(pop_obj->POP_2, b_getcfg_int(conf_name,"pop2", 0));

 fl_show_form(pop_obj->POP_Conf, FL_PLACE_CENTER, FL_TRANSIENT, "POP");
 fl_do_only_forms();

 b_putcfg_str(conf_name, "pophost", (char *)fl_get_input(pop_obj->POP_Host));
 b_putcfg_str(conf_name, "poport", (char *)fl_get_input(pop_obj->POP_Port));
 b_putcfg_str(conf_name, "popuser", (char *)fl_get_input(pop_obj->POP_User));

 b_putcfg_int(conf_name, "popdelete", fl_get_button(pop_obj->POP_Delete));
 b_putcfg_int(conf_name, "popdmark", fl_get_button(pop_obj->POP_DMark));
 b_putcfg_int(conf_name, "popstorpwd", fl_get_button(pop_obj->POP_Store_Pwd));
 b_putcfg_int(conf_name, "pop2", fl_get_button(pop_obj->POP_2));

 b_putcfg_str(conf_name, "popasswd", (char *)fl_get_input(pop_obj->POP_Pwd));

 if (fl_get_button(pop_obj->POP_Store_Pwd))
	b_setcfg_flags("popasswd", 0);
 else
	b_setcfg_flags("popasswd", DONT_STORE);

 fl_hide_form(pop_obj->POP_Conf);
 fl_free_form(pop_obj->POP_Conf);
 fl_free(pop_obj);
 pop_obj = NULL;

 ready = 0;
 return;         

}

void POP_Ok_Call(FL_OBJECT *obj, long param)
{
   ready = 0;
}

void
pop_account_init()
{
 pacc_obj = create_form_POPacc();
}

void
pop_account()
{

 if (ready)
        return;

 ready = 1;

 fl_set_input(pacc_obj->P_Username, b_getcfg_str(conf_name, "popuser", ""));
 fl_set_input(pacc_obj->P_Password, b_getcfg_str(conf_name, "popasswd", ""));
 fl_set_object_label(pacc_obj->P_Server, b_getcfg_str(conf_name, "pophost", "127.0.0.1"));
 fl_set_object_label(pacc_obj->P_Title, "POP account on");

 fl_set_object_focus(pacc_obj->POPacc, pacc_obj->P_Password);

 fl_show_form(pacc_obj->POPacc, FL_PLACE_CENTER, FL_TRANSIENT, "POP account");

 fl_do_only_forms();

 b_putcfg_str(conf_name,"popuser",(char *)fl_get_input(pacc_obj->P_Username));
 b_putcfg_str(conf_name,"popasswd",(char *)fl_get_input(pacc_obj->P_Password));

 fl_hide_form(pacc_obj->POPacc);

 ready = 0;
 return;         
}

void
smart_pop_conf() 
{

 if (ready1)
        return;

 ready1 = 1;

 spop_obj = create_form_SmartPOP();

 fl_set_input(spop_obj->SPOP_Kb, b_getcfg_str(conf_name, "popmaxmsg", "-1"));

 switch (b_getcfg_int(conf_name, "popmaxact", 1)) {
   case 0:
	fl_set_button(spop_obj->SPOP_Header, 1);
   break;

   case 1:
	fl_set_button(spop_obj->SPOP_Skip, 1);
   break;

   default:
	fl_set_button(spop_obj->SPOP_Skip, 1);
   break;
						  }

 switch (b_getcfg_int(conf_name, "popcheckretr", 0)) {
   case 0:
	fl_set_button(spop_obj->SPOP_Status, 0);
	fl_set_button(spop_obj->SPOP_UID, 0);
   break;

   case 1:
	fl_set_button(spop_obj->SPOP_Status, 1);
	fl_set_button(spop_obj->SPOP_UID, 0);
   break;

   case 2:
	fl_set_button(spop_obj->SPOP_Status, 0);
	fl_set_button(spop_obj->SPOP_UID, 1);
   break;

   case 3:
	fl_set_button(spop_obj->SPOP_Status, 1);
	fl_set_button(spop_obj->SPOP_UID, 1);
   break;

   default:
	fl_set_button(spop_obj->SPOP_Status, 0);
	fl_set_button(spop_obj->SPOP_UID, 0);
   break;
						     }

 if (b_getcfg_int(conf_name, "popgetstat", 0))
	fl_set_button(spop_obj->SPOP_Stat_XLST, 1);
 else
	fl_set_button(spop_obj->SPOP_Stat_Header, 1);

 fl_show_form(spop_obj->SmartPOP, FL_PLACE_CENTER, FL_TRANSIENT, "Smart POP");
 fl_do_only_forms();

 b_putcfg_int(conf_name, "popmaxmsg", atoi((char *)fl_get_input(spop_obj->SPOP_Kb)));

 if (fl_get_button(spop_obj->SPOP_Header))
	b_putcfg_int(conf_name, "popmaxact", 0);
 else
	b_putcfg_int(conf_name, "popmaxact", 1);

 if (fl_get_button(spop_obj->SPOP_Status) && fl_get_button(spop_obj->SPOP_UID))
	b_putcfg_int(conf_name, "popcheckretr", 3);
 else
 if (fl_get_button(spop_obj->SPOP_Status))
	b_putcfg_int(conf_name, "popcheckretr", 1);
 else
 if (fl_get_button(spop_obj->SPOP_UID))
	b_putcfg_int(conf_name, "popcheckretr", 2);
 else
	b_putcfg_int(conf_name, "popcheckretr", 0);

 if (fl_get_button(spop_obj->SPOP_Stat_Header))
	b_putcfg_int(conf_name, "popgetstat", 0);
 else
	b_putcfg_int(conf_name, "popgetstat", 1);

 fl_hide_form(spop_obj->SmartPOP);
 fl_free_form(spop_obj->SmartPOP);
 fl_free(spop_obj);
 spop_obj = NULL;

 ready1 = 0;
 return;         

}

void
smtp_conf() 
{

 if (ready)
        return;

 ready = 1;

 smtp_obj = create_form_SMTP_Conf();
 fl_set_input(smtp_obj->SMTP_Host, b_getcfg_str(conf_name, "smtphost", "127.0.0.1"));
 fl_set_input(smtp_obj->SMTP_Port, b_getcfg_str(conf_name, "smtport", "25"));

 switch(b_getcfg_int(conf_name,"smtpsend", 0)) 	{
   case 0:
	fl_set_button(smtp_obj->SMTP_Sendmail, 1);
   break;

   case 1:
	fl_set_button(smtp_obj->SMTP_SMTP, 1);
   break;

   case 2:
	fl_set_button(smtp_obj->SMTP_POP, 1);
   break;

   default:
	fl_set_button(smtp_obj->SMTP_Sendmail, 1);
   break;
		}

 fl_set_button(smtp_obj->SMTP_Bg, b_getcfg_int(conf_name,"smtpbg", 0));

 fl_set_button(smtp_obj->SMTP_Save, b_getcfg_int(conf_name,"smtpsave", 0));
 fl_set_button(smtp_obj->SMTP_Bcc, b_getcfg_int(conf_name,"smtpbcc", 0));
 fl_set_button(smtp_obj->SMTP_Off, b_getcfg_int(conf_name,"smtpoffl", 0));

 fl_set_input(smtp_obj->Misc_SMail, b_getcfg_str(conf_name, "sendmail", _PATH_SENDMAIL));


 fl_show_form(smtp_obj->SMTP_Conf, FL_PLACE_CENTER, FL_TRANSIENT, "SMTP");
 fl_do_only_forms();

 b_putcfg_str(conf_name, "smtphost", (char *)fl_get_input(smtp_obj->SMTP_Host));
 b_putcfg_str(conf_name, "smtport", (char *)fl_get_input(smtp_obj->SMTP_Port));

 if (fl_get_button(smtp_obj->SMTP_Sendmail))
	b_putcfg_int(conf_name, "smtpsend", 0);
 else
 if (fl_get_button(smtp_obj->SMTP_SMTP))
	b_putcfg_int(conf_name, "smtpsend", 1);
 else
 if (fl_get_button(smtp_obj->SMTP_POP))
	b_putcfg_int(conf_name, "smtpsend", 2);
 else
	b_putcfg_int(conf_name, "smtpsend", 0);

 b_putcfg_int(conf_name, "smtpbg", fl_get_button(smtp_obj->SMTP_Bg));

 b_putcfg_int(conf_name, "smtpsave", fl_get_button(smtp_obj->SMTP_Save));
 b_putcfg_int(conf_name, "smtpbcc", fl_get_button(smtp_obj->SMTP_Bcc));
 b_putcfg_int(conf_name, "smtpoffl", fl_get_button(smtp_obj->SMTP_Off));
 offline = fl_get_button(smtp_obj->SMTP_Off);

 b_putcfg_str(conf_name, "sendmail", (char *)fl_get_input(smtp_obj->Misc_SMail));

 fl_hide_form(smtp_obj->SMTP_Conf);
 fl_free_form(smtp_obj->SMTP_Conf);
 fl_free(smtp_obj);
 smtp_obj = NULL;

 ready = 0;
 return;         

}
