/*
 * Copyright(c) 1995,1996 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: sort.c,v 1.9 1996/12/15 14:22:34 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

static FD_Sort_Form *sort_obj;
static int ready = 0;

void Sort_Call(FL_OBJECT *obj, long param)
{
}

void
sort_conf() 
{
u_int new_sort = 0;

 if (ready)
        return;

 ready = 1;

 sort_obj = create_form_Sort_Form();

 switch (sort_type & 0x0f) {
   case NO_SORT:
	fl_set_button(sort_obj->Sort_None, 1);
   break;

   case BY_SNT_TIME:
	fl_set_button(sort_obj->Sort_Snd_Time, 1);
   break;

   case BY_RCV_TIME:
	fl_set_button(sort_obj->Sort_Rcv_Time, 1);
   break;

   case BY_SUBJECT:
	fl_set_button(sort_obj->Sort_Subj, 1);
   break;

   case BY_AUTHOR:
	fl_set_button(sort_obj->Sort_Author, 1);
   break;

   case BY_FLAGS:
	fl_set_button(sort_obj->Sort_Prior, 1);
   break;

   case BY_SIZE:
	fl_set_button(sort_obj->Sort_Size, 1);
   break;

   default:
	fl_set_button(sort_obj->Sort_None, 1);
   break;
			   }

   if (sort_type & MSG_DESCEND)
	fl_set_button(sort_obj->Sort_Desc, 1);
   else
	fl_set_button(sort_obj->Sort_Asc, 1);

   if (sort_type & MSG_THREAD)
	fl_set_button(sort_obj->Sort_Thread, 1);

 switch (folder_sort & 0x0f) {
   case NO_SORT:
	fl_set_button(sort_obj->Fold_Nosort, 1);
   break;

   case BY_NAME:
	fl_set_button(sort_obj->Fold_Name, 1);
   break;

   case BY_MSGNUM:
	fl_set_button(sort_obj->Fold_Msg, 1);
   break;

   case BY_UNREAD:
	fl_set_button(sort_obj->Fold_Unread, 1);
   break;

   default:
	fl_set_button(sort_obj->Fold_Nosort, 1);
   break;
			   }

   if (folder_sort & MSG_DESCEND)
	fl_set_button(sort_obj->Fold_Desc, 1);
   else
	fl_set_button(sort_obj->Fold_Asc, 1);

 fl_set_counter_bounds(sort_obj->Sort_DStat, 0, 2);
 fl_set_counter_precision(sort_obj->Sort_DStat, 0);
 fl_set_counter_step(sort_obj->Sort_DStat, 1, 1);
 fl_set_counter_value(sort_obj->Sort_DStat, (double)b_getcfg_int(conf_name, "statlen", 2));

 fl_set_counter_bounds(sort_obj->Sort_DDate, 0, 13);
 fl_set_counter_precision(sort_obj->Sort_DDate, 0);
 fl_set_counter_step(sort_obj->Sort_DDate, 1, 1);
 fl_set_counter_value(sort_obj->Sort_DDate, (double)b_getcfg_int(conf_name, "datelen", 13));

 fl_set_counter_bounds(sort_obj->Sort_DSize, 0, 6);
 fl_set_counter_precision(sort_obj->Sort_DSize, 0);
 fl_set_counter_step(sort_obj->Sort_DSize, 1, 1);
 fl_set_counter_value(sort_obj->Sort_DSize, (double)b_getcfg_int(conf_name, "sizelen", 5));

 fl_set_counter_bounds(sort_obj->Sort_DFrom, 0, 24);
 fl_set_counter_precision(sort_obj->Sort_DFrom, 0);
 fl_set_counter_step(sort_obj->Sort_DFrom, 1, 1);
 fl_set_counter_value(sort_obj->Sort_DFrom, (double)b_getcfg_int(conf_name, "fromlen", 18));

 fl_set_counter_bounds(sort_obj->Sort_DSubj, 0, 100);
 fl_set_counter_precision(sort_obj->Sort_DSubj, 0);
 fl_set_counter_step(sort_obj->Sort_DSubj, 1, 1);
 fl_set_counter_value(sort_obj->Sort_DSubj, (double)b_getcfg_int(conf_name, "subjlen", 100));


 fl_set_counter_bounds(sort_obj->Sort_FName, 0, 100);
 fl_set_counter_precision(sort_obj->Sort_FName, 0);
 fl_set_counter_step(sort_obj->Sort_FName, 1, 1);
 fl_set_counter_value(sort_obj->Sort_FName, (double)b_getcfg_int(conf_name, "foldlen", 11));

 fl_set_counter_bounds(sort_obj->Sort_FTotal, 0, 100);
 fl_set_counter_precision(sort_obj->Sort_FTotal, 0);
 fl_set_counter_step(sort_obj->Sort_FTotal, 1, 1);
 fl_set_counter_value(sort_obj->Sort_FTotal, (double)b_getcfg_int(conf_name, "numlen", 4));

 fl_set_counter_bounds(sort_obj->Sort_FUnread, 0, 100);
 fl_set_counter_precision(sort_obj->Sort_FUnread, 0);
 fl_set_counter_step(sort_obj->Sort_FUnread, 1, 1);
 fl_set_counter_value(sort_obj->Sort_FUnread, (double)b_getcfg_int(conf_name, "funrlen", 4));


 fl_show_form(sort_obj->Sort_Form, FL_PLACE_CENTER, FL_TRANSIENT, "Sort");
 fl_do_only_forms();

 show_msg[STAT_LEN] = (int)fl_get_counter_value(sort_obj->Sort_DStat);
 b_putcfg_int(conf_name, "statlen", (int)fl_get_counter_value(sort_obj->Sort_DStat));
 show_msg[DATE_LEN] = (int)fl_get_counter_value(sort_obj->Sort_DDate);
 b_putcfg_int(conf_name, "datelen", (int)fl_get_counter_value(sort_obj->Sort_DDate));
 show_msg[SIZE_LEN] = (int)fl_get_counter_value(sort_obj->Sort_DSize);
 b_putcfg_int(conf_name, "sizelen", (int)fl_get_counter_value(sort_obj->Sort_DSize));
 show_msg[FROM_LEN] = (int)fl_get_counter_value(sort_obj->Sort_DFrom);
 b_putcfg_int(conf_name, "fromlen", (int)fl_get_counter_value(sort_obj->Sort_DFrom));
 show_msg[SUBJ_LEN] = (int)fl_get_counter_value(sort_obj->Sort_DSubj);
 b_putcfg_int(conf_name, "subjlen", (int)fl_get_counter_value(sort_obj->Sort_DSubj));


 show_fld[FOLD_LEN] = (int)fl_get_counter_value(sort_obj->Sort_FName);
 b_putcfg_int(conf_name, "foldlen", (int)fl_get_counter_value(sort_obj->Sort_FName));

 show_fld[FNUM_LEN] = (int)fl_get_counter_value(sort_obj->Sort_FTotal);
 b_putcfg_int(conf_name, "fnumlen", (int)fl_get_counter_value(sort_obj->Sort_FTotal));

 show_fld[FUNR_LEN] = (int)fl_get_counter_value(sort_obj->Sort_FUnread);
 b_putcfg_int(conf_name, "funrlen", (int)fl_get_counter_value(sort_obj->Sort_FUnread));


 if (fl_get_button(sort_obj->Sort_None))
	new_sort = NO_SORT;
 else
 if (fl_get_button(sort_obj->Sort_Rcv_Time))
	new_sort = BY_RCV_TIME;
 else
 if (fl_get_button(sort_obj->Sort_Snd_Time))
	new_sort = BY_SNT_TIME;
 else
 if (fl_get_button(sort_obj->Sort_Subj))
	new_sort = BY_SUBJECT;
 else
 if (fl_get_button(sort_obj->Sort_Author))
	new_sort = BY_AUTHOR;
 else
 if (fl_get_button(sort_obj->Sort_Prior))
	new_sort = BY_FLAGS;
 else
 if (fl_get_button(sort_obj->Sort_Size))
	new_sort = BY_SIZE;
 else
	new_sort = NO_SORT;

 if (fl_get_button(sort_obj->Sort_Asc))
	new_sort |= MSG_ASCEND;
 else
 if (fl_get_button(sort_obj->Sort_Desc))
	new_sort |= MSG_DESCEND;
 else
	new_sort |= MSG_ASCEND;

 if (fl_get_button(sort_obj->Sort_Thread))
	new_sort |= MSG_THREAD;

 if (new_sort != sort_type) {
	b_putcfg_int(conf_name, "sort", new_sort);
	sort_type = new_sort;
	sort_folder(current_folder);
			    }

 if (fl_get_button(sort_obj->Fold_Nosort))
	new_sort = NO_SORT;
 else
 if (fl_get_button(sort_obj->Fold_Name))
	new_sort = BY_NAME;
 else
 if (fl_get_button(sort_obj->Fold_Msg))
	new_sort = BY_MSGNUM;
 else
 if (fl_get_button(sort_obj->Fold_Unread))
	new_sort = BY_UNREAD;
 else
	new_sort = NO_SORT;

 if (fl_get_button(sort_obj->Fold_Asc))
	new_sort |= MSG_ASCEND;
 else
 if (fl_get_button(sort_obj->Fold_Desc))
	new_sort |= MSG_DESCEND;
 else
	new_sort |= MSG_ASCEND;

 if (new_sort != folder_sort) {
	b_putcfg_int(conf_name, "fsort", new_sort);
	folder_sort = new_sort;
	sort_folders();
			    }

 redraw_folders();

 fl_hide_form(sort_obj->Sort_Form);
 fl_free_form(sort_obj->Sort_Form);
 fl_free(sort_obj);
 sort_obj = NULL;

 ready = 0;
 return;         

}

