/*
  Xinvest is copyright 1995 by Mark Buser.

  Permission is hereby granted to copy
  and freely distribute copies of this
  program for non-commercial purposes
  without fee, provided that this notice
  appears in all copies.

  All redistributions must be in their
  entirety as originally distributed.
  Feel free to modify Xinvest, but
  modified versions may not be distributed
  without prior consent of the author.

  This software is provided 'as-is'
  without any express or implied warranty.
  In no event will the author be held
  liable for any damages resulting from
  the use of this software.

  $Revision: 1.6 $ $Date: 1997/01/13 22:46:19 $
*/

#include <Xm/Xm.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>

#include "color.h"

/* ARGSUSED */
void showDetailEH ( Widget w, XtPointer client_data, XEvent *event)
{
  static Widget popup = (Widget) NULL;
  static Widget label;
  Widget frame;

  XmFontList font_list;
  XmString label_str;
  Dimension label_width, label_height, height;

  Position root_x, root_y;

  if (event->type == EnterNotify) {

    if (popup == (Widget)NULL) {
       popup = XtVaAppCreateShell ("DetailShell", "DetailClass",
                                   applicationShellWidgetClass,
                                   XtDisplayOfObject(w),
                                   XmNoverrideRedirect, True,
                                   XmNcolormap, GetColormap(),
                                   NULL);
       frame = XtVaCreateManagedWidget ("detail_frame", 
                                xmFrameWidgetClass, popup, 
                                NULL);
       label = XtVaCreateManagedWidget("detail_label", 
                                       xmLabelGadgetClass, frame,
                                       NULL);
    }

    XtVaGetValues( label, XmNfontList, &font_list, NULL);
    XtVaGetValues( w,     XmNlabelString, &label_str, NULL);

    label_width = XmStringWidth( font_list, label_str);
    label_height = XmStringHeight( font_list, label_str);

    XtVaSetValues( label, XmNlabelString, label_str, NULL);
    XmStringFree( label_str );

    XtTranslateCoords( w, (Position)0, (Position)0, &root_x, &root_y);
    XtVaGetValues( w, XmNheight, &height, NULL);

#define BORDER 2

    XtVaSetValues (popup, XmNx, root_x,
                          XmNy, root_y+height,
                          XmNwidth, label_width + (BORDER*2),
                          XmNheight, label_height + (BORDER*2),
                   NULL);
#undef BORDER

    XtRealizeWidget (popup);

  } else if (event->type == LeaveNotify && popup)

    XtUnrealizeWidget(popup);
}
