/*
  Xinvest is copyright 1996 by Mark Buser.

  Permission is hereby granted to copy
  and freely distribute copies of this
  program for non-commercial purposes
  without fee, provided that this notice
  appears in all copies.
  
  All redistributions must be in their
  entirety as originally distributed.
  Feel free to modify Xinvest, but
  modified versions may not be distributed
  without prior consent of the author.
  
  This software is provided 'as-is'
  without any express or implied warranty.
  In no event will the author be held
  liable for any damages resulting from
  the use of this software.

  $Revision: 2.7 $ $Date: 1997/01/11 00:50:34 $
*/
#ifndef RATE_H
#define RATE_H

#include "nav.h"
#include "transP.h"

void rateAddTrans( TRANS *, int);    /* Add one transaction to deposits */
void rateClrTrans();                 /* Clear all deposits */
void rateAddAccount( int, NAV *);    /* Add trans from account until NAV date */
void rateClrAccount();               /* Clear all deposits */
double rate_IRR ( double );          /* IRR of deposits to reach parameter */

double account_fee( int, NAV *);
double account_value( int, NAV *);
double account_value_reinvest( int, NAV *);
double account_cost( int, NAV *);
double account_withdrawal( int, NAV *);
double account_distrib( int, NAV *);     /* Amount of dividends taken */
double account_shares( int, NAV *);
void account_add_deposits (int, NAV *);  /* Add account transactions */
void account_clr_deposits ();            /* Remove all account transactions */
double account_IRR ( int );              /* Calculate IRR from transactions */

char *daytostr ( long, char *);          /* Change (long)date to (char *)date */
long strtoday ( char * );                /* Change (char *)date to (long)date */
#endif
