/*
 * XIRC
 * Configuration options
 */

#include "xirc.h"

FD_MCForm *mc_form;

static int stylesel = -1, colorsel = -1;

void set_stylepup_return(FL_OBJECT *obj, int sel)
{
    char rep[80];

    bzero(rep, 80);

    switch(sel) {
	case 1:	sprintf(rep, "Boldface");	break;
	case 2: sprintf(rep, "Italic");		break;
	case 3: sprintf(rep, "BoldItalic");	break;
	case 4: sprintf(rep, "Fixed");		break;
	case 5: sprintf(rep, "Normal");		break;
    }

    if (rep[0] != 0)
	fl_set_object_label(obj, rep);
}

void set_colorpup_return(FL_OBJECT *obj, int sel)
{
    char rep[80];

    bzero(rep, 80);

    switch(sel) {
	case 1:	sprintf(rep, "Black");		break;
	case 2: sprintf(rep, "Red");		break;
	case 3: sprintf(rep, "Green");		break;
	case 4: sprintf(rep, "Yellow");		break;
	case 5: sprintf(rep, "Blue");		break;
	case 6: sprintf(rep, "Purple");		break;
	case 7: sprintf(rep, "Sky");		break;
	case 8: sprintf(rep, "White");		break;
    }

    if (rep[0] != 0)
	fl_set_object_label(obj, rep);
}

void set_style(FL_OBJECT *obj)
{
    stylesel = fl_defpup(FL_ObjWin(obj),
	"Boldface|Italic|Boldface Italic|Fixed|Normal");

    fl_setpup_position(obj->form->x + obj->x,
	obj->form->y + obj->y + obj->h + 7);

    set_stylepup_return(obj, fl_dopup(stylesel));
    fl_freepup(stylesel);
}

void set_color(FL_OBJECT *obj)
{
    colorsel = fl_defpup(FL_ObjWin(obj),
	"Black|Red|Green|Yellow|Blue|Purple|Sky|White");

    fl_setpup_position(obj->form->x + obj->x,
	obj->form->y + obj->y + obj->h + 7);

    set_colorpup_return(obj, fl_dopup(colorsel));
    fl_freepup(colorsel);
}

void ServStyleCallback(FL_OBJECT *obj, long dat)
{
    set_style(obj);
}

void PrivStyleCallback(FL_OBJECT *obj, long dat)
{
    set_style(obj);
}

void CServStyleCallback(FL_OBJECT *obj, long dat)
{
    set_style(obj);
}

void CTCPStyleCallback(FL_OBJECT *obj, long dat)
{
    set_style(obj);
}

void ServColCallback(FL_OBJECT *obj, long dat)
{
    set_color(obj);
}

void PrvColCallback(FL_OBJECT *obj, long dat)
{
    set_color(obj);
}

void CSColCallback(FL_OBJECT *obj, long dat)
{
    set_color(obj);
}

void CTCPColCallback(FL_OBJECT *obj, long dat)
{
    set_color(obj);
}

void DisMCCallback(FL_OBJECT *obj, long dat)
{
    fl_hide_form(mc_form->MCForm);
}

void AccMCCallback(FL_OBJECT *obj, long dat)
{
    irc_data.servermsg.style = get_style_by_name(mc_form->ServStyle->label);
    irc_data.servermsg.color = get_color_by_name(mc_form->ServCol->label);
    irc_data.privatemsg.style = get_style_by_name(mc_form->PrivStyle->label);
    irc_data.privatemsg.color = get_color_by_name(mc_form->PrvCol->label);
    irc_data.critservmsg.style = get_style_by_name(mc_form->CServStyle->label);
    irc_data.critservmsg.color = get_color_by_name(mc_form->CSCol->label);
    irc_data.ctcpmsg.style = get_style_by_name(mc_form->CTCPStyle->label);
    irc_data.ctcpmsg.color = get_color_by_name(mc_form->CTCPCol->label);

    fl_hide_form(mc_form->MCForm);
    save_options();
}
