/*
 * XIRC
 * Input handling routines
 */

#include "xirc.h"

char reqnick[80];

void handle_input(char *str)
{
    char command[80], data[480];

    bzero(command, 80);
    bzero(data, 480);

    sscanf(str, "%[^ \r\n] %[^\r\n]\r\n", command, data);

    fl_freeze_form(main_form->MainForm);
    if (!strncasecmp(command, "/me", 3)) {
	char output[480], disp[480];

	bzero(output, 480);
	bzero(disp, 480);
	if (channel[0] != 0) {
	    sprintf(output, "PRIVMSG %s :%cACTION %s%c\r\n", channel, 1, data, 1);
	    sprintf(disp, "* %s %s", nick, data);
	    (void) write(irc, output, strlen(output));
	    fl_addto_browser(main_form->MainBrowser, disp);
	} else {
	    add_line(main_form->MainBrowser, "*** You can't talk in deep space!", 1);
	}
    } else if (!strncasecmp(command, "/nick", 5)) {
	char output[80];

	bzero(output, 80);
	sprintf(output, "NICK %s\r\n", data);
	(void) write(irc, output, strlen(output));

	if (nick[0] == 0) {
	    strcpy(nick, data);
	    bzero(irc_data.nick, 9);
	    strcpy(irc_data.nick, data);
	}

	bzero(reqnick, 80);
	strcpy(reqnick, data);
    } else if (!strncasecmp(command, "/leave", 6) ||
	((!strncasecmp(command, "/l", 2)) && strlen(command) == 2)) {
	char output[80];

	if (channel[0] != 0) {
	    bzero(output, 80);
	    sprintf(output, "PART %s\r\n", data);
	    (void) write(irc, output, strlen(output));
	} else
	    add_line(main_form->MainBrowser, "*** If you intend to leave XIRC, type \"/quit\".", 1);
    } else if (!strncasecmp(command, "/join", 5) ||
	((!strncasecmp(command, "/j", 2)) && strlen(command) == 2)) {
	char output[480];

	bzero(output, 480);
	if (data[0] != 0) {
	    if (data[0] != '#') {
		sprintf(output, "JOIN #%s\r\n", data);
		bzero(channel, 80);
		sprintf(channel, "#%s", data);
	    } else {
		sprintf(output, "JOIN %s\r\n", data);
		bzero(channel, 80);
		strcpy(channel, data);
	    }
	    (void) write(irc, output, strlen(output));
	} else {
	    add_line(main_form->MainBrowser, "*** You can't join a blank channel!", 1);
	}
    } else if ((!strncasecmp(command, "/signoff", 8)) ||
	       (!strncasecmp(command, "/si", 3)) ||
	       (!strncasecmp(command, "/quit", 5))) {
	char output[480], out[480];

	bzero(output, 480);
	bzero(out, 480);
	sprintf(output, "QUIT :%s\r\n", data);
	sprintf(out, "*** Signoff: %s (%s)", nick, data);

	/* Signoff is sent twice so the server doesn't mistake your
	   disconnection as a dead or dropped socket.  (Weird) */

	(void) write(irc, output, strlen(output));
	(void) write(irc, output, strlen(output));
	add_line(main_form->MainBrowser, out, 3);
	fl_clear_browser(ul_form->NickBrowser);
	exit(0);
    } else if (!strncasecmp(command, "/font", 5)) {
	if (data[0] != 0) {
	    if (!strncasecmp(data, "small", 5))
		fl_set_browser_fontsize(main_form->MainBrowser, FL_SMALL_SIZE);
	    else if (!strncasecmp(data, "normal", 6))
		fl_set_browser_fontsize(main_form->MainBrowser, FL_NORMAL_SIZE);
	    else if (!strncasecmp(data, "large", 5))
		fl_set_browser_fontsize(main_form->MainBrowser, FL_LARGE_SIZE);
	} else {
	    fl_show_form(font_form->FontForm, FL_PLACE_MOUSE,
		FL_FULLBORDER, "XIRC Main Font Settings");
	}
    } else if (!strncasecmp(command, "/msg", 4) ||
	((!strncasecmp(command, "/m", 2)) && strlen(command) == 2)) {
	char nic[80], msg[400], out[480], disp[480];

	bzero(nic, 80);
	bzero(msg, 400);
	bzero(out, 480);
	bzero(disp, 480);

	sscanf(data, "%[^ ] %[^\r\n]\r\n", nic, msg);
	sprintf(out, "PRIVMSG %s :%s\r\n", nic, msg);
	(void) write(irc, out, strlen(out));
	sprintf(disp, "<-%s-> %s", nic, msg);
	add_line(main_form->MainBrowser, disp, 2);
    } else if (!strncasecmp(command, "/mode", 5)) {
	char rep[600];

	bzero(rep, 600);

	sprintf(rep, "MODE %s %s\r\n", channel, data);
	(void) write(irc, rep, strlen(rep));
    } else if (!strncasecmp(command, "/kick", 5)) {
	char nic[80], str[400], rep[480];

	bzero(nic, 80);
	bzero(str, 400);
	bzero(rep, 480);

	sscanf(data, " %[^ ] %[^\r\n]\r\n", nic, str);
	sprintf(rep, "KICK %s %s :%s\r\n", channel, nic, str);
	(void) write(irc, rep, strlen(rep));
    } else if (!strncasecmp(command, "/whois", 6)) {
	char rep[480];

	bzero(rep, 480);
	sprintf(rep, "WHOIS %s\r\n", data);
	(void) write(irc, rep, strlen(rep));
	fl_set_browser_fontsize(text_form->TextBrowser, 12);
	fl_clear_browser(text_form->TextBrowser);
	fl_show_form(text_form->TextForm, FL_PLACE_CENTER|FL_FREE_SIZE,
		FL_FULLBORDER, "Whois Data");
    } else if (!strncasecmp(command, "/topic", 6)) {
	char rep[480];

	bzero(rep, 480);
	if (channel[0] != 0) {
	    sprintf(rep, "TOPIC %s :%s\r\n", channel, data);
	    (void) write(irc, rep, strlen(rep));
	} else {
	    add_line(main_form->MainBrowser, "*** You can't set the topic of deep space!", 1);
	}
    } else if (!strncasecmp(command, "/list", 5)) {
	(void) write(irc, "LIST\r\n", 6);
	fl_clear_browser(text_form->TextBrowser);
	fl_addto_browser(text_form->TextBrowser, "@f*** Channel      Num Topic");
	add_line(main_form->MainBrowser, "*** Generating channel list, one moment.", 1);
    } else if (!strncasecmp(command, "/help", 5)) {
	add_line(main_form->MainBrowser, "*** Please refer to the help menu.  That's what it's there for.", 1);
    } else if (command[0] == '/') {
	char out[400];

	bzero(out, 400);
	sprintf(out, "*** %s: Unknown or unimplemented command.", command);
	add_line(main_form->MainBrowser, out, 1);
    } else {
	char output[480], out[480];

	bzero(output, 480);
	bzero(out, 480);
	if (channel[0] != 0) {
	    sprintf(output, "PRIVMSG %s :%s %s\r\n", channel, command, data);
	    sprintf(out, "<%s> %s %s\n", nick, command, data);
	    (void) write(irc, output, strlen(output));
	    fl_addto_browser(main_form->MainBrowser, out);
	} else {
	    add_line(main_form->MainBrowser, "*** You can't talk in deep space!", 1);
	}
    }
    fl_unfreeze_form(main_form->MainForm);
}
