/*
 * XIRC
 * Names support
 */

#include "xirc.h"

int get_selected_line(void)
{
    if (channel[0] != 0)
	return(fl_get_browser(ul_form->NickBrowser));
    else
	return(0);
}

char *get_ban(char *nic)
{
    int i;
    char *banname;

    banname = (char *) malloc(80);

    for(i = 0; i < 500; i++) {
	if (!strncasecmp(nic, chanusers[i].nick, strlen(nic)) &&
	    strlen(nic) == strlen(chanusers[i].nick)) {
	    if (irc_data.bantype == BAN_STANDARD) {
		sprintf(banname, "*!*%s@%s", chanusers[i].email1,
			chanusers[i].email2);
		return(banname);
	    } else if (irc_data.bantype == BAN_SITE) {
		sprintf(banname, "*!*@%s", chanusers[i].email2);		
		return(banname);
	    } else if (irc_data.bantype == BAN_NICK) {
		sprintf(banname, "%s!*@*", chanusers[i].nick);
		return(banname);
	    } else if (irc_data.bantype == BAN_SCREW) {
		char newemail1[80], newemail2[80];
		int x;

		bzero(newemail1, 80);
		bzero(newemail2, 80);
		for(x = 0; x < strlen(chanusers[i].email1); x++) {
		    srand(x + chanusers[i].email1[x]);
		    if ((rand() % 50) > 25)
			newemail1[x] = '?';
		    else
			newemail1[x] = chanusers[i].email1[x];
		}

		for(x = 0; x < strlen(chanusers[i].email2); x++) {
		    srand(x + chanusers[i].email2[x]);
		    if ((rand() % 50) > 25)
			newemail2[x] = (chanusers[i].email2[x] != '.') ? '?' : '.';
		    else
			newemail2[x] = chanusers[i].email2[x];
		}

		sprintf(banname, "*!*%s@%s", newemail1, newemail2);
		return(banname);
	    }
	}
    }

    return(NULL);
}

void NickBrowserCallback(FL_OBJECT *obj, long dat)
{
}

void NickOpCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[80];
	int is_opped = 0;

	bzero(nic, 80);
	bzero(rep, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@') {
	    strcpy(nic, nic + 1);
	    is_opped = 1;
	}

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	if (is_opped)
	    sprintf(rep, "MODE %s -o %s\r\n", channel, nic);
	else
	    sprintf(rep, "MODE %s +o %s\r\n", channel, nic);

	(void) write(irc, rep, strlen(rep));
    }
}

void NickKickCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[160], kickmsg[80];

	bzero(nic, 80);
	bzero(rep, 160);
	bzero(kickmsg, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	strcpy(kickmsg, fl_show_input("Kick message?", ""));
	if (kickmsg[0] != 0) {
	    sprintf(rep, "KICK %s %s :%s\r\n", channel, nic, kickmsg);
	    (void) write(irc, rep, strlen(rep));
	}
    }
}

void NickBanCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[80];
	char *name;

	bzero(nic, 80);
	bzero(rep, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	name = get_ban(nic);
	if (name) {
	    sprintf(rep, "MODE %s +b %s\r\n", channel, name);
	    (void) write(irc, rep, strlen(rep));
	}
    }
}

void NickTrashCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[160];
	char *name;

	bzero(nic, 80);
	bzero(rep, 160);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	name = get_ban(nic);
	if (name) {
	    sprintf(rep, "MODE %s -o+b %s %s\r\n", channel, nic, name);
	    (void) write(irc, rep, strlen(rep));
	    bzero(rep, 160);
	    sprintf(rep, "KICK %s %s :Get back in that trash can!\r\n", channel, nic);
	    (void) write(irc, rep, strlen(rep));
	}
    }
}

void NickIgnoreCallback(FL_OBJECT *obj, long dat)
{
    fl_show_alert("Ignore", "Sorry, not implemented.", "", 0);
}

void NickKillCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[160], kickmsg[80];

	bzero(nic, 80);
	bzero(rep, 160);
	bzero(kickmsg, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	strcpy(kickmsg, fl_show_input("Kill message?", ""));
	if (kickmsg[0] != 0) {
	    sprintf(rep, "KILL %s :%s\r\n", nic, kickmsg);
	    (void) write(irc, rep, strlen(rep));
	}
    }
}

void NickWhoCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[80];

	bzero(nic, 80);
	bzero(rep, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	fl_set_browser_fontsize(text_form->TextBrowser, 12);
	fl_clear_browser(text_form->TextBrowser);

	sprintf(rep, "WHOIS %s\r\n", nic);
	(void) write(irc, rep, strlen(rep));

	fl_show_form(text_form->TextForm, FL_PLACE_CENTER|FL_FREE_SIZE,
		FL_FULLBORDER, "Whois Data");
    }
}

void NickVoiceCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();
    int is_voice = 0;

    if (i != 0) {
	char nic[80], rep[80];

	bzero(nic, 80);
	bzero(rep, 80);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+') {
	    strcpy(nic, nic + 1);
	    is_voice = 1;
	}

	if (is_voice)
	    sprintf(rep, "MODE %s -v %s\r\n", channel, nic);
	else
	    sprintf(rep, "MODE %s +v %s\r\n", channel, nic);

	(void) write(irc, rep, strlen(rep));
    }
}

void NickMsgCallback(FL_OBJECT *obj, long dat)
{
    int i = get_selected_line();

    if (i != 0) {
	char nic[80], rep[600], kickmsg[540];

	bzero(nic, 80);
	bzero(rep, 600);
	bzero(kickmsg, 540);

	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, i));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	strcpy(kickmsg, fl_show_input("Message?", ""));
	if (kickmsg[0] != 0) {
	    char disp[600];

	    bzero(disp, 600);
	    sprintf(rep, "PRIVMSG %s :%s\r\n", nic, kickmsg);
	    (void) write(irc, rep, strlen(rep));

	    sprintf(disp, "<-%s-> %s", nic, kickmsg);
	    add_line(main_form->MainBrowser, disp, 2);
	}
    }
}

void DisULIST(FL_OBJECT *obj, long dat)
{
    fl_hide_form(ul_form->ULISTForm);
}

void ProtectUser(FL_OBJECT *obj, long dat)
{
    fl_show_alert("Protect user", "Sorry, not implemented.", "", 0);
}

void add_names_list(char *dat)
{
    char nic[80], data[1600], data2[1600];

    bzero(nic, 80);
    bzero(data, 1600);
    bzero(data2, 1600);

    fl_clear_browser(ul_form->NickBrowser);

    sscanf(dat, "%[^ ] %[^\r\n]\r\n", nic, data);
    strcpy(data2, data);
    while(nic[0] != 0) {
	char add[80];

	bzero(add, 80);
	sprintf(add, " %s", nic);

	fl_add_browser_line(ul_form->NickBrowser, add);
	bzero(nic, 80);
	bzero(data, 1600);
	sscanf(data2, "%[^ ] %[^\r\n]\r\n", nic, data);
	bzero(data2, 1600);
	strcpy(data2, data);
    }
}

void add_names(char *dat)
{
    char nic[80];

    bzero(nic, 80);
    sprintf(nic, " %s", dat);
    fl_add_browser_line(ul_form->NickBrowser, nic);
}

void remove_names(char *dat)
{
    int i, x;
    char nic[80];

    i = fl_get_browser_maxline(ul_form->NickBrowser);
    for(x = 1; x < i; x++) {
	bzero(nic, 80);
	strcpy(nic, fl_get_browser_line(ul_form->NickBrowser, x));
	strcpy(nic, nic + 1);

	if (nic[0] == '@')
	    strcpy(nic, nic + 1);

	if (nic[0] == '+')
	    strcpy(nic, nic + 1);

	if (strstr(dat, nic)) {
	    fl_delete_browser_line(ul_form->NickBrowser, x);
	    return;
	}
    }
}

void names_refresh(void)
{
    char rep[160];

    bzero(rep, 160);
    sprintf(rep, "NAMES %s\r\n", channel);
    (void) write(irc, rep, strlen(rep));
}
