/* spline.h: Interpolation
//
// Written and Copyright (C) 1993-1996 by Michael J. Gourlay
//
// NO WARRANTEES, EXPRESS OR IMPLIED.
*/

#ifndef _SPLINE_H__INCLUDED_
#define _SPLINE_H__INCLUDED_




/* REAL: type to use for floating point values.
//
// The intention is that you can decide which precision you want at compile
// time.  Choose, for example, float or double.
*/
#ifndef REAL
#define REAL float
#endif




extern void spline3_setup (REAL *, REAL *, long, REAL *, REAL *);

extern REAL spline3_eval (REAL, REAL *, REAL *, long, REAL *, REAL *, REAL *, REAL *);

REAL d_parabola(REAL x, REAL xp0, REAL xp1, REAL xp2, REAL yp0, REAL yp1, REAL yp2);

REAL hermite3_interp (REAL w, const REAL *x, const REAL *y, REAL *d, long n, REAL (*f)(REAL), int flags, REAL *h1, REAL *h2);

#endif
