/*
 *	@(#) xswnlist.h 12.1 95/07/07 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S003, 24-Oct-93, rickra
 *	Added 32v5 stream fields
 *
 * S002, 27-May-93, rickra
 *	Added some new fields:	
 *		BX_BOOT_TIME BX_KPD0 BX_BOOTSTRING BX_STRING
 *		BX_STRING_SIZE BX_CALLOUT BX_MOUNT
 *
 * S001, 30-Sep-92, rickra
 *	Fixed typo where a comment was left open!!!	
 * S000, 30-Sep-92, rickra
 *	Added copyright and modification history
 *	Added utsname for kernel detection being in sync with /dev/kmem
 */
struct	nlist	x[] =
	{
		{ "v" }, 
#define BX_V    	0 
		{ "tune" }, 
#define BX_TUNE		1
		{ "file" }, 
#define BX_FILES	2 
		{ "inode" }, 
#define BX_INODE	3 
		{ "sysinfo" }, 
#define BX_SYSINFO 	4
		{ "proc" }, 
#define	BX_PROCS	5
		{ "region" }, 
#define BX_REGION	6
		{ "Hz" }, 
#define BX_HZ		7
		{ "cfreelist" }, 
#define BX_CFREELIST	8
		{ "cfree" }, 
#define BX_CBLOCKS	9
		{ "minfo" }, 
#define BX_MINFO	10
		{ "nswap" }, 
#define BX_NSWAP	11	
		{ "maxmem" }, 
#define BX_MAXMEM	12	
		{ "freemem" }, 
#define BX_FREEMEM	13	
		{ "strst" }, 
#define BX_STREAMS	14	
		{ "bootinfo" }, 
#define BX_BOOTINFO	15
		{ "nmblock" }, 
#define BX_NMBLOCK	16	
		{ "availsmem" }, 
#define BX_AVAILSMEM	17	
		{ "rcstat" }, 
#define BX_RCSTAT	18	
		{ "clstat" }, 
#define BX_CLSTAT	19	
		{ "rsstat" }, 
#define BX_RSSTAT	20
		{ "svstat" }, 
#define BX_SVSTAT	21
		{ "scoutsname" }, 
#define BX_SCOUTS	22
		{ "utsname" }, 
#define BX_UTSNAME	23
		{ "Sdskstats" }, 
#define BX_SCSI_DISK_STATS	24
		{ "Stpstats" }, 
#define BX_SCSI_TAPE_STATS	25
		{ "Sromstats" }, 
#define BX_SCSI_ROM_STATS	26
		{ "ctstats" }, 
#define BX_CART_TAPE_STATS	27
		{ "esdistats" }, 
#define BX_ESDI_DISK_STATS	28
		{ "wd1010stats" }, 
#define BX_WD_DISK_STATS	29
		{ "flstats" }, 
#define BX_FLOPPY_DISK_STATS	30
		{ "lbolt" }, 
#define BX_BOOT_TIME		31	
		{ "kpd0" }, 
#define BX_KPD0			32
		{ "bs_bootstring" }, 
#define BX_BOOTSTRING		33
		{ "strgCfg" }, 
#define BX_STRING		34
		{ "max_cfgsize" }, 
#define BX_STRING_SIZE		35
		{ "callout" }, 
#define BX_CALLOUT		36
		{ "mount" }, 
#define BX_MOUNT		37
		{ "rbsize" }, 
#define BX_RBSIZE		38
		{ "Rbsize" }, 
#define BX_RRBSIZE		39
		{ "pagest" }, 
#define BX_PAGEST		40
		{ "pfdat" }, 
#define BX_PFDAT		41
		{ "mfmap" }, 
#define BX_MFMAP		42
		{ "mfmax" }, 
#define BX_MFMAX		43
{ (char *)0 },
	};

#define	nlist_num	44


