/*
 *      @(#) xsw.c 12.1 95/05/09 SCOINC
 */
/***************************************************************************
 *
 *      Copyright (c) 1990-1993              The Santa Cruz Operation, Inc.
 *
 *      All rights reserved.  No part of this program or publication may be
 *      reproduced, transmitted, transcribed, stored in a retrieval system,
 *      or translated into any language or computer language, in any form or
 *      by any means, electronic, mechanical, magnetic, optical, chemical,
 *      biological, or otherwise, without the prior written permission of:
 *
 *              The Santa Cruz Operation , Inc.         (408) 425-7222
 *              400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * S007, 05-Feb-94, rickra
 *      Finally checking this in..... 
 *	Removed old comments.
 *	Moved some functions to update_d.c ....
 *
 * S006, 24-Oct-93, rickra
 *      Added 32v4 Vs. 32v5 streams..
 *
 * S005, 15-Sep-93, rickra
 *      Added disk space support...
 *	Bug fixes.....
 *
 * S004, 27-May-93, rickra
 *      Alot.... Oh well...
 * S003, 01-Jan-93, rickra
 *      Added support for seperate windows.
 * S002, 30-Sep-92, rickra
 *      Forgot to keep comment before Defined functions descriptions.
 * S001, 30-Sep-92, rickra
 *      Added the SCCS descriptor at the top.
 * S000, 30-Sep-92, rickra
 *      Determined if if the /unix is the boot kernel.
 */

/*--------------------------------------------------------------------------

        xsw.c - SCO ODT (UNIX 386) system watcher

  Defined functions:

	list_select (w, client_data, cbs)
	change_and_update_window_sizes (window, display, gc,
					DrawAreaXYWH, button_to_change,
					y_multiplier)
	check_help_and_options ()
	set_xsw_title ()
	set_geometry ()
	calculate_and_update_Users ()
	update_Tod ()
	draw_lower_main_statics (window, display, gc, DrawAreaXYWH, Y_offset)
	update_lower_main_info ()
	update_screen (sep_window, data_updated)
	update_display (read_new_kernel_data, sep_window)
	destroy_callback (my_widget, client_data, cbs)
	create_seperate_windows_widgets (button)
	draw_display (initial, sep_window)
	update_timer_proc (server_pointer)
	set_update_timer (msec, server_pointer)
	expose_callback (widget, client_data, call_data)
	quit_now ()
	delta_StatCycle (delta_msec)
	Menu_bar_mode_callback (widget, client_data, call_data)
	button_up_callback (widget, client_data, call_data)
	button_down_callback (widget, client_data, call_data)
	button_1_callback (widget, client_data, call_data)
	button_2_callback (widget, client_data, call_data)
	button_3_callback (widget, client_data, call_data)
	change_font_callback (widget, client_data, call_data)
	input_callback_key_event (widget, client_data, call_data)
	input_callback_button_event (widget, client_data, call_data)
	input_callback (widget, client_data, call_data)
	main (argc, argv)

--------------------------------------------------------------------------*/


char           *revision = "1.01";

#include "include/unixincs.h"
#include <sys/sysmacros.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/StringDefs.h>
#include <X11/IntrinsicP.h>
#include <X11/Intrinsic.h>
#include <X11/CoreP.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>
#include <Xm/Protocols.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/PanedW.h>
#include <Xm/PushBG.h>
#include <Xm/DrawingA.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/SelectioB.h>
#include <Xm/Command.h>
#include <Xm/ArrowB.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/Separator.h>
#include <Xm/ToggleB.h>
#include <Xm/Form.h>
#include <Xm/DialogS.h>
#include "include/buttons.h"
#include "include/resources.h"
#include "include/xswboth.h"
#include "include/scales.h"
#include "include/menus.h"
#include "include/xsw.h"


#define swapfunc(X)     sysi86(SI86SWPI, X)

typedef struct ToggleButtonNameStruct
{
  char           *label;
}               ToggleButtonNames;


ToggleButtonNames Toggle_Button_decl[] =
{
  {"CPU"},			/* 0  */
  {"Wait"},			/* 1  */
  {"Cache"},			/* 2  */
  {"Other"},			/* 3  */
  {"PS Cpu"},			/* 4  */
  {"PS I/O"},			/* 5  */
  {"PS Mem"},			/* 6  */
  {"Streams"},			/* 7  */
  {"NFS Stats."},		/* 8  */
  {"Sysinfo"},			/* 9  */
  {"VBT"},			/* 10  */
  {"Device Stats."},		/* 11  */
  {"MEM"},			/* 12  */
  {"Disk Space"}		/* 13  */
};

struct NetworkXswStruct *head_server = NULL;
struct NetworkXswStruct *current_server = NULL;

struct NetworkXswStruct *selected_server = NULL;


struct NetworkXswStruct *input_callback_current_server = NULL;
struct NetworkXswStruct *toggle_button_current_server = NULL;

int             server_count = 0;

int             FileDescriptor;

char           *kernel = "/unix";

char           *xsw_basename;
char           *strdup ();
char           *basename ();
int             inCommandLineOptionParse = 0;

Pixmap          pixmap;

XtAppContext    appcon;

extern int      doing_help;


extern  int current_colorHelp_button_num;

extern struct hostent *RemoteHostInfo;


int             got_key_event = 0;

/* Begin MAIN XSW defines  */

MyResources     res;

Widget          frame;
Widget          row_column;
Widget          swindow;

Widget          message_text_widget;

Widget          target_button_up;
Widget          target_button_down;

Widget          actual_interval_widget;
Widget          target_interval_widget;
Widget          actual_interval_text_widget;
Widget          target_interval_text_widget;
Widget          user_widget;
Widget          user_text_widget;

Widget          server_label;
Widget          temp_server_label;
Widget          sep_widget;
Widget          sep_widget_vertical;
Widget          clip_widget;

Widget          row_column;

int             default_button_1_mode = 2;
int             default_button_2_mode = 2;
int             default_button_3_mode = 2;


Widget          TOGGLE_BUTTONS_WIDGETS[Max_state_buttons];

int             current_font = 0;


/* End MAIN XSW defines  */


int             first_expose = 1;

XmString       *server_list;

XmString       *disconnect_server_list;

Widget          DrawAreaW;
Widget          main_window_widget;
Widget          menu_bar;
Widget          toplevel;
Widget          sub_menu_state_list[Max_sub_menu_buttons];

XWindowAttributes DrawAreaXYWH;
Display        *display;
Window          window = 0;
GC              gc;
GC              temp_gc;
Colormap        cmap;
int             color_map;
int             screen;
int             screen2;
int             redrawing_entire_DrawArea = 1;


int             configured_port = 0;

int             need_fresh_process_read = 1;

int             must_be_32v5 = 0;


extern int      errno;
extern int      h_errno;

#define delta_msec(t,t0) ((( t.time * 1000L) +  t.millitm) - \
                          ((t0.time * 1000L) + t0.millitm))

int             send_data_count = 0;
int             first_server_read = 0;

int             ps_procs_to_display = 0;

int             in_expose_callback = 0;
int             in_set_display_mode = 0;

struct scoutsname scoutsname;
struct utsname  memuts;
struct utsname  sysuts;

extern long     lseek ();

extern void     help_general ();
extern void     help_options ();
extern void     help_problems ();

extern int      sync_number;

/* Begin Prototyping here */

int             catch_signal ();

void
                toggle_button_reset (Widget w,
				     caddr_t client_data,
				     XmAnyCallbackStruct * call_data);

void
                set_display_mode (int new_mode);

void
                read_sysinfo_and_minfo ();

void
                connect_server ();
void
                disconnect_server ();


void
                expose_callback (Widget widget,
				 struct expose_callback_struct *client_data,
				 XmDrawingAreaCallbackStruct * call_data);

void
                input_callback (Widget widget,
				struct NetworkXswStruct *client_data,
				XmDrawingAreaCallbackStruct * call_data);

/*================================================================== INT ===
* list_select
*
* Called when the user selects a server from the connected server list on
* the left hand side of the MAIN window.
*
* Parameters:
*	o w 	  	(I) - Widget
*	o client_data 	(I) - Client data.
*	o cbs 		(I) - Call back structure.
*
* Algorithm:
*	Obtain and assign server pointer to current_server. Update target
* actual and the toggle button states.
*
* Notes:
*
*---------------------------------------------------------------------------
*/
void
list_select (w, client_data, cbs)
     Widget          w;
     caddr_t        *client_data;
     XmListCallbackStruct *cbs;
{
  Arg             args[9];
  int             argcount;

  char           *text;
  int             i;
  struct NetworkXswStruct *viewing_server = NULL;

  char           *server_message = "Connected to server ...";

  XmStringGetLtoR (cbs -> item, XmSTRING_DEFAULT_CHARSET, &text);

  viewing_server = head_server;


  for (i = 1; i < cbs -> item_position; i++)
    {
      viewing_server = viewing_server -> forward_link;
    }

  current_server = viewing_server;

  selected_server = current_server;


/*  NEED TO UPDATE Target, Actual, and toggle button states.....*/


  display_network_msg (current_server, server_message);

  update_StatPeriod (current_server);
  update_StatCycle (current_server);
  update_Users (current_server);


  for (i = 0; i < Max_state_buttons; i++)
    {
      argcount = 0;

      if (current_server -> TOGGLE_BUTTONS_STATE[i] == 1)
	XtSetArg (args[argcount], XmNset, True);
      else
	XtSetArg (args[argcount], XmNset, False);

      argcount++;
      XtSetValues (TOGGLE_BUTTONS_WIDGETS[i], args, argcount);

    }

/*
 * For now, just set all to false, then set the server current font to true..
 * Should probably maintain a "global" current font which is used to
 * track the state of the current font button......
 */


  for (i = first_font_button; i <= last_font_button; i++)
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, False);
      argcount++;
      XtSetValues (sub_menu_state_list[i], args, argcount);
    }

  argcount = 0;
  XtSetArg (args[argcount], XmNset, True);
  argcount++;
  XtSetValues (sub_menu_state_list[first_font_button +
			   current_server -> current_font], args, argcount);

}
/*================================================================== INT ===
* change_and_update_window_sizes
*
* Called when the window size needs to change. 
*
* Parameters:
*       o SP			(I) - NetworkXswStruct pointer 
*       o button_to_change	(I) - The window button to change. 
*       o y_multiplier		(I) - The Y multiplier  
*
* Algorithm:
*       Free the pixmap for the button, then re-create it to the new size. 
* Set the height, width
*
* Notes:
*
*---------------------------------------------------------------------------
*/
void
change_and_update_window_sizes (SP, button_to_change, y_multiplier)

     struct NetworkXswStruct *SP;
     int             button_to_change;
     int             y_multiplier;

{



  int             i;
  int             current_offset = 0;
  Arg             args[5];
  int             argcount;


  SP -> SEPERATE_WINDOWS_LIST[button_to_change].width =
    (FHEIGHT * y_multiplier);

  XFreePixmap (
		SP -> SEPERATE_WINDOWS_LIST[button_to_change].display,
		SP -> SEPERATE_WINDOWS_LIST[button_to_change].pixmap);


  SP -> SEPERATE_WINDOWS_LIST[button_to_change].pixmap =

    XCreatePixmap (
	XtDisplay (SP -> SEPERATE_WINDOWS_LIST[button_to_change].DrawAreaW),
		    RootWindowOfScreen (
	XtScreen (SP -> SEPERATE_WINDOWS_LIST[button_to_change].DrawAreaW)),
		    SP -> SEPERATE_WINDOWS_LIST[button_to_change].width,
		    SP -> SEPERATE_WINDOWS_LIST[button_to_change].height,
		    DefaultDepthOfScreen (
       XtScreen (SP -> SEPERATE_WINDOWS_LIST[button_to_change].DrawAreaW)));


  argcount = 0;
  XtSetArg (args[argcount], XmNminHeight, (XtArgVal) (FHEIGHT * y_multiplier));
  argcount++;
  XtSetArg (args[argcount], XmNmaxHeight, (XtArgVal) (FHEIGHT * y_multiplier));
  argcount++;
  XtSetArg (args[argcount], XmNheight, (XtArgVal) (FHEIGHT * y_multiplier));
  argcount++;
  XtSetValues (SP -> SEPERATE_WINDOWS_LIST[button_to_change].shell_widget,
	       args, argcount);


  argcount = 0;
  XtSetArg (args[argcount], XmNheight, (XtArgVal) FHEIGHT * y_multiplier);
  argcount++;
  XtSetValues (SP -> SEPERATE_WINDOWS_LIST[button_to_change].DrawAreaW,
	       args, argcount);

/*
  Should  we make a call to XtResizeWidget?????????
 */


/*
  fprintf (stdout, "leaving re-sizeing window......\n");
*/
}

/*================================================================== INT ===
* check_help_and_options 
*
* Called when the user specifies -help on the command line.
*
* Algorithm:
*       If help is on, then display the usage_list.
*	If version is on, then display the revision.
*
* Notes:
*
*---------------------------------------------------------------------------
*/
void
check_help_and_options ()
{
  int             i = 0;

  if (res.help)
    {
      while (usage_list[i].opt != NULL)
	{
	  printf ("%s\n", usage_list[i].opt);
	  i++;
	}
#ifdef TESTING
      gct_writelog ("xswLOG");
#endif
      exit (0);
    }

  if (res.version)
    {
      printf ("%s\n", revision);

#ifdef TESTING
      gct_writelog ("xswLOG");
#endif
      exit (0);
    }


}				/* End of check_help_and_options */

/*================================================================== INT ===
* set_xsw_title 
*
* Called to set the title on the MAIN window. 
*
* Algorithm:
*       if res.title is set, then use it. Otherwize, use the default.
*
* Notes:
*
*---------------------------------------------------------------------------
*/
void
set_xsw_title ()
{
  Arg             args[2];
  int             argcount;

  char            DrawArea_title[128];

  if (res.title)
    strcpy (DrawArea_title, res.title);
  else
    {
      sprintf (DrawArea_title,
	       "Xsw %s",
	       revision);

    }

  argcount = 0;
  XtSetArg (args[argcount], XtNtitle, DrawArea_title);
  argcount++;
  XtSetValues (toplevel, args, argcount);

}				/* End of set_xsw_title */

/*================================================================== INT ===
* set_geometry 
*
* Called to set the geometry. 
*
* Algorithm:
*       
*
* Notes:
*	Hard coded right now. Need to let the user to set it. I have heard
* of problems with 1280-1024 resolutions???????
*
*---------------------------------------------------------------------------
*/
void
set_geometry ()
{

/*
  int             itmp;

  if (res.geom != NULL)
    itmp = XParseGeometry (res.geom,
			   &res.x, &res.y, &res.width, &res.height);
  else
*/
  {
    res.x = 0;
    res.y = 0;
    res.width = (FWIDTH * 80);
/*
 * Need to account for the Menu Bar, then the Ddraw area...
 */

    res.height = (FHEIGHT * 2) + Start_Y_offset;
  }
}				/* End of set_geometry */

#ifdef draw_update_Proc
/*+-------------------------------------------------------------------------
        update_lower_main_info()
--------------------------------------------------------------------------*/
void
update_lower_main_info ()
{
#ifdef DEBUG1
  fprintf (stdout, "In upate_lower_main_info\n");
#endif
  draw_update_Proc (Proc_TLX, Proc_TLY);
}				/* end of update_lower_main_info */

#endif

/*+-------------------------------------------------------------------------
        update_timer_proc(client_data)
--------------------------------------------------------------------------*/
void
update_timer_proc (server_pointer)
     struct NetworkXswStruct *server_pointer;
{

  long            difference;
  struct timeb    start_timer;
  struct timeb    end_timer;
  struct NetworkXswStruct *temp_server;
  struct NetworkXswStruct *temp_serverII = NULL;
  struct NetworkXswStruct *temp_serverIII = NULL;
  int             server_position = 0;

  void            set_update_timer (unsigned long,
				    struct NetworkXswStruct *);

  temp_server = current_server;
  current_server = server_pointer;


  (void) ftime (&start_timer);

/*
  If we havent even selected a server yet, do not update display....
 */

  if (current_server != NULL)
    {
      need_fresh_process_read = 1;
      update_display (1, 0);
      need_fresh_process_read = 0;

    }
/*
 * If the current_server lost it's connection with  xswsrv, then
 * we should clean up and NOT set the update timer!!!!!!
 */

  if (!current_server -> connected)
    {

      advise_user_of_broken_connection (current_server);

      remove_server_from_linked_list (current_server);

      remove_server_callbacks (current_server);

      destroy_server_windows (current_server);

      free_server_memory (current_server);

      server_count--;

      server_position = create_new_server_list (temp_server);

      temp_server = (struct NetworkXswStruct *)
	activate_new_current_server (current_server,
				     temp_server,
				     server_position);

      free (server_pointer);


    }
  else
    {

      (void) ftime (&end_timer);

      difference = delta_msec (end_timer, start_timer);

      if ((int) (current_server -> StatCycle_msec - difference) > 0)
	{
	  set_update_timer (current_server -> StatCycle_msec - difference,
			    server_pointer);

	}
      else
	{
	  set_update_timer (1L, server_pointer);
	}



    }

/*
 * If we lost connection to the "current_server" then this pointer is now
 * garbage. We should have already set current_server to it's NEW postion
 * in the activate_new_current_server......
 *
 * Move the line below to INSIDE the "else" above ....
 */

  current_server = temp_server;

}				/* end of update_timer_proc */

/*+-------------------------------------------------------------------------
        set_update_timer(msec)
--------------------------------------------------------------------------*/
void
set_update_timer (msec, server_pointer)
     unsigned long   msec;
     struct NetworkXswStruct *server_pointer;
{

#ifdef DEBUG2
  fprintf (stdout, "In set_update_timer \n");
#endif

  server_pointer -> timer_id = XtAppAddTimeOut (appcon, msec, update_timer_proc, server_pointer);

#if defined(MyDebug_Timer)
  fprintf (fped, "timer started: event id %08lx for %lu msec\n",
	   (unsigned long) timer_id, msec);
#endif

}				/* end of set_update_timer */

/*+-------------------------------------------------------------------------
        expose_callback(event)
--------------------------------------------------------------------------*/
void
expose_callback (widget, client_data, call_data)
     Widget          widget;
     struct expose_callback_struct *client_data;
     XmDrawingAreaCallbackStruct *call_data;
{



  XExposeEvent   *event = (XExposeEvent *) 0;
  XConfigureEvent *resize_event = (XConfigureEvent *) 0;
  struct NetworkXswStruct *server_pointer =
  (struct NetworkXswStruct *) client_data -> server_pointer;
  int             button = client_data -> button_number;



  int             i;
  long            difference;
  struct NetworkXswStruct *temp_server;
  Dimension       current_width, current_height;

  Arg             args[4];
  int             argcount;


  static struct timeb last_expose_time_read;
  static struct timeb current_expose_time_read;

#ifdef DEBUG1
  fprintf (stdout, "in expose_callback\n");
#endif

/*
  fprintf (stdout, "in expose_callback button= %d\n",button);
*/

  if (call_data)
    event = (XExposeEvent *) call_data -> event;

  if (event && (event -> count != 0))
    return;



/*
  If the event is an Expose, or if the reason is a resize with a valid
  window, then refresh the window(s)
*/

  if ((event -> type == Expose) ||
      ((call_data -> reason == XmCR_RESIZE) && (call_data -> window > 0)))
    {

/*
      fprintf (stdout, "expose or resize\n");
*/


      temp_server = current_server;
      current_server = server_pointer;

/*
 * If we scroll_bar_expose is true, then we just had a scroll bar expose and
 * the scroll bar widget will take care of refreshing the screen.....
 */


      if ((event -> type == Expose) && (call_data -> reason == XmCR_EXPOSE))
	{

/*
	  fprintf (stdout, "expose\n");
*/

	  XCopyArea (
		      call_data -> event -> xany.display,
		      current_server -> SEPERATE_WINDOWS_LIST[button].pixmap,
		      call_data -> event -> xany.window,
		      current_server -> SEPERATE_WINDOWS_LIST[button].gc,
		      event -> x,
		      event -> y,
		      event -> width,
		      event -> height,
		      event -> x,
		      event -> y);
/*
	  fprintf (stdout, "finished XCopyArea\n");
*/

	}
      else
/*
 * Check to see if we have been resized....
 *
 * If so then we need to do a little work. If we are resized larger, then
 * a expose event will take place. If we are resized smaller, then NO expose
 * event takes place.
 *
 * So, if we want to minimize things, we would set a flag if we are resized
 * and check on the expose if we have just resize, if so , then have the
 * expose just exit....
 *
 * This is done becuase the resize literally re-draws the entire window. This
 * is because we use the size of the window for limiting some of the drawing..
 * I.e. CPU, WAIT, CACHE scales are drawn with the right side == 100 percent...
 *
 */
      if (call_data -> reason == XmCR_RESIZE)
	{

/*
  fprintf (stdout, "resize\n");
*/

	  if (call_data)
	    resize_event = (XConfigureEvent *) call_data -> event;


/*
 * Need to
 *
 * 	1) Clear the drawing areas....
 *	2) re-draw the static areas, I.e. the literals....
 *	3) update the window ......
 */

	  argcount = 0;
	  XtSetArg (args[argcount], XmNwidth, &current_width);
	  argcount++;
	  XtSetArg (args[argcount], XmNheight, &current_height);
	  argcount++;
	  XtGetValues (widget, args, argcount);


/*
 * Since we got a resize event, we must have grown, but only free and
 * re-initialize if we are growing larger than the current default....
 *
 * Thus, we keep the Largest size....
 */
/*
fprintf (stdout, "Max  Height = %d,Max  Width = %d\n",
  current_height >
	current_server -> SEPERATE_WINDOWS_LIST[button].pixmap_cur_height,
  current_width >
	current_server -> SEPERATE_WINDOWS_LIST[button].pixmap_cur_width);
*/

	  if ((current_width > current_server -> SEPERATE_WINDOWS_LIST[button].pixmap_cur_width) || (
												      current_height > current_server -> SEPERATE_WINDOWS_LIST[button].pixmap_cur_height))

	    {

/*
	      fprintf(stdout,"going to grow: width = %d\n",
	      current_server -> SEPERATE_WINDOWS_LIST[button].pixmap_cur_width);
*/

	      current_server ->
		SEPERATE_WINDOWS_LIST[button].pixmap_cur_width = current_width;
	      current_server ->
		SEPERATE_WINDOWS_LIST[button].pixmap_cur_height = current_height;


	      XFreePixmap (
		    current_server -> SEPERATE_WINDOWS_LIST[button].display,
		    current_server -> SEPERATE_WINDOWS_LIST[button].pixmap);

	      current_server -> SEPERATE_WINDOWS_LIST[button].pixmap =
		XCreatePixmap (
				XtDisplay (current_server -> SEPERATE_WINDOWS_LIST[button].DrawAreaW),
				RootWindowOfScreen (
						     XtScreen (current_server -> SEPERATE_WINDOWS_LIST[button].DrawAreaW)),
				current_width,
				current_height,
				DefaultDepthOfScreen (
						       XtScreen (current_server -> SEPERATE_WINDOWS_LIST[button].DrawAreaW)));

	    }

/*
 * Need to determine if the width and/or height are valid.....
 * THEY SHOULD ALWAYS BE VALID.....!!!!!! SHOULD NOT HAVE TO CHECK
 */

/*
fprintf (stdout, "Height = %d, Width = %d\n", current_height, current_width);
fprintf (stdout, "O Height = %d,O Width = %d\n",
		current_server -> SEPERATE_WINDOWS_LIST[button].height,
		current_server -> SEPERATE_WINDOWS_LIST[button].width);
*/


	  if ((current_width > 0) && (current_width <= DisplayWidth (display, screen)))
	    current_server -> SEPERATE_WINDOWS_LIST[button].width = current_width;

	  if ((current_height > 0) && (current_height <= DisplayHeight (display, screen)))
	    current_server -> SEPERATE_WINDOWS_LIST[button].height = current_height;


	  XClearWindow (
		    current_server -> SEPERATE_WINDOWS_LIST[button].display,
		    current_server -> SEPERATE_WINDOWS_LIST[button].window);

	  XSetForeground (
		    current_server -> SEPERATE_WINDOWS_LIST[button].display,
			 current_server -> SEPERATE_WINDOWS_LIST[button].gc,
			   background);

	  XFillRectangle (
		    current_server -> SEPERATE_WINDOWS_LIST[button].display,
		     current_server -> SEPERATE_WINDOWS_LIST[button].pixmap,
			 current_server -> SEPERATE_WINDOWS_LIST[button].gc,
			   0,
			   0,
		      current_server -> SEPERATE_WINDOWS_LIST[button].width,
		    current_server -> SEPERATE_WINDOWS_LIST[button].height);

	  draw_display (first_expose, call_data -> window);
	  update_screen (call_data -> window, 0);

	}


      current_server = temp_server;
/*
  fprintf (stdout, "leaving expose\n");
*/

    }

/*
  fprintf (stdout, "leaving expose_callback\n");
*/
}				/* end of expose_callback */

void
set_port (w, client_data, cbs)
     Widget          w;
     caddr_t        *client_data;
     XmSelectionBoxCallbackStruct *cbs;
{
  XmStringContext context;
  XmStringCharSet charset;
  XmStringDirection dir;
  Boolean         seperator;
  char           *text;
  int             temp_port;

/*
  argcount = 0;
  XtSetArg (args[argcount], XmNset, False);
  argcount++;
  XtSetValues (sub_menu_state_list[BUTTON_set_port], args, argcount);
*/

  XmStringInitContext (&context, cbs -> value);

  XmStringGetNextSegment (context, &text, &charset, &dir, &seperator);

  sscanf (text, "%d", &temp_port);

  configured_port = temp_port;

  XtDestroyWidget (XtParent (w));

}

/*+-------------------------------------------------------------------------
        quit_now()
--------------------------------------------------------------------------*/
void
quit_now ()
{
  struct NetworkXswStruct *temp_server = NULL;

  int             j;

  XSync (display, False);

  temp_server = head_server;


/*
 * Need to actually free up things... Expecially Pixmap memory, since
 * pixmap memory is actually your X Server MEMORY.......
 *
 * FIX THIS
 */

  if (temp_server != NULL)
    {

      while (temp_server != NULL)
	{
	  xsw_write (temp_server,
		     temp_server -> FileDescriptor,
		     send_quitting_data,
		     sizeof (int));

	  for (j = 0; j < temp_server -> current_items; j++)
	    XFreePixmap (
			  temp_server -> SEPERATE_WINDOWS_LIST[
			 temp_server -> DISPLAY_LIST[j].button_num].display,
			  temp_server -> SEPERATE_WINDOWS_LIST[
			 temp_server -> DISPLAY_LIST[j].button_num].pixmap);

	  temp_server = temp_server -> forward_link;
	}
      sleep (1);

    }

  leave (0);
}				/* end of quit_now */

/*+-------------------------------------------------------------------------
        delta_StatCycle(delta_msec)
--------------------------------------------------------------------------*/
void
delta_StatCycle (delta_msec)
     long            delta_msec;
{
  int             i;
  unsigned long   new_msec;

  if ((current_server -> StatCycle_msec < 1000L) && (delta_msec > 0))
    {
      new_msec = current_server -> StatCycle_msec + 100L;
    }
  else if ((current_server -> StatCycle_msec <= 1000L) && (delta_msec < 0))
    {
      new_msec = current_server -> StatCycle_msec - 100L;
    }
  else
    {
      new_msec = current_server -> StatCycle_msec + (unsigned) delta_msec;
    }


  if ((new_msec < StatCycle_msecMin) || (new_msec > StatCycle_msecMax))
    {
      fputc (7, stderr);
      return;
    }

  current_server -> StatCycle_msec = new_msec;
  update_StatCycle (current_server);

  for (i = 0; i < current_server -> current_items; i++)
    {
      switch (current_server -> DISPLAY_LIST[i].button_num)
	{
	case BUTTON_cpu:
	  draw_CpuScale_literals (current_server);

	  XCopyArea (
		current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].display,
		 current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].pixmap,
		 current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].window,
	       current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].gc, 0, 0,
		  current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].width,
		 current_server -> SEPERATE_WINDOWS_LIST[BUTTON_cpu].height,
		      0, 0);




	  break;
	case BUTTON_wait:
	  draw_WaitScale_literals (current_server);
	  XCopyArea (
	       current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].display,
		current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].pixmap,
		current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].window,
	      current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].gc, 0, 0,
		 current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].width,
		current_server -> SEPERATE_WINDOWS_LIST[BUTTON_wait].height,
		      0, 0);

	  break;

	}

    }

}				/* end of delta_StatCycle */

void
Menu_bar_mode_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{

  Arg             args[2];
  int             argcount;
  XmString        message;
  Widget          dialog;
  int             button_num = (int) client_data;


  if (current_server != NULL)
    {
      toggle_button_current_server = current_server;
      set_display_mode (client_data);
      toggle_button_current_server = NULL;
    }
  else
    {
/* Create popup which states that you must first select a server */


      message = XmStringCreateSimple ("Must select server first");

      argcount = 0;
      XtSetArg (args[argcount], XmNmessageString, message);
      argcount++;
      dialog = XmCreateMessageDialog (toplevel, "message", args, argcount);
      XmStringFree (message);

      XtAddCallback (dialog, XmNokCallback, toggle_button_reset, client_data);
      XtAddCallback (dialog, XmNcancelCallback, toggle_button_reset, client_data);

      XtUnmanageChild (XmMessageBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

      XtManageChild (dialog);

    }

}

void
button_up_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[2];
  int             argcount;
  XmString        message;
  Widget          dialog;

  if (current_server != NULL)
    {
      delta_StatCycle (+1000L);
    }
  else
    {
      message = XmStringCreateSimple ("Must select server first");

      argcount = 0;
      XtSetArg (args[argcount], XmNmessageString, message);
      argcount++;
      dialog = XmCreateMessageDialog (toplevel, "message", args, argcount);
      XmStringFree (message);

      XtUnmanageChild (XmMessageBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

      XtManageChild (dialog);


    }

}

void
button_down_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[2];
  int             argcount;
  XmString        message;
  Widget          dialog;


  if (current_server != NULL)
    {
      delta_StatCycle (-1000L);
    }
  else
    {
      message = XmStringCreateSimple ("Must select server first");

      argcount = 0;
      XtSetArg (args[argcount], XmNmessageString, message);
      argcount++;
      dialog = XmCreateMessageDialog (toplevel, "message", args, argcount);
      XmStringFree (message);

      XtUnmanageChild (XmMessageBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

      XtManageChild (dialog);

    }

}




void
button_1_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[32];
  int             argcount;


  if (client_data != default_button_1_mode)
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, False);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_1_increase +
				       default_button_1_mode], args,
		   argcount);

      default_button_1_mode = client_data;
    }
  else
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, True);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_1_increase +
				       default_button_1_mode], args,
		   argcount);


    }

}
void
button_2_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[32];
  int             argcount;
  if (client_data != default_button_2_mode)
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, False);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_2_increase +
				       default_button_2_mode], args,
		   argcount);

      default_button_2_mode = client_data;
    }
  else
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, True);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_2_increase +
				       default_button_2_mode], args,
		   argcount);


    }

}

void
port_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[32];
  int             argcount;

  XmString        message;
  Widget          dialog;
  XmString        prompt = XmStringCreateSimple ("Port to use:");


  argcount = 0;
  XtSetArg (args[argcount], XmNtitle, "Port?");
  argcount++;
  XtSetArg (args[argcount], XmNselectionLabelString, prompt);
  argcount++;
  XtSetArg (args[argcount], XmNautoUnmanage, False);
  argcount++;
  dialog = XmCreatePromptDialog (toplevel, "Port?", args, argcount);
  XmStringFree (prompt);

  XtAddCallback (dialog, XmNokCallback, set_port, NULL);

  XtAddCallback (dialog, XmNcancelCallback, XtDestroyWidget, NULL);

  XtUnmanageChild (XmSelectionBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

  XtManageChild (dialog);
  XtPopup (XtParent (dialog), XtGrabNone);

}

void
button_3_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{
  Arg             args[32];
  int             argcount;
  if (client_data != default_button_3_mode)
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, False);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_3_increase +
				       default_button_3_mode], args,
		   argcount);

      default_button_3_mode = client_data;
    }
  else
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNset, True);
      argcount++;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;

      XtSetValues (sub_menu_state_list[BUTTON_button_3_increase +
				       default_button_3_mode], args,
		   argcount);


    }

}


void
change_font_callback (widget, client_data, call_data)
     Widget          widget;
     int            *client_data;
     caddr_t         call_data;
{

  int             result = 0;

  result = change_font (client_data);

  if (result == 1)
    current_font = client_data;

}

/*+-------------------------------------------------------------------------
        input_callback_key_event(widget,client_data,call_data)
--------------------------------------------------------------------------*/
void
input_callback_key_event (widget, client_data, call_data)
     Widget          widget;
     caddr_t         client_data;
     XmDrawingAreaCallbackStruct *call_data;
{
  XKeyEvent      *event = (XKeyEvent *) (call_data -> event);
  int             numkeys;
  KeySym          keysym;
  char            kbuf[8];

#ifdef DEBUG1
  fprintf (stdout, "in input Callback\n");
#endif

  numkeys = XLookupString (event, kbuf, sizeof (kbuf),
			   &keysym, (XComposeStatus *) 0);

  if ((event -> type == KeyPress) && (numkeys == 1))
    {

      got_key_event = 1;
      switch (kbuf[0])
	{
	case 'C':
	case 'c':
	  set_display_mode (BUTTON_cpu);
	  break;
	case 'W':
	case 'w':
	  set_display_mode (BUTTON_wait);
	  break;
	case 'A':
	case 'a':
	  set_display_mode (BUTTON_cache);
	  break;
	case 'O':
	case 'o':
	  set_display_mode (BUTTON_other);
	  break;
	case 'E':
	case 'e':
	  set_display_mode (BUTTON_mem);
	  break;
	case 'P':
	case 'p':
	  set_display_mode (BUTTON_ps_cpu);
	  break;
	case 'I':
	case 'i':
	  set_display_mode (BUTTON_ps_io);
	  break;
	case 'M':
	case 'm':
	  set_display_mode (BUTTON_ps_mem);
	  break;
	case 'T':
	case 't':
	  set_display_mode (BUTTON_streams);
	  break;
	case 'N':
	case 'n':
	  set_display_mode (BUTTON_nfsstat);
	  break;
	case 'S':
	case 's':
	  set_display_mode (BUTTON_sysinfo);
	  break;
	case 'V':
	case 'v':
	  set_display_mode (BUTTON_tune_var);
	  break;
	case 'D':
	case 'd':
	  set_display_mode (BUTTON_dev_stats);
	  break;
	case 'K':
	case 'k':
	  set_display_mode (BUTTON_disk_space);
	  break;
	case '+':
	  if (current_server != NULL)
	    delta_StatCycle (+1000L);
	  break;
	case '-':
	  if (current_server != NULL)
	    delta_StatCycle (-1000L);
	  break;
	default:
	  fputs ("\7", stderr);	/* Ackkkkk -- lazy */
	}
      got_key_event = 0;
    }

}				/* end of input_callback_key_event */

/*+-------------------------------------------------------------------------
        input_callback_button_event(widget,client_data,call_data)
--------------------------------------------------------------------------*/
void
input_callback_button_event (widget, client_data, call_data)
     Widget          widget;
     caddr_t         client_data;
     XmDrawingAreaCallbackStruct *call_data;
{
  XButtonEvent   *event = (XButtonEvent *) (call_data -> event);
  int             button_number = 0;

#ifdef DEBUG1
  fprintf (stdout, "in input_callback_button_event\n");
#endif

  switch (event -> button)
    {
    case Button1:

         switch (default_button_1_mode)
            {
            case 0:
              if (current_server != NULL)
                delta_StatCycle (+1000L);
              break;

            case 1:
              if (current_server != NULL)
                delta_StatCycle (-1000L);
              break;
            case 2:
              create_color_help (event -> window);
              break;
            }
          break;

    case Button2:
      switch (default_button_2_mode)
	{
	case 0:
	  if (current_server != NULL)
	    delta_StatCycle (+1000L);
	  break;

	case 1:
	  if (current_server != NULL)
	    delta_StatCycle (-1000L);
	  break;
	case 2:
	  create_color_help (event -> window);
	  break;
	}

      break;
    case Button3:
      switch (default_button_3_mode)
	{
	case 0:
	  if (current_server != NULL)
	    delta_StatCycle (+1000L);
	  break;

	case 1:
	  if (current_server != NULL)
	    delta_StatCycle (-1000L);
	  break;
	case 2:
	  create_color_help (event -> window);
	  break;
	}

      break;
    }

}				/* end of input_callback_button_event */

/*+-------------------------------------------------------------------------
        input_callback(widget,client_data,call_data)
--------------------------------------------------------------------------*/
void
input_callback (widget, client_data, call_data)
     Widget          widget;
     struct NetworkXswStruct *client_data;
     XmDrawingAreaCallbackStruct *call_data;
{
  struct NetworkXswStruct *temp_server;

#ifdef DEBUG
  fprintf (stdout, "in input_callback\n");
#endif

  input_callback_current_server = current_server;
  current_server = client_data;

  switch (call_data -> event -> type)
    {
    case KeyPress:
      input_callback_key_event (widget, client_data, call_data);
      break;
    case KeyRelease:
      break;
    case ButtonPress:
      input_callback_button_event (widget, client_data, call_data);

      break;
    case ButtonRelease:

      if (doing_help == 1)
	{
	  XtPopdown (current_server -> 
	SEPERATE_WINDOWS_LIST[current_colorHelp_button_num].colorHelp.toplevel);
	}
      doing_help = 0;

      break;
    default:
      current_server = temp_server;
      return;
    }

  current_server = input_callback_current_server;
}				/* end of input_callback */


char            cpu_string[] = "CPU";
char            wait_string[] = "Wait";
char            cache_string[] = "Cache";
char            other_string[] = "Other";
char            mem_string[] = "MEM";
char            ps_cpu_string[] = "PS CPU";
char            ps_io_string[] = "PS I/O";
char            ps_mem_string[] = "PS MEM";
char            streams_string[] = "Streams";
char            nfsstat_string[] = "NFS Stats";
char            devstats_string[] = "Dev. Stats";
char            sysinfo_string[] = "Sysinfo";
char            vbt_string[] = "VBT";
char            quit_string[] = "Exit";

char            connect_to_server_string[] = "Connect Server";
char            disconnect_to_server_string[] = "Disconnect Server";

static xs_menu_struct file_menu_data[] =
{
  {connect_to_server_string, 'C', connect_server, NULL, NULL, 0, NULL,-1},
  {disconnect_to_server_string, 'D', disconnect_server, NULL, NULL, 0, NULL,-1},
  {quit_string, 'x', quit_now, NULL, NULL, 0, NULL,-1}
};

char            font_Default_string[] = "Default";
char            font_6x10_string[] = "6x10";
char            font_6x12_string[] = "6x12";
char            font_6x13_string[] = "6x13";
char            font_8x13_string[] = "8x13";
char            font_9x15_string[] = "8x15";
char            font_ibm10x20_string[] = "ibm10x20";

static xs_menu_struct Font_list_data[] =
{
  {font_Default_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_Default - first_font_button), NULL, 0, NULL,-1},
  {font_6x10_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_6x10 - first_font_button), NULL, 0, NULL,-1},
  {font_6x12_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_6x12 - first_font_button), NULL, 0, NULL,-1},
  {font_6x13_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_6x13 - first_font_button), NULL, 0, NULL,-1},
  {font_8x13_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_8x13 - first_font_button), NULL, 0, NULL,-1},
  {font_9x15_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_9x15 - first_font_button), NULL, 0, NULL,-1},
  {font_ibm10x20_string, '\0', change_font_callback,
   (caddr_t) (BUTTON_ibm10x20 - first_font_button), NULL, 0, NULL,-1},
};


char            increase_string1[] = "Increase Interval";
char            decrease_string1[] = "Decrease Interval";
char            popup_string1[] = "Popup Color Help";
char            increase_string2[] = "Increase Interval ";
char            decrease_string2[] = "Decrease Interval ";
char            popup_string2[] = "Popup Color Help ";
char            increase_string3[] = "Increase Interval  ";
char            decrease_string3[] = "Decrease Interval  ";
char            popup_string3[] = "Popup Color Help  ";

static xs_menu_struct button_1_list_data[] =
{
  {increase_string1, 'I', button_1_callback,
   (caddr_t) (0), NULL, 0, NULL,-1},
  {decrease_string1, 'D', button_1_callback,
   (caddr_t) (1), NULL, 0, NULL,-1},
  {popup_string1, 'P', button_1_callback,
   (caddr_t) (2), NULL, 0, NULL,-1}
};

static xs_menu_struct button_2_list_data[] =
{
  {increase_string2, 'I', button_2_callback,
   (caddr_t) (0), NULL, 0, NULL,-1},
  {decrease_string2, 'D', button_2_callback,
   (caddr_t) (1), NULL, 0, NULL,-1},
  {popup_string2, 'P', button_2_callback,
   (caddr_t) (2), NULL, 0, NULL,-1}
};

static xs_menu_struct button_3_list_data[] =
{
  {increase_string3, 'I', button_3_callback,
   (caddr_t) (0), NULL, 0, NULL,-1},
  {decrease_string3, 'D', button_3_callback,
   (caddr_t) (1), NULL, 0, NULL,-1},
  {popup_string3, 'P', button_3_callback,
   (caddr_t) (2), NULL, 0, NULL,-1}
};



static xs_menu_struct Buttons_list_data[] =
{
  {"Button 1", '1', NULL, NULL, button_1_list_data,
   XtNumber (button_1_list_data), NULL,-1},
  {"Button 2", '2', NULL, NULL, button_2_list_data,
   XtNumber (button_2_list_data), NULL,-1},
  {"Button 3", '3', NULL, NULL, button_3_list_data,
   XtNumber (button_3_list_data), NULL,-1}

};

static xs_menu_struct options_menu_data[] =
{
  {"Font Size", 'F', NULL, NULL, Font_list_data, XtNumber (Font_list_data), NULL,-1},
  {"Button Action", 'B', NULL, NULL, Buttons_list_data, XtNumber (Buttons_list_data), NULL,-1}
};

char            general_help_string[] = "General Display Information";
char            option_help_string[] = "Options";
char            known_help_string[] = "Known Problems";

static xs_menu_struct help_menu_data[] =
{
  {general_help_string, 'G', help_general, NULL, NULL, 0, NULL,-1},
  {option_help_string, 'O', help_options, NULL, NULL, 0, NULL,-1}
/*
  {known_help_string, 'K', help_problems, NULL, NULL, 0, NULL,-1},
*/
};

static xs_menu_struct menu_bar_data[] =
{
  {"File", 'F', NULL, NULL, file_menu_data, XtNumber (file_menu_data), NULL,-1},
  {"Options", 'O', NULL, NULL, options_menu_data, XtNumber (options_menu_data), NULL,-1},
  {"Help", 'H', NULL, NULL, help_menu_data, XtNumber (help_menu_data), NULL,-1}
};

void
initialize_window_data ()

{
  int             i;

  for (i = 0; i < Max_state_buttons; i++)
    {

      switch (i)

	{
	case BUTTON_cpu:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen) / 2;
	  break;
	case BUTTON_wait:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen) / 2;
	  break;
	case BUTTON_cache:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen) / 2;
	  break;
	case BUTTON_other:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen) / 2;
	  break;
	case BUTTON_ps_cpu:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    4 * DisplayHeight (display, screen);
	  break;
	case BUTTON_ps_io:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    4 * DisplayHeight (display, screen);
	  break;
	case BUTTON_ps_mem:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    4 * DisplayHeight (display, screen);
	  break;
	case BUTTON_streams:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height = DisplayHeight (display, screen);
	  break;
	case BUTTON_nfsstat:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height = DisplayHeight (display, screen);
	  break;
	case BUTTON_sysinfo:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height = DisplayHeight (display, screen);
	  break;
	case BUTTON_tune_var:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height = DisplayHeight (display, screen);
	  break;
	case BUTTON_dev_stats:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height = DisplayHeight (display, screen);
	  break;
	case BUTTON_mem:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen) / 2;
	  break;
	case BUTTON_disk_space:
	  window_init_data[i].Drawing_Width = DisplayWidth (display, screen);
	  window_init_data[i].Drawing_Height =
	    DisplayHeight (display, screen);
	  break;

	}


    }



}

catch_signal ()
{
/*
  fprintf(stdout,"current_server -> StatPeriod_msec/1000 = %5.2f",
		current_server -> StatPeriod_msec /1000);
  fprintf(stdout,"current_server -> hz = %5.2f",
		current_server -> hz);
*/

}

char           *
GetServerName (char *serverList)
{

  char           *temp;


  return (strtok (serverList, ":"));

}

GetServerOptions (char *host_name, char *serverOptions)
{

  char           *temp;
  char           *result;

  while ((temp = strtok (NULL, ",")) != NULL)
    {


      if (strcmp (temp, "cpu") == 0)
	{
	  set_display_mode (BUTTON_cpu);
	}
      else if (strcmp (temp, "wait") == 0)
	{
	  set_display_mode (BUTTON_wait);
	}
      else if (strcmp (temp, "cache") == 0)
	{
	  set_display_mode (BUTTON_cache);
	}
      else if (strcmp (temp, "other") == 0)
	{
	  set_display_mode (BUTTON_other);
	}
      else if (strcmp (temp, "pscpu") == 0)
	{
	  set_display_mode (BUTTON_ps_cpu);
	}
      else if (strcmp (temp, "psio") == 0)
	{
	  set_display_mode (BUTTON_ps_io);
	}
      else if (strcmp (temp, "psmem") == 0)
	{
	  set_display_mode (BUTTON_ps_mem);
	}
      else if (strcmp (temp, "streams") == 0)
	{
	  set_display_mode (BUTTON_streams);
	}
      else if (strcmp (temp, "nfs") == 0)
	{
	  set_display_mode (BUTTON_nfsstat);
	}
      else if (strcmp (temp, "sysinfo") == 0)
	{
	  set_display_mode (BUTTON_sysinfo);
	}
      else if (strcmp (temp, "vbt") == 0)
	{
	  set_display_mode (BUTTON_tune_var);
	}
      else if (strcmp (temp, "device") == 0)
	{
	  set_display_mode (BUTTON_dev_stats);
	}
      else if (strcmp (temp, "mem") == 0)
	{
	  set_display_mode (BUTTON_mem);
	}
      else if (strcmp (temp, "diskspace") == 0)
	{
	  set_display_mode (BUTTON_disk_space);
	}
      else
	fprintf (stdout,
	     "Unknown option \"%s\" for server \"%s\" \n", temp, host_name);

    }

}

void
build_auto_connect_list (char *serverOptions)

{

  char           *host_name;
  int             sync_read;
  int             result;
  int             dettache_from_server = send_quitting_data;
  int             continue_server = send_continue;
  int             uname_size = 0;
  int             got_permission = 0;


  configured_port = 2793;

  host_name = GetServerName (serverOptions);

  if (host_name == NULL)
    {
      fprintf (stdout, "No server specified\n");
      return;
    }

  RemoteHostInfo = gethostbyname (host_name);

  if (RemoteHostInfo == NULL)
    fprintf (stdout, "Host name lookup failure -> %s\n", host_name);
  else if (Connection () == 1)
    CheckSyncAndSecurity (host_name, serverOptions, NULL);
  else
    fprintf (stdout, "Could NOT CONNECT to server -> %s\n", host_name);

}

/*+-------------------------------------------------------------------------
        main(argc,argv)
--------------------------------------------------------------------------*/
void
main (argc, argv)
     int             argc;
     char           *argv[];
{
  Arg             args[32];
  int             argcount;
  char           *progname = strdup (basename (argv[0]));
  char           *basename ();
  int             i;

  static XmStringCharSet charset = (XmStringCharSet) XmSTRING_DEFAULT_CHARSET;


/*
 * initialize
 */

#ifdef TESTING
  gct_readlog ("xswLOG");
#endif

  setbuf (stdout, NULL);

  sigset (SIGFPE, catch_signal);

/*
  sigset (SIGALRM, catch_alarm);
*/

  xsw_basename = strdup (basename (argv[0]));

/*
 * Get other options manually
 */

  for (argcount = 1; argcount < argc; argcount++)
    {
      if (!strcmp (argv[argcount], "-u"))
	{
	  if ((argcount + 1) < argc)
	    {
	      kernel = argv[argcount + 1];
	    }
	}



    }

  argcount = 0;
  XtSetArg (args[argcount], XmNallowShellResize, True);
  argcount++;

  toplevel = XtAppInitialize (&appcon, "Xsw",
			      optionDescList, XtNumber (optionDescList),
			      &argc, argv, NULL,
			      args, argcount);


  display = XtDisplay (toplevel);



  XtGetApplicationResources (toplevel, &res,
			     appResources, XtNumber (appResources),
			     NULL, 0);

  check_help_and_options ();

  screen = DefaultScreen (display);
  cmap = DefaultColormap (display, screen);
  gc = DefaultGC (display, screen);


/*
 * Create a MainWindow widget so that attachments are done for us.
 */


  argcount = 0;
  main_window_widget = XmCreateMainWindow (toplevel,
					   "mainWindow",
					   args,
					   argcount);


/*
 * Create the application menu bar
 */

  argcount = 0;
  menu_bar = XmCreateMenuBar (main_window_widget, "menu_bar", args, argcount);
  xs_create_menu_buttons (NULL, menu_bar, menu_bar_data,
			  XtNumber (menu_bar_data),0,NULL);

  check_fonts ();

  init_color ();

  set_geometry ();


  for (i = BUTTON_button_1_increase; i <= BUTTON_button_3_popup; i++)
    {
      argcount = 0;
      XtSetArg (args[argcount], XmNindicatorType, XmONE_OF_MANY);
      argcount++;
      XtSetValues (sub_menu_state_list[i], args,
		   argcount);

    }

  argcount = 0;
  XtSetArg (args[argcount], XmNset, True);
  argcount++;
  XtSetValues (sub_menu_state_list[BUTTON_button_1_increase +
				   default_button_1_mode], args, argcount);

  argcount = 0;
  XtSetArg (args[argcount], XmNset, True);
  argcount++;
  XtSetValues (sub_menu_state_list[BUTTON_button_2_increase +
				   default_button_2_mode], args, argcount);

  argcount = 0;
  XtSetArg (args[argcount], XmNset, True);
  argcount++;
  XtSetValues (sub_menu_state_list[BUTTON_button_3_increase +
				   default_button_3_mode], args, argcount);

/*
 * Now that we have the fonts and geometry figrued out, set up the width
 * and height of the main widget.
 */

  argcount = 0;
  XtSetArg (args[argcount], XmNminWidth, (XtArgVal) 6 * 105);
  argcount++;
  XtSetArg (args[argcount], XmNminHeight, (XtArgVal) 12 * 15);
  argcount++;
  XtSetArg (args[argcount], XmNmaxWidth, (XtArgVal) 6 * 105);
  argcount++;
  XtSetArg (args[argcount], XmNmaxHeight, (XtArgVal) 12 * 15);
  argcount++;
  XtSetArg (args[argcount], XmNx, (XtArgVal) res.x);
  argcount++;
  XtSetArg (args[argcount], XmNy, (XtArgVal) res.y);
  argcount++;
  XtSetArg (args[argcount], XmNwidth, (XtArgVal) 6 * 105);
  argcount++;
  XtSetArg (args[argcount], XmNheight, (XtArgVal) 12 * 15);
  argcount++;
  XtSetValues (toplevel, args, argcount);



/*
 * Create Drawing Area
 */

  argcount = 0;
  DrawAreaW = XmCreateDrawingArea (main_window_widget, "xsw-draw",
				   args, argcount);

  argcount = 0;
  frame = XmCreateForm (main_window_widget, "form", args, argcount);
  XtManageChild (frame);

  argcount = 0;
  server_label = XmCreateLabel (frame, "SERVER", args, argcount);
  XtManageChild (server_label);

  argcount = 0;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_POSITION);
  argcount++;
  XtSetArg (args[argcount], XmNleftPosition, 5);
  argcount++;
  XtSetValues (server_label, args, argcount);

  argcount = 0;
  XtSetArg (args[argcount], XmNselectionPolicy, XmBROWSE_SELECT);
  argcount++;
  XtSetArg (args[argcount], XmNscrollingPolicy, XmAUTOMATIC);
  argcount++;
  XtSetArg (args[argcount], XmNvisibleItemCount, 10);
  argcount++;
  XtSetArg (args[argcount], XmNvisual, XmVARIABLE);
  argcount++;
  swindow = XmCreateScrolledList (frame, "swindow", args, argcount);
  XtManageChild (swindow);

  XtAddCallback (swindow, XmNbrowseSelectionCallback, list_select, NULL);

  argcount = 0;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, server_label);
  argcount++;
  XtSetArg (args[argcount], XmNrightAttachment, XmATTACH_POSITION);
  argcount++;
  XtSetArg (args[argcount], XmNrightPosition, 20);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_FORM);
  argcount++;
  XtSetArg (args[argcount], XmNbottomAttachment, XmATTACH_FORM);
  argcount++;
  XtSetValues (XtParent (swindow), args, argcount);

  argcount = 0;
  message_text_widget = XmCreateText (frame, "message_field", args, argcount);
  XtManageChild (message_text_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNrightAttachment, XmATTACH_FORM);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, swindow);
  argcount++;
  XtSetArg (args[argcount], XmNrows, 1);
  argcount++;
  XtSetArg (args[argcount], XmNeditable, False);
  argcount++;
  XtSetArg (args[argcount], XmNautoShowCursorPosition, True);
  argcount++;
  XtSetArg (args[argcount], XmNcursorPositionVisible, False);
  argcount++;
  XtSetValues (message_text_widget, args, argcount);

  argcount = 0;
  argcount = 0;
  XtSetArg (args[argcount], XmNmarginHeight, 4);
  target_interval_widget = XmCreateLabel (frame, "Target: ",
					  args, argcount);
  XtManageChild (target_interval_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNheight, 6 * 2.5);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, swindow);
  argcount++;
  XtSetValues (target_interval_widget, args, argcount);

  argcount = 0;
  target_interval_text_widget = XmCreateText (frame, "TargetTextWidget",
					      args, argcount);
  XtManageChild (target_interval_text_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNcolumns, 8);
  argcount++;
  XtSetArg (args[argcount], XmNrows, 1);
  argcount++;
  XtSetArg (args[argcount], XmNeditable, False);
  argcount++;
  XtSetArg (args[argcount], XmNautoShowCursorPosition, True);
  argcount++;
  XtSetArg (args[argcount], XmNcursorPositionVisible, False);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, target_interval_widget);
  argcount++;
  XtSetValues (target_interval_text_widget, args, argcount);

  argcount = 0;
  XtSetArg (args[argcount], XmNheight, 17);
  argcount++;
  target_button_up = XtCreateManagedWidget ("ButtonUp", xmArrowButtonWidgetClass,
					    frame, args, argcount);

  XtAddCallback (target_button_up, XmNactivateCallback,
		 button_up_callback, NULL);

  argcount = 0;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, target_interval_text_widget);
  argcount++;
  XtSetValues (target_button_up, args, argcount);

  argcount = 0;
  target_button_down = XtCreateManagedWidget ("ButtonDown",
					      xmArrowButtonWidgetClass,
					      frame, args, argcount);

  XtAddCallback (target_button_down, XmNactivateCallback,
		 button_down_callback, NULL);

  argcount = 0;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, target_button_up);
  argcount++;
  XtSetArg (args[argcount], XmNarrowDirection, XmARROW_DOWN);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, target_interval_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNheight, 17);
  argcount++;
  XtSetValues (target_button_down, args, argcount);


  argcount = 0;
  actual_interval_widget = XmCreateLabel (frame, "Actual  : ",
					  args, argcount);
  XtManageChild (actual_interval_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNheight, 6 * 2.5);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, target_button_up);
  argcount++;
  XtSetValues (actual_interval_widget, args, argcount);

  argcount = 0;
  actual_interval_text_widget = XmCreateText (frame, "ActualTextWidget",
					      args, argcount);
  XtManageChild (actual_interval_text_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNcolumns, 8);
  argcount++;
  XtSetArg (args[argcount], XmNrows, 1);
  argcount++;
  XtSetArg (args[argcount], XmNeditable, False);
  argcount++;
  XtSetArg (args[argcount], XmNautoShowCursorPosition, True);
  argcount++;
  XtSetArg (args[argcount], XmNcursorPositionVisible, False);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, actual_interval_widget);
  argcount++;
  XtSetValues (actual_interval_text_widget, args, argcount);

  argcount = 0;
  user_widget = XmCreateLabel (frame, "User(s): ",
			       args, argcount);
  XtManageChild (user_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNheight, 6 * 2.5);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, actual_interval_text_widget);
  argcount++;
  XtSetValues (user_widget, args, argcount);

  argcount = 0;
  user_text_widget = XmCreateText (frame, "UserTextWidget",
				   args, argcount);
  XtManageChild (user_text_widget);

  argcount = 0;
  XtSetArg (args[argcount], XmNcolumns, 8);
  argcount++;
  XtSetArg (args[argcount], XmNrows, 1);
  argcount++;
  XtSetArg (args[argcount], XmNeditable, False);
  argcount++;
  XtSetArg (args[argcount], XmNautoShowCursorPosition, True);
  argcount++;
  XtSetArg (args[argcount], XmNcursorPositionVisible, False);
  argcount++;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, message_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNleftWidget, user_widget);
  argcount++;
  XtSetValues (user_text_widget, args, argcount);

  argcount = 0;
  row_column = XmCreateRowColumn (frame, "rc", args, argcount);
  XtManageChild (row_column);

  argcount = 0;
  XtSetArg (args[argcount], XmNtopAttachment, XmATTACH_WIDGET);
  argcount++;
  XtSetArg (args[argcount], XmNtopWidget, target_interval_text_widget);
  argcount++;
  XtSetArg (args[argcount], XmNleftAttachment, XmATTACH_POSITION);
  argcount++;
  XtSetArg (args[argcount], XmNleftPosition, 20);
  argcount++;
  XtSetArg (args[argcount], XmNbottomAttachment, XmATTACH_FORM);
  argcount++;
  XtSetArg (args[argcount], XmNrightAttachment, XmATTACH_FORM);
  argcount++;
  XtSetArg (args[argcount], XmNorientation, XmHORIZONTAL);
  argcount++;
  XtSetArg (args[argcount], XmNpacking, XmPACK_COLUMN);
  argcount++;
  XtSetArg (args[argcount], XmNnumColumns, 3);
  argcount++;
  XtSetValues (row_column, args, argcount);


  for (i = 0; i < Max_state_buttons; i++)
    {
      argcount = 0;
      TOGGLE_BUTTONS_WIDGETS[i] = XmCreateToggleButton (
							 row_column,
			       Toggle_Button_decl[i].label, args, argcount);
      XtManageChild (TOGGLE_BUTTONS_WIDGETS[i]);

      XtAddCallback (TOGGLE_BUTTONS_WIDGETS[i],
		     XmNdisarmCallback, Menu_bar_mode_callback,
		     (caddr_t) i);

    }



/*
 * set title
 */

  set_xsw_title ();


  XmMainWindowSetAreas (main_window_widget, menu_bar,
			NULL, NULL, NULL, frame);


  XtManageChild (menu_bar);
  XtManageChild (DrawAreaW);
  XtManageChild (main_window_widget);

  XtRealizeWidget (toplevel);

  window = XtWindow (DrawAreaW);



  initialize_window_data ();

  inCommandLineOptionParse = 1;

  for (argcount = 1; argcount < argc; argcount++)
    {
      if (!strcmp (argv[argcount], "-server"))
	{
	  if ((argcount + 1) < argc)
	    {
	      build_auto_connect_list (argv[argcount + 1]);

	    }
	}
    }

  inCommandLineOptionParse = 0;
/*
 * main loop
 */

  XtAppMainLoop (appcon);


}				/* end of main */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of xsw.c */
