.\"========================================================================
.\"
.\" Name - xsw.man
.\"
.\" Version:	1.0
.\"
.\" Description:  Man page for xsw 
.\"
.\"========================================================================
.\"
.TH XSW 1X
.\"
.SH NAME
xsw \- X System Watcher
.\"
.SH SYNTAX
\fIxsw\fR \ [options]
.\"
.SH DESCRIPTION
\fIxsw \fR is a client/server based system resource monitoring tool. 
\fIxsw \fR , the client, is to be used in conjunction with \fIxswsrv \fR,
the server. 
.PP
When \fIxsw \fR is invoked, a Main Control Panel (MCP) is displayed. A
menu bar is position on top with three pull down menus:
.sp
\fBFile\fR
.ti +5
-Connect to a new server.
.ti +5
-Disconnet  a server.
.ti +5
-Exit \fIxsw\fR
.sp
\fBOptions \fR
.ti +5
-Change fonts on a per server basis. 
.ti +5
-Change button actions.
.sp
\fBHelp\fR
.ti +5
-General Display Information
.ti +5
-Options
.PP
Directly below the menu bar on the left side, is a box that contains a 
list of server(s) which \fIxsw \fR is currently connected to. The active
server will be highlighted. The MCP will reflect the state of the active 
server. All connected servers will be updated according to their \fBTarget\fR 
interval time (See Below). Only one server can be viewed on the MCP at a time. 
Directly below the menu bar and to the right of the server list is a 
message box used for displaying messages regaurding the active server.
Directly below the message box are:
.PP
\fBTarget\fR : What sampling interval is wanted for the active server. Arrow buttons change the interval. 
.PP
\fBActual\fR : The actual sampling interval obtained for the active server.
.PP
\fBUsers\fR  : The number of users for the active server. 
.sp
.PP
Below the \fBTarget\fR, \fBActual\fR, and \fBUsers\fR boxes, are toggle buttons
used for displaying system resources. The resources available for viewing are:
.sp
.TP 13
\fBCPU\fR: 
Displays cpu usage at actual interval, average cpu usage at actual 
interval * 5 , and average cpu usage at actual interval * 10. The cpu 
usage is broken down into: user time, sytem time, and break time.
.TP 13
\fBWAIT\fR: 
Displays cpu wait usage at actual interval, average cpu wait at actual 
interval * 5 , and average cpu wait at actual interval * 10. The cpu wait 
usage is broken down into: I/O time, page I/O time, and swap I/O time.
.TP 13
\fBCache \fR: 
Displays disk cache read/write hit/misses.
.TP 13
\fBOther \fR: 
Displays several tunable kernel structures:
.TP 30
.ti +7
NFILES
The maximum number of open files system-wide. Each entry represents an open file.
.TP 30
.ti +7
NINODES
The many inode table entries to allocate. Each table entry represents an in-core inode that is an active file.
.TP 30
.ti +7
NPROC
The many process tabel entries to allocate. Each table entry 
represents an active process. The number of entries depends on the number of
terminal lines available and the number of prcesses spawned by each user.
.TP 30
.ti +7
NREGION
How many region table entries are used.
.TP 30
.ti +7
CBLOCKS
How many cfree table entries are used.
.TP 30
.ti +7
CALLOUTS
How many call-out table entries are used.
.TP 30
.ti +7
NMOUNTS
How many mount table entries are used.
.TP 13
\fBPS Cpu\fR:
Displays cpu usage on a per process basis. The processes displayed can
be those \fBCUR\fRrently running and/or have run, or \fBALL\fR process
on the system. If \fBCUR\fR is choosen, then time can be shown as a 
percentage (\fB%\fR) of the interval or in \fBT\fRicks for that interval.
If \fBALL\fR process is choosen, then time can be shown as a percentage
(\fB%\fR) since boot or in \fBM\fRinutes:seconds. The following is displayed
for \fBPS Cpu\fR:
.TP 30
.ti +7
\fBS\fR
The state of the process at time of sampling. The follwing states are shown:
.TP 30
.ti +7
\fBs\fR
The process is currently sleeping, waiting for an event. 
.TP 30
.ti +7
\fBR\fR
The process is currently running. 
.TP 30
.ti +7
\fBUSER\fR
The user of the process. If the process is "set uid", then the "#" character will be appended to the user name.
.TP 30
.ti +7
\fBPID\fR
The Process IDentification of the process. 
.TP 30
.ti +7
\fBCPU\fR
The cpu usage for scheduling. 
.TP 30
.ti +7
\fBPRI \fR
The priority of the process. 
.TP 30
.ti +7
\fBNI\fR
The nice value used for cpu usage. 
.TP 30
.ti +7
\fBUCPU\fR
Tser time of the process. 
.TP 30
.ti +7
\fBSCPU\fR
System time of the process. 
.TP 30
.ti +7
\fBU+S\fR
User + system time of the process. 
.TP 30
.ti +7
\fBSIZE\fR
Size of the process, according to the "proc" data structure.. 
.TP 30
.ti +7
\fBTTY\fR
Tty associated with the process. 
.TP 30
.ti +7
\fBCMD\fR
The arguments from the execution of the process. 
.TP 13
\fBPS I/O\fR:
Displays I/O on a per process basis. The processes displayed can be those
\fBCUR\fRrently running and/or have run, or \fBALL\fR process on the system. 
If \fBCUR\fRrent is choosen, then time can be shown as a percentage 
(\fB%\fR) of the interval or in \fBT\fRicks for that interval. If \fBALL\fR
process is choosen, then time can be shown as a percentage (\fB%\fR) since 
boot or in \fBM\fRinutes:seconds. The following is displayed for \fBPS I/O\fR:
.TP 30
.ti +7
\fBUSER\fR
The user of the process. If the process is "set uid", then the "#" character will be appended to the user name.
.TP 30
.ti +7
\fBPID\fR
The Process IDentification of the process. 
.TP 30
.ti +7
\fBSWAP\fR
The number of bytes to/from swap for that process. 
.TP 30
.ti +7
\fBCHAR\fR
The number of characters for that process. 
.TP 30
.ti +7
\fBREAD\fR
The number of reads for that process. 
.TP 30
.ti +7
\fBWRITE\fR
The number of writes for that process. 
.TP 30
.ti +7
\fBTOTAL\fR
The number of read + writes for that process. 
.TP 30
.ti +7
\fBCMD\fR
The arguments from the execution of the process.
.TP 13
\fBPS Mem\fR:
Displays memory on a per process basis. Memory is displayed in memory "pages"
and can be in \fBA\fRccending or \fBD\fReccending order. There are several 
different \fBVIEW\fRs of memory:
.sp
.TP 30
.ti +7
\fBCore Storage Only: Private & Shared\fR: 
.TP 35
.ti +10
\fBUSER\fR
The user of the process.
.TP 35
.ti +10
\fBPID\fR
The Process IDentification of the process. 
.TP 35
.ti +10
\fBVSIZE\fR
The virtual size of the process. This is the maximum size that the
process can grow to. 
.TP 35
.ti +10
\fBSHRD\fR
The number of pages that are sharable. 
.TP 35
.ti +10
\fBPRIV\fR
The number of pages that are private. 
.TP 35
.ti +10
\fBWTD\fR
The number of pages in a region that are valid divided by the number of process referenceing the region.
.TP 35
.ti +10
\fBTOTAL\fR
The \fBPRIV\fR + \fBWTD\fR. 
.TP 35
.ti +10
\fBCMD\fR
The arguments from the execution of the process. 
.sp
.TP 30
.ti +7
\fBCore Storage Only\fR: 
.TP 35
.ti +10
\fBUSER\fR
The user of the process.
.TP 35
.ti +10
\fBPID\fR
The Process IDentification of the process. 
.TP 35
.ti +10
\fBVSIZE\fR
The virtual size of the process. This is the maximum size that the process can grow to. 
.TP 35
.ti +10
\fBNONE\fR
The number of pages that are in core only. 
.TP 35
.ti +10
\fBSWAP\fR
The number of pages that are in core, but with a copy on swap. 
.TP 35
.ti +10
\fBFILE\fR
The number of pages that are in core, but with a copy on file. 
.TP 35
.ti +10
\fBLSTFILE\fR
The number of pages that are in core, but with a copy on file. 
.TP 35
.ti +10
\fBTOTAL\fR
Is \fBNONE\fR + \fBSWAP\fR + \fBFILE\fR + \fBLSTFILE\fR.
.TP 35
.ti +10
\fBCMD\fR
The arguments from the execution of the process. 
.sp
.TP 30
.ti +7
\fBAll Storage\fR  : 
.TP 35
.ti +10
\fBUSER\fR
The user of the process.
.TP 35
.ti +10
\fBPID\fR
The Process IDentification of the process. 
.TP 35
.ti +10
\fBVSIZE\fR
The virtual size of the process. This is the maximum size that the process can grow to. 
.TP 35
.ti +10
\fBNONE\fR
The number of pages that are in core only. 
.TP 35
.ti +10
\fBSWAP\fR
The number of pages that on swap. 
.TP 35
.ti +10
\fBFILE\fR
The number of pages that on file. 
.TP 35
.ti +10
\fBLSTFILE\fR
The number of pages that on file. 
.TP 35
.ti +10
\fBZERO\fR
The number of pages that are zero filled. 
.TP 35
.ti +10
\fBFILL\fR
The number of pages that are fill. 
.TP 35
.ti +10
\fBIOMAP\fR
The number of pages that are io mapped. 
.TP 35
.ti +10
\fBWINDOW\fR
The number of pages that are window. 
.TP 35
.ti +10
\fBCMD\fR
The arguments from the execution of the process. 
.sp
.TP 30
.ti +7
\fBSecondary Storage All\fR:
.TP 35
.ti +10
\fBUSER\fR
The user of the process.
.TP 35
.ti +10
\fBPID\fR
The Process IDentification of the process. 
.TP 35
.ti +10
\fBVSIZE\fR
The virtual size of the process. This is the maximum size that the process can grow to. 
.TP 35
.ti +10
\fBSWAP\fR
The number of pages that are on swap only. 
.TP 35
.ti +10
\fBFILE\fR
The number of pages that on file only. 
.TP 35
.ti +10
\fBLSTFILE\fR
The number of pages that on file only. 
.TP 35
.ti +10
\fBZERO\fR
The number of pages that have not been used yet. 
.TP 35
.ti +10
\fBFILL\fR
The number of pages that are fill. 
.TP 35
.ti +10
\fBIOMAP\fR
The number of pages that are io mapped. 
.TP 35
.ti +10
\fBWINDOW\fR
The number of pages that are window. 
.TP 35
.ti +10
\fBCMD\fR
The arguments from the execution of the process. 
.TP 13
\fBStreams\fR:
Displays streams statistics. The following information:
.TP 30
.ti +7
Config
What is currently configured into the system.
.TP 30
.ti +7
Use
The current item usage count.
.TP 30
.ti +7
%Use
The percent of Config in use.
.TP 30
.ti +7
Total
The total item usage count.
.TP 30
.ti +7
Max
The maximum item usage count.
.TP 30
.ti +7
Fail
The count of allocations failures.
.TP 30
.ti 6
is shown for these streams sturcutres:
.TP 30
.ti +7
NSTREAM
Stream allocation data.
.TP 30
.ti +7
NQUEUE
Queue allocation data.
.TP 30
.ti +7
MBLOCK
Message block allocation data.
.TP 30
.ti +7
DBLK TOT
Total stream buffers.
.TP 30
.ti +7
DBLK4
4 byte stream buffer.
.TP 30
.ti +7
BLK16
16 byte stream buffer.
.TP 30
.ti +7
BLK64
64 byte stream buffer.
.TP 30
.ti +7
BLK128
128 byte stream buffer.
.TP 30
.ti +7
BLK256
256 byte stream buffer.
.TP 30
.ti +7
BLK512
512 byte stream buffer.
.TP 30
.ti +7
BLK1024
1024 byte stream buffer.
.TP 30
.ti +7
BLK2048
2048 byte stream buffer.
.TP 30
.ti +7
BLK4096
4096 byte stream buffer.
.TP 13
\fBNFS Stats\fR:
Displays statistics on both the client and server side of NFS.
.sp
.TP 30
.ti +7
NFS Client:
.TP 35
.ti +10
calls
The total number of calls.
.TP 35
.ti +10
badcalls
The number of rejected NFS calls.
.TP 35
.ti +10
nclget
The number of times the client had to request a new handle for an NFS call.
.TP 35
.ti +10
clsleep
The number of times a NFS call was blocked becasue no client was currently 
availble. Please see man page on nfsclnt if this number is greater than 0.
.TP 35
.ti +10
null
Breakdown of NFS calls by procedure.
.sp
.TP 30
.ti +7
NFS server:
.TP 35
.ti +10
calls
The total number of calls.
.TP 35
.ti +10
badcalls
The number of rejected NFS calls.
.TP 35
.ti +10
null
Breakdown of NFS calls by procedure.
.sp
.TP 30
.ti +7
RPC client:
.TP 35
.ti +10
calls
The total number of calls made to all NFS servers.
.TP 35
.ti +10
badcalls
The number of RPC calls that returned an error.
.TP 35
.ti +10
retrans
The number of calls that were retransmitted because
not reponse was recieved from the NFS server within
the timeout period.
.TP 35
.ti +10
badxid
Indicates that the server is recieving some
retransmitted requests, but is taking a long time to
reply to all NFS requests.
.TP 35
.ti +10
timeout
Number of calls that timed out waiting for a server
response.
.TP 35
.ti +10
wait
The number of calls that had to wait on a busy client
handle to be refreshed.
.TP 35
.ti +10
peekerrs
The number of 'peek' into call message that failed.
.TP 35
.ti +10
badresps
The number of minimal reply message size failures.
.sp
.TP 30
.ti +7
RPC server:
.TP 35
.ti +10
calls
The total number of NFS RPC calls made to this server,
from all clients.
.TP 35
.ti +10
badcalls
The number of RPC calls that were rejected, before the
request was passed to the NFS service routines.
.TP 35
.ti +10
nullrecv
The number of times an nfsd daemon is scheduled to run
but finds that there is no packet on the NFS service
socket queue.
.TP 35
.ti +10
badlen
The RPC request recieved by the server was too short.
.TP 35
.ti +10
xdrcall
The XDR headers in the packet are malformed.
.TP 13
\fBSysinfo\fR:
Displays the "sysinfo" data structure. The following is displayed:
.TP 30
.ti +7
bread
The number of block reads during this interval.
.TP 30
.ti +7
bwrite
The number of block writes during this interval.
.TP 30
.ti +7
lread
The number of logical reads during this interval.
.TP 30
.ti +7
lwrite
The number of logical writes during this interval.
.TP 30
.ti +7
phread
The number of physical reads during this interval.
.TP 30
.ti +7
phwrite
The number of physical writes during this interval.
.TP 30
.ti +7
swapin
The number of swap in's during this interval.
.TP 30
.ti +7
swapout
The number of swap out's during this interval.
.TP 30
.ti +7
bswapin
The number of block swap in's during this interval.
.TP 30
.ti +7
bswapout
The number of block swap out's during this interval.
.TP 30
.ti +7
iget
The number of iget's during this interval.
.TP 30
.ti +7
namei
The number of namei's during this interval.
.TP 30
.ti +7
dirblk
The number of dirblk's during this interval.
.TP 30
.ti +7
readch
The number of character's read during this interval.
.TP 30
.ti +7
writech
The number of character's written during this interval.
.TP 30
.ti +7
rawch
The number of ????????????????????????????????????????.
.TP 30
.ti +7
canch
The number of ????????????????????????????????????????.
.TP 30
.ti +7
outch
The number of ????????????????????????????????????????.
.TP 30
.ti +7
msg
The number of ????????????????????????????????????????.
.TP 30
.ti +7
sema
The number of ????????????????????????????????????????.
.TP 30
.ti +7
maxmem
The amount of memory that is availble to user processes.
.TP 30
.ti +7
frmem
The amount of memory that is free to user processes.
.TP 30
.ti +7
mem used
The percent of memory that is being used. 
.TP 30
.ti +7
nswap
The amount of swap space available. 
.TP 30
.ti +7
frswp
The amount of free swap space available. 
.TP 30
.ti +7
swp used
The percent of swap being used. 
.TP 30
.ti +7
availswp
The amount of available swap.
.TP 30
.ti +7
pswitch
The number of context switches during this interval.
.TP 30
.ti +7
syscall
The number of system calls during this interval.
.TP 30
.ti +7
sysread
The number of system reads during this interval.
.TP 30
.ti +7
syswrit
The number of system writes during this interval.
.TP 30
.ti +7
sysfork
The number of system forks during this interval.
.TP 30
.ti +7
sysexec
The number of system execs during this interval.
.TP 30
.ti +7
runque
The number of processes ready to run.
.TP 30
.ti +7
runocc
The number of processes ????????????.
.TP 30
.ti +7
swpque
The number of processes ????????????.
.TP 30
.ti +7
swpocc
The number of processes ????????????.
.TP 30
.ti +7
vfault
The number of faults. 
.TP 30
.ti +7
demand
The number of demands. 
.TP 30
.ti +7
pfault
The number of page faults. 
.TP 30
.ti +7
cw
The number of ??????. 
.TP 30
.ti +7
steal
The number of ??????. 
.TP 30
.ti +7
frdpgs
The number of ??????. 
.TP 30
.ti +7
vfpg
The number of ??????. 
.TP 30
.ti +7
sfpg
The number of ??????. 
.TP 30
.ti +7
vspg
The number of ??????. 
.TP 30
.ti +7
sspg
The number of ??????. 
.TP 30
.ti +7
pnpfault
The number of ??????. 
.TP 30
.ti +7
wrtfault
The number of ??????. 
.TP 30
.ti +7
unmodsw
The number of ??????. 
.TP 30
.ti +7
unmodfl
The number of ??????. 
.TP 30
.ti +7
psoutok
The number of ??????. 
.TP 30
.ti +7
psinfai
The number of ??????. 
.TP 30
.ti +7
psinok
The number of ??????. 
.TP 30
.ti +7
rsout
The number of ??????. 
.TP 30
.ti +7
rsin
The number of ??????. 
.TP 30
.ti +7
pages from
.TP 30
.ti +10
swap
.TP 30
.ti +10
cache
.TP 30
.ti +10
file
.TP 13
\fBVBT\fR:
Displays the "v", "bootinfo", "tune", "bs_bootstring", & "strgCfg"  data 
structure. The following is displayed:
.TP 30
.ti +7
Var
.TP 35
.ti +10
v_autoup
Age (in seconds) before bdflush writes delayed-write buffer.
.TP 35
.ti +10
v_buf
Number of I/O buffers
.TP 35
.ti +10
v_clist
Number of clists allocated
.TP 35
.ti +10
v_file
Size of file table.
.TP 35
.ti +10
v_hbuf
Hash buffers (power of 2)
.TP 35
.ti +10
v_inode
Size of incore inode table
.TP 35
.ti +10
v_maxpmem
Maximum physical memory to use (if 0, then use all available physical memory); 
in pages.
.TP 35
.ti +10
v_maxup
Max processes per user
.TP 35
.ti +10
v_mount
Size of mount table
.TP 35
.ti +10
v_pbuf
Number of physical I/O buffers.
.TP 35
.ti +10
v_proc
Size of proc table
.TP 35
.ti +10
v_region
Number of regions allocated.
.TP 35
.ti +10
v_vhndfrac
Fraction of maxmem limits vhand.
.TP 30
.ti +7
Bootinfo
.TP 35
.ti +10
basemem
The base memory available.
.TP 35
.ti +10
extmem
The extended memory available.
.TP 35
.ti +10
bflags
The bootflags in hexidecimal .
.TP 35
.ti +10
memory available
The memory available and what it is being used for. 
.TP 30
.ti +7
Tune
.TP 35
.ti +10
t_ageintvl
Age process every so many seconds
.TP 35
.ti +10
t_bdflushr
The rate at which bdflush is run in seconds.
.TP 35
.ti +10
t_gpgshi
Once we start to steal pages, don't stop until freemem > t_getpgshi.
.TP 35
.ti +10
t_gpgslo
If freemem < t_getpgslow, then start to steal pages from processes.
.TP 35
.ti +10
t_gpgsmsk
Mask used by getpages to determine whether a page is stealable. The page is
stealable if pte & t_gpgsmskis == 0.
.TP 35
.ti +10
t_maxfc
The maximum number of pages which will be saved up and freed at once. 
.TP 35
.ti +10
t_maxsc
The maximum number of pages which will be swapped out in a single operation.
.TP 35
.ti +10
t_maxumem
The maximum size of a user's virtual address space in pages.
.TP 35
.ti +10
t_minarmem
The minimum available resident (not swapable) memory to maintain in order
to avoid deadlock.  In pages.
.TP 35
.ti +10
t_minasmem
The minimum available swapable memory to maintain in order to avoid deadlock.
In pages.
.TP 30
.ti +7
Boot String
Displays the boot string of the system.
.TP 30
.ti +7
Boot configuration
Displays the device configuration of the system.
.TP 13
\fBDisk Stats.\fR:
Displays activity for block devices. e.g., disk or tape drive. The activity
reported is:
.TP 30
.ti +7
Device #
The device.
.TP 30
.ti +7
%Busy
Portion of time that the device was busy servicing a transfer request 
during the interval.
.TP 30
.ti +7
AvQue
Average number of requests outstanding during the interval. 
.TP 30
.ti +7
r+w/s
Number of data transfers from or to the device per second during the interval.
.TP 30
.ti +7
blks/s
Number of bytes transferred in 512-byte units per second during the interval. 
.TP 30
.ti +7
AvWait
Average time in milliseconds that the transfer requests wait idly on the queue.
.TP 30
.ti +7
AvServ
Average time in miliseconds to be serviced ( which for disks includes seek,
rotational latency, and data transfer times).
.TP 13
\fBMEM\fR:
Displays the following: 
.TP 30
.ti +7
% Memory Used
Displays average and current memory usages as a percent of total memory.
.TP 30
.ti +7
% Swap Used 
Displays average and current swap usages as a percent of total swap.
.TP 30
.ti +7
% Avail. Swap Used 
Displays average and current available swap usages as a percent of total 
available swap.

.in -5n
.SH OPTIONS
.PP
Command line options allow the user to set specific colors and threshold values. \fIxsw \fR can connect to an unlimited number of servers.
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw Standard Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-display \fIdisplayName\fP	\-	Alternate display
\-help	\-	prints out all options to stdout.
\-version	\-	prints out the version of \fIxsw\fR.
\-server host:[window,window,...]	\-	T{
connects to host and pops up appropriate resource window. The follwing
resource windows are available: cpu,wait,cache,other,pscpu,psio,psmem,streams
nfs,sysinfo,vbt,disk,mem
T}
\-geometry \fIgeometry\fR	\-	Geometry.
\-title \fItitle\fR	\-	The title.
\-bg \fIcolor\fR	background:\fIcolor\fP	Background color.
\-fg \fIcolor\fR	foreground:\fIcolor\fP	Foreground color.
\-fn \fIfont\fR	font:\fIfont\fP	Default font.
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw Generic Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-labelc \fIcolor\fR	labelColor:\fIcolor\fP	T{
The color of text labels.
T}
\-usersc \fIcolor\fR	userColor:\fIcolor\fP	T{
The color of the user's window.
T}
\-intervalc \fIcolor\fR	IntervalColor:\fIcolor\fP	T{
The color of target window.
T}
\-actintervalc \fIcolor\fR	ActiveIntervalColor	T{
The color of actual window.
T}
\-actintervalwc \fIcolor\fR	ActualIntervalWarningColor:\fIcolor\fR	T{
The color of actual window when its time is +/-10% of target.
T}
\-actintervalac \fIcolor\fR	ActualIntervalAlarmColor:\fIcolor\fR	T{
The color of actual window when its time is +/-30% of target.
T}
\-titlebfg \fIcolor\fR	title_barfgColor:\fIcolor\fR	T{
The text background color for window title bars.
T}
\-titlebbg \fIcolor\fR	title_barbgColor:\fIcolor\fR	T{
The text foreground color for window title bars.
T}
\-auxbtnonbgc \fIcolor\fR	auxButtonOnBackground:\fIcolor\fR	T{
The Auxillary Buttons' "ON" Background. 
T}
\-auxbtnonffgc \fIcolor\fR	auxButtonOnForeground:\fIcolor\fR	T{
The Auxillary Buttons' "ON" Foreground. 
T}
\-auxbtnoffbgc \fIcolor\fR	auxButtonOffBackground:\fIcolor\fR	T{
The Auxillary Buttons' "OFF" Background. 
T}
\-auxbtnofffgc \fIcolor\fR	auxButtonOffForeground:\fIcolor\fR	T{
The Auxillary Buttons' "OFF" Foreground. 
T}
\-numericc \fIcolor\fR	numericColor:\fIcolor\fR	T{
The Numeric color. 
T}
\-numericwc \fIcolor\fR	numericWarningColor:\fIcolor\fR	T{
The Numeric Warning color. 
T}
\-numericac \fIcolor\fR	numericAlarmColor:\fIcolor\fR	T{
The Numeric Alarm color.
T}
\-snumericc \fIcolor\fR	staticNumericColor:\fIcolor\fR	T{
The Static Numeric color 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw CPU Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-uc \fIcolor\fR	userColor:\fIcolor\fR	T{
The User CPU percentage scale color.
T}
\-kc \fIcolor\fR	kernelColor:\fIcolor\fR	T{
The Kernel CPU percentage scale color.
T}
\-bc \fIcolor\fR	breakColor:\fIcolor\fR	T{
The Break CPU percentage scale color.
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw Wait Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-ic \fIcolor\fR	ioColor:\fIcolor\fR	T{
The I/O WAIT percentage scale color.
T}
\-pc \fIcolor\fR	pioColor:\fIcolor\fR	T{
The Page I/O WAIT percentage scale color.
T}
\-sc \fIcolor\fR	swapColor:\fIcolor\fR	T{
The Swap I/O WAIT percentage scale color.
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)     sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw MEM Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-memusedc \fIcolor\fR	memUsedColor:\fIcolor\fR	T{
The Memory percent used scale color. 
T}
\-memusedwc \fIcolor\fR	memUsedWarningColor:\fIcolor\fR	T{
The Memory percent used warning scale color. 
T}
\-memusedac \fIcolor\fR	memUsedAlarmColor:\fIcolor\fR	T{
The Memory percent used alarm scale color. 
T}
\-muwt \fIthreshhold\fR	memUsedWarningThreshhold:\fIthreshhold\fR	T{
The Memory Warning percent Threshhold. 
T}
\-muat \fIthreshhold\fR	memUsedAlarmThreshhold:\fIthreshhold\fR	T{
The Memory Alarm percent Threshhold. 
T}
\-swapusedc \fIcolor\fR	swapUsedColor:\fIcolor\fR	T{
The Swap memory percent used scale color. 
T}
\-swapusedwc \fIcolor\fR	swapUsedWarningColor:\fIcolor\fR	T{
The Swap memory percent used warning scale color. 
T}
\-swapusedac \fIcolor\fR	swapUsedAlarmColor:\fIcolor\fR	T{
The Swap memory percent used alarm scale color. 
T}
\-suwt \fIthreshhold\\fR	swapUsedWarningThreshhold:\fIthreshhold\\fR	T{
The Swap Warning percent Threshhold.
T}
\-suwt \fIthreshhold\\fR	swapUsedAlarmThreshhold:\fIthreshhold\\fR	T{
The Swap Alarm percent Threshhold.
T}
\-availswapusedc \fIcolor\fR	availSwapUsedColor:\fIcolor\fR	T{
The Avail. Swap memory percent used scale color.
T}
\-availswapusedwc \fIcolor\fR	availSwapUsedWarningColor:\fIcolor\fR	T{
The Avail. Swap memory percent used warning scale color.
T}
\-availswapusedac \fIcolor\fR	availSwapUsedAlarmColor:\fIcolor\fR	T{
The Avail. Swap memory percent used alarm scale color. 
T}
\-asuwt \fIthreshhold\fR	availSwapUsedWarningThreshhold:\fIthreshhold\fR	T{
The Avail. Swap Warning percent Threshhold. 
T}
\-asuat \fIthreshhold\fR	availSwapUsedAlarmThreshhold:\fIthreshhold\fR	T{
The Avail. Swap Alarm percent Threshhold. 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw Cache Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-cachereadhitc \fIcolor\fR	cacheReadHitColor:\fIcolor\fR	T{
The Read Cache Hit scale color. 
T}
\-cachewritehitc \fIcolor\fR	cacheWriteHitColor:\fIcolor\fR	T{
The Write Cache Hit scale color. 
T}
\-cachereadmissc \fIcolor\fR	cacheReadMissColor:\fIcolor\fR	T{
The Read Cache Miss scale color. 
T}
\-cachewritemissc \fIcolor\fR	cacheWriteMissColor:\fIcolor\fR	T{
The Write Cache Miss scale color. 
T}
\-cachereadmisswc \fIcolor\fR	cacheReadMissWarningColor:\fIcolor\fR	T{
The Read Cache Miss Warning scale color. 
T}
\-cachewritemisswc \fIcolor\fR	cacheWriteMissWarningColor:\fIcolor\fR	T{
The Write Cache Miss Warning scale color. 
T}
\-cachereadmissac \fIcolor\fR	cacheReadMissAlarmColor:\fIcolor\fR	T{
The Read Cache Miss Alarm scale color. 
T}
\-cachewritemissac \fIcolor\fR	cacheWriteMissAlarmColor:\fIcolor\fR	T{
The Write Cache Miss Alarm scale color. 
T}
\-rca \fIpercent\fR	readCacheAlarmThreshhold:\fIpercent\fR	T{
The Read Cache Hit alarm percentage. 
T}
\-wca \fIpercent\fR	writeCacheAlarmThreshhold:\fIpercent\fR	T{
The Write Cache Hit alarm percentage. 
T}
\-rcw \fIpercent\fR	readCacheWarningThreshhold:\fIpercent\fR	T{
The Read Cache Hit warning percentage. 
T}
\-wcw \fIpercent\fR	writeCacheWarningThreshhold:\fIpercent\fR	T{
The Write Cache Hit warning percentage. 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)      sw(2i)  sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw Other Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-nfilec \fIcolor\fR	nfileColor:\fIcolor\fR	T{
The NFILE percentage scale color. 
T}
\-ninodec \fIcolor\fR	ninodeColor:\fIcolor\fR	T{
The NINODE percentage scale color. 
T}
\-nprocc \fIcolor\fR	nprocColor:\fIcolor\fR	T{
The NPROC percentage scale color. 
T}
\-nregionc \fIcolor\fR	nregionColor:\fIcolor\fR	T{
The NREGION percentage scale color. 
T}
\-ncblocksc \fIcolor\fR	ncblocksColor:\fIcolor\fR	T{
The NCBLOCKS percentage scale color. 
T}
\-nfileac \fIcolor\fR	nfileAlarmColor:\fIcolor\fR	T{
The NFILE Alarm percentage scale color. 
T}
\-ninodeac \fIcolor\fR	ninodeAlarmColor:\fIcolor\fR	T{
The NINODE Alarm percentage scale color. 
T}
\-nprocac \fIcolor\fR	nprocAlarmColor:\fIcolor\fR	T{
The NPROC Alarm percentage scale color. 
T}
\-nregionac \fIcolor\fR	nregionAlarmColor:\fIcolor\fR	T{
The NREGION Alarm percentage scale color. 
T}
\-ncblocksac \fIcolor\fR	ncblocksAlarmColor:\fIcolor\fR	T{
The NCBLOCKS Alarm percentage scale color. 
T}
\-nfileat \fIthreshhold\fR	nfileAlarmThreshhold:\fIthreshhold\fR	T{
The NFILE Alarm percent Threshhold. 
T}
\-ninodeat \fIthreshhold\fR	ninodeAlarmThreshhold:\fIthreshhold\fR	T{
The NINODE Alarm percent Threshhold. 
T}
\-nprocat \fIthreshhold\fR	nprocAlarmThreshhold:\fIthreshhold\fR	T{
The NPROC Alarm percent Threshhold. 
T}
\-nregionat \fIthreshhold\fR	nregionAlarmThreshhold:\fIthreshhold\fR	T{
The NREGION Alarm percent Threshhold. 
T}
\-ncblocksat \fIthreshhold\fR	ncblocksAlarmThreshhold:\fIthreshhold\fR	T{
The NCBLOCKS Alarm percent Threshhold. 
T}
\-nfilewc \fIcolor\fR	nfileWaringColor:\fIcolor\fR	T{
The NFILE Warning percentage scale color. 
T}
\-ninodewc \fIcolor\fR	ninodeWarningColor:\fIcolor\fR	T{
The NINODE Warning percentage scale color. 
T}
\-nprocwc \fIcolor\fR	nprocWarningColor:\fIcolor\fR	T{
The NPROC Warning percentage scale color. 
T}
\-nregionwc \fIcolor\fR	nregionWarningColor:\fIcolor\fR	T{
The NREGION Warning percentage scale color. 
T}
\-ncblockswc \fIcolor\fR	ncblocksWarningColor:\fIcolor\fR	T{
The NCBLOCKS Warning percentage scale color. 
T}
\-nfilewt \fIpercent\fR	nfileWarningThreshhold:\fIpercent\fR	T{
The NFILE Warning percent Threshhold. 
T}
\-ninodewt \fIpercent\fR	ninodeWarningThreshhold:\fIpercent\fR	T{
The NINODE Warning percent Threshhold. 
T}
\-nprocwt \fIpercent\fR	nprocWarningThreshhold:\fIpercent\fR	T{
The NPROC Warning percent Threshhold. 
T}
\-ncblockswt \fIpercent\fR	ncblocksWarningThreshhold:\fIpercent\fR	T{
The NCBLOCKS Warning percent Threshhold. 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)   sw(2i)   sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw PS Mem Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-psmemc \fIcolor\fR	psMemColor:\fIcolor\fR	T{
The PS Memory color 
T}
\-psmemgrowc \fIcolor\fR	psMemGrowingColor:\fIcolor\fR	T{
The PS Memory growing color. 
T}
\-psmemshrinkc \fIcolor\fR	psMemShrinkingColor:\fIcolor\fR	T{
The PS Memory shrinking color. 
T}
\-psmemnewc \fIcolor\fR	psMemNewColor:\fIcolor\fR	T{
The PS Memory new color. 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)   sw(2i)   sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw PS CPU Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-pscpuidlec \fIcolor\fR	psCpuIdleColor:\fIcolor\fR	T{
The PS CPU idle color. 
T}
\-pscpuactivec \fIcolor\fR	psCpuActiveColor:\fIcolor\fR	T{
The PS CPU active color .
T}
\-pscpunewc \fIcolor\fR	psCpuNewColor:\fIcolor\fR	T{
The PS CPU new color. 
T}
\-pscpurunc \fIcolor\fR	psCpuRunningColor:\fIcolor\fR	T{
The PS CPU running color. 
T}
.TE
.sp
.TS
allbox doublebox;
lw(1.25i)   sw(2i)   sw(2i)
_    | _    | _
lp-2 | lp-2 | lp-2.
\fBXsw PS IO Window Options\fP
\fBCommand-line Option	Resource Name	Description\fP
\-psioidlec \fIcolor\fR	psioidlec:\fIcolor\fR	T{
The PS IO idle color. 
T}
\-psioactivec \fIcolor\fR	psioactivec:\fIcolor\fR	T{
The PS IO active color. 
T}
\-psionewc \fIcolor\fR	psionewc:\fIcolor\fR	T{
The PS IO new color. 
T}
.TE
.sp 2
.SH LIMITATIONS
.PP
FILL IN THE BLANK
 
.sp
.SH AUTHOR
.TS
doublebox;
c.
Rick Rasmussen
The Santa Cruz Operation
\fIrickra@sco.com\fP
.TE
.sp 2
.s 2
.SH SEE ALSO
X(1X), xswsrv(1X)
