/*
 *	@(#) resources.h 12.1 95/05/09 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S002, 21-Sep-93, rickra
 * 	 Added resources for disk space 
 *
 * S001, 27-May-93, rickra
 * 	 Added resources for MEM window.
 *	 Added resources for CALLOUTS NMOUNTS...
 *
 * S000, 30-Sep-92, rickra
 * 	 Added copyright and modification history
 */

typedef struct 
{
/*
	char *geom;
*/
	int x;					/* +-- results                        */
	int y;					/* |   of XParseGeometry processing   */
	unsigned int width;				/* |   on res.geometry                */
	unsigned int height;				/* +-- and toplevel                  */
	Boolean help;
	Boolean version;
	char *labelColor;	
	char *UsersColor;
	char *TimeOfDayColor;
	char *IntervalColor;
	char *ActualIntervalColor;
	char *ActualIntervalWarningColor;
	char *ActualIntervalAlarmColor;
	char *DisplayMessagesColor;
	char *title_barfgColor;	
	char *title_barbgColor;	
	char *title;
	char *name;
	char *background;
	char *foreground;
	char *font;
	char *userColor;
	char *kernelColor;
	char *breakColor;
	char *ioColor;
	char *pioColor;
	char *swapColor;

	char *memUsedColor;
	char *memUsedWarningColor;
	char *memUsedAlarmColor;
	int  memUsedWarningThreshhold;
	int  memUsedAlarmThreshhold;

	char *swapUsedColor;
	char *swapUsedWarningColor;
	char *swapUsedAlarmColor;
	int  swapUsedAlarmThreshhold;
	int  swapUsedWarningThreshhold;

	char *availSwapUsedColor;
	char *availSwapUsedWarningColor;
	char *availSwapUsedAlarmColor;
	int  availSwapUsedAlarmThreshhold;
	int  availSwapUsedWarningThreshhold;

	char *nfileColor;
	char *ninodeColor;	
	char *nprocColor;
	char *nregionColor;
	char *ncblocksColor;

	char *ninodeAlarmColor;	
	char *nfileAlarmColor;
	char *nprocAlarmColor;
	char *nregionAlarmColor;
	char *ncblocksAlarmColor;

	int ninodeAlarmThreshhold;
	int nfileAlarmThreshhold;
	int nprocAlarmThreshhold;
	int nregionAlarmThreshhold;
	int ncblocksAlarmThreshhold;

	char *ninodeWarningColor;	
	char *nfileWarningColor;
	char *nprocWarningColor;
	char *nregionWarningColor;
	char *ncblocksWarningColor;

	int ninodeWarningThreshhold;
	int nfileWarningThreshhold;
	int nprocWarningThreshhold;
	int nregionWarningThreshhold;
	int ncblocksWarningThreshhold;

	int busyAlarmThreshhold;
	int busyWarningThreshhold;
	int breakAlarmThreshhold;
	int breakWarningThreshhold;
	int waitAlarmThreshhold;
	int waitWarningThreshhold;
	int swapAlarmThreshhold;
	int swapWarningThreshhold;
	int writeCacheAlarmThreshhold;
	int writeCacheWarningThreshhold;
	int readCacheAlarmThreshhold;
	int readCacheWarningThreshhold;

	char *cache_write_hit_color;
	char *cache_read_hit_color;
	char *cache_write_miss_color;
	char *cache_read_miss_color;
	char *cache_write_miss_warning_color;
	char *cache_read_miss_warning_color;
	char *cache_write_miss_alarm_color;
	char *cache_read_miss_alarm_color;

	char *PS_mem_Color;
	char *PS_mem_growing_Color;
	char *PS_mem_shrinking_Color;
	char *PS_mem_new_Color;

	char *PS_cpu_idle_Color;
	char *PS_cpu_active_Color;
	char *PS_cpu_new_Color;
	char *PS_cpu_running_Color;

	char *auxButtonOnFG;
	char *auxButtonOnBG;
	char *auxButtonOffFG;
	char *auxButtonOffBG;

	char *PS_io_idle_Color;
	char *PS_io_active_Color;
	char *PS_io_new_Color;

	char *disk_space_losing_Color;
	char *disk_space_gaining_Color;
	char *disk_space_stable_Color;

	char *numericColor;
	char *numericWarningColor;
	char *numericAlarmColor;

	char *staticNumericColor;

	Cursor  wait_cursor,cursor;

} MyResources, *MyResourcesptr;

#define offset(field) XtOffset(MyResources *, field)
static XtResource appResources[] =
{
/*
  {"geom", "Geometry", XtRString, sizeof (char *),
   offset (geom), XtRString, (char *) 0},
*/

  {"help", "Help", XtRBoolean, sizeof (Boolean),
   offset (help), XtRString, "FALSE"},

  {"version", "Version", XtRBoolean, sizeof (Boolean),
   offset (version), XtRString, "FALSE"},

  {"title", "Title", XtRString, sizeof (char *),
   offset (title), XtRString, (char *) 0},

  {"font", "Fontxsw", XtRString, sizeof (char *),
   offset (font), XtRString, "fixed"},

  {"labelColor", "LabelColor", XtRString, sizeof (char *),
   offset (labelColor), XtRString, "white"},

  {"UsersColor", "UsersColor", XtRString, sizeof (char *),
   offset (UsersColor), XtRString, "white"},

  {"TimeOfDayColor", "TimeOfDayColor", XtRString, sizeof (char *),
   offset (TimeOfDayColor), XtRString, "white"},

  {"IntervalColor", "IntervalColor", XtRString, sizeof (char *),
   offset (IntervalColor), XtRString, "white"},

  {"ActualIntervalColor", "ActualIntervalColor", XtRString, sizeof (char *),
   offset (ActualIntervalColor), XtRString, "white"},

  {"ActualIntervalWarningColor", "ActualIntervalWarningColor", 
	XtRString, sizeof (char *),
   offset (ActualIntervalWarningColor), XtRString, "yellow"},

  {"ActualIntervalAlarmColor", "ActualIntervalAlarmColor", 
	XtRString, sizeof (char *),
   offset (ActualIntervalAlarmColor), XtRString, "red"},

  {"DisplayMessagesColor", "DisplayMessagesColor", XtRString, sizeof (char *),
   offset (DisplayMessagesColor), XtRString, "white"},

  {"title_barfgColor", "TitleBarFGColor", XtRString, sizeof (char *),
   offset (title_barfgColor), XtRString, "black"},

  {"title_barbgColor", "TitleBarBGColor", XtRString, sizeof (char *),
   offset (title_barbgColor), XtRString, "white"},

  {"background", "Back", XtRString, sizeof (char *),
   offset (background), XtRString, "black"},

  {"foreground", "Fore", XtRString, sizeof (char *),
   offset (foreground), XtRString, "white"},

  {"userColor", "NormalColor", XtRString, sizeof (char *),
   offset (userColor), XtRString, "green"},

  {"kernelColor", "WarningColor", XtRString, sizeof (char *),
   offset (kernelColor), XtRString, "yellow"},

  {"breakColor", "AlarmColor", XtRString, sizeof (char *),
   offset (breakColor), XtRString, "red"},

  {"ioColor", "NormalColor", XtRString, sizeof (char *),
   offset (ioColor), XtRString, "green"},

  {"pioColor", "WarningColor", XtRString, sizeof (char *),
   offset (pioColor), XtRString, "yellow"},

  {"swapColor", "AlarmColor", XtRString, sizeof (char *),
   offset (swapColor), XtRString, "red"},

  {"memUsedColor", "NormalColor", XtRString, sizeof (char *),
   offset (memUsedColor), XtRString, "green"},

  {"memUsedWarningColor", "WarningColor", XtRString, sizeof (char *),
   offset (memUsedWarningColor), XtRString, "yellow"},

  {"memUsedAlarmColor", "AlarmColor", XtRString, sizeof (char *),
   offset (memUsedAlarmColor), XtRString, "red"},

  {"memUsedWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (memUsedWarningThreshhold), XtRString, "80"},

  {"memUsedAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (memUsedAlarmThreshhold), XtRString, "90"},

  {"swapUsedColor", "NormalColor", XtRString, sizeof (char *),
   offset (swapUsedColor), XtRString, "green"},

  {"swapUsedWarningColor", "WarningColor", XtRString, sizeof (char *),
   offset (swapUsedWarningColor), XtRString, "yellow"},

  {"swapUsedAlarmColor", "AlarmColor", XtRString, sizeof (char *),
   offset (swapUsedAlarmColor), XtRString, "red"},

  {"swapUsedWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (swapUsedWarningThreshhold), XtRString, "80"},

  {"swapUsedAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (swapUsedAlarmThreshhold), XtRString, "90"},

  {"availSwapUsedColor", "NormalColor", XtRString, sizeof (char *),
   offset (availSwapUsedColor), XtRString, "green"},

  {"availSwapUsedWarningColor", "WarningColor", XtRString, sizeof (char *),
   offset (availSwapUsedWarningColor), XtRString, "yellow"},

  {"availSwapUsedAlarmColor", "AlarmColor", XtRString, sizeof (char *),
   offset (availSwapUsedAlarmColor), XtRString, "red"},

  {"availSwapUsedWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (availSwapUsedWarningThreshhold), XtRString, "80"},

  {"availSwapUsedAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (availSwapUsedAlarmThreshhold), XtRString, "90"},

  {"busyWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (busyWarningThreshhold), XtRString, "70"},

  {"busyAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (busyAlarmThreshhold), XtRString, "90"},

  {"breakWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (breakWarningThreshhold), XtRString, "2"},

  {"breakAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (breakAlarmThreshhold), XtRString, "5"},

  {"waitWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (waitWarningThreshhold), XtRString, "20"},

  {"waitAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (waitAlarmThreshhold), XtRString, "50"},

  {"swapWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (swapWarningThreshhold), XtRString, "10"},

  {"swapAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (swapAlarmThreshhold), XtRString, "20"},

  {"writeCacheAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (writeCacheAlarmThreshhold), XtRString, "60"},

  {"writeCacheWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (writeCacheWarningThreshhold), XtRString, "85"},

  {"readCacheAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (readCacheAlarmThreshhold), XtRString, "60"},

  {"readCacheWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (readCacheWarningThreshhold), XtRString, "90"},

  {"nfileColor", "NfileColor", XtRString, sizeof (char *),
   offset (nfileColor), XtRString, "green"},

  {"ninodeColor", "NinodeColor", XtRString, sizeof (char *),
   offset (ninodeColor), XtRString, "green"},

  {"nprocColor", "NprocColor", XtRString, sizeof (char *),
   offset (nprocColor), XtRString, "green"},

  {"nregionColor", "NregionColor", XtRString, sizeof (char *),
   offset (nregionColor), XtRString, "green"},

  {"ncblocksColor", "NcblocksColor", XtRString, sizeof (char *),
   offset (ncblocksColor), XtRString, "green"},

  {"nfileAlarmColor", "NfileAlarmColor", XtRString, sizeof (char *),
   offset (nfileAlarmColor), XtRString, "red"},

  {"ninodeAlarmColor", "NinodeAlarmColor", XtRString, sizeof (char *),
   offset (ninodeAlarmColor), XtRString, "red"},

  {"nprocAlarmColor", "NprocAlarmColor", XtRString, sizeof (char *),
   offset (nprocAlarmColor), XtRString, "red"},

  {"nregionAlarmColor", "NregionAlarmColor", XtRString, sizeof (char *),
   offset (nregionAlarmColor), XtRString, "red"},

  {"ncblocksAlarmColor", "NcblocksAlarmColor", XtRString, sizeof (char *),
   offset (ncblocksAlarmColor), XtRString, "red"},

  {"nfileWaringColor", "NfileWarningColor", XtRString, sizeof (char *),
   offset (nfileWarningColor), XtRString, "yellow"},

  {"ninodeWarningColor", "NinodeWarningColor", XtRString, sizeof (char *),
   offset (ninodeWarningColor), XtRString, "yellow"},

  {"nprocWarningColor", "NprocWarningColor", XtRString, sizeof (char *),
   offset (nprocWarningColor), XtRString, "yellow"},

  {"nregionWarningColor", "NregionWarningColor", XtRString, sizeof (char *),
   offset (nregionWarningColor), XtRString, "yellow"},

  {"ncblocksWarningColor", "NcblocksWarningColor", XtRString, sizeof (char *),
   offset (ncblocksWarningColor), XtRString, "yellow"},

  {"nfileWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (nfileWarningThreshhold), XtRString, "80"},

  {"ninodeWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (ninodeWarningThreshhold), XtRString, "80"},

  {"nprocWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (nprocWarningThreshhold), XtRString, "80"},

  {"nregionWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (nregionWarningThreshhold), XtRString, "80"},

  {"ncblocksWarningThreshhold", "WarningThreshhold", XtRInt, sizeof (int),
   offset (ncblocksWarningThreshhold), XtRString, "80"},

  {"nfileAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (nfileAlarmThreshhold), XtRString, "90"},

  {"ninodeAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (ninodeAlarmThreshhold), XtRString, "90"},

  {"nprocAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (nprocAlarmThreshhold), XtRString, "90"},

  {"nregionAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (nregionAlarmThreshhold), XtRString, "90"},

  {"ncblocksAlarmThreshhold", "AlarmThreshhold", XtRInt, sizeof (int),
   offset (ncblocksAlarmThreshhold), XtRString, "90"},

  {"cacheWriteHitColor", "CacheWriteHitColor", XtRString, sizeof (char *),
   offset (cache_write_hit_color), XtRString, "white"},

  {"cacheReadHitColor", "CacheReadHitColor", XtRString, sizeof (char *),
   offset (cache_read_hit_color), XtRString, "white"},

  {"cacheWriteMissColor", "CacheWriteMissColor", XtRString, sizeof (char *),
   offset (cache_write_miss_color), XtRString, "black"},

  {"cacheReadMissColor", "CacheReadMissColor", XtRString, sizeof (char *),
   offset (cache_read_miss_color), XtRString, "black"},

  {"cacheWriteMissWarningColor", "CacheWriteMissWarningColor", XtRString, sizeof (char *),
   offset (cache_write_miss_warning_color), XtRString, "black"},

  {"cacheReadMissWarningColor", "CacheReadMissWarningColor", XtRString, sizeof (char *),
   offset (cache_read_miss_warning_color), XtRString, "black"},

  {"cacheWriteMissAlarmColor", "CacheWriteMissAlarmColor", XtRString, sizeof (char *),
   offset (cache_write_miss_alarm_color), XtRString, "black"},

  {"cacheReadMissAlarmColor", "CacheReadMissAlarmColor", XtRString, sizeof (char *),
   offset (cache_read_miss_alarm_color), XtRString, "black"},

  {"psMemColor", "PS_Mem_Color", XtRString, sizeof (char *),
   offset (PS_mem_Color), XtRString, "black"},

  {"psMemGrowingColor", "PSMemGrowingColor", XtRString, sizeof (char *),
   offset (PS_mem_growing_Color), XtRString, "black"},

  {"psMemShrinkingColor", "PSMemShrinkingColor", XtRString, sizeof (char *),
   offset (PS_mem_shrinking_Color), XtRString, "black"},

  {"psMemNewColor", "PSMemNewColor", XtRString, sizeof (char *),
   offset (PS_mem_new_Color), XtRString, "black"},

  {"psCpuIdleColor", "PSCpuIdleColor", XtRString, sizeof (char *),
   offset (PS_cpu_idle_Color), XtRString, "black"},

  {"psCpuActiveColor", "PSCpuActiveColor", XtRString, sizeof (char *),
   offset (PS_cpu_active_Color), XtRString, "black"},

  {"psCpuNewColor", "PSCpuNewColor", XtRString, sizeof (char *),
   offset (PS_cpu_new_Color), XtRString, "black"},

  {"psCpuRunningColor", "PSCpuRunningColor", XtRString, sizeof (char *),
   offset (PS_cpu_running_Color), XtRString, "black"},

  {"psIoIdleColor", "PSIoIdleColor", XtRString, sizeof (char *),
   offset (PS_io_idle_Color), XtRString, "black"},

  {"psIoActiveColor", "PSIoActiveColor", XtRString, sizeof (char *),
   offset (PS_io_active_Color), XtRString, "black"},

  {"psIoNewColor", "PSIoNewColor", XtRString, sizeof (char *),
   offset (PS_io_new_Color), XtRString, "black"},

  {"diskspaceLosingColor", "DiskspaceLosingColor", XtRString, sizeof (char *),
   offset (disk_space_losing_Color), XtRString, "red"},

  {"diskspaceGainingColor", "DiskspaceGainingColor", XtRString, sizeof (char *),
   offset (disk_space_gaining_Color), XtRString, "blue"},

  {"diskspaceStableColor", "DiskspaceStableColor", XtRString, sizeof (char *),
   offset (disk_space_stable_Color), XtRString, "blue"},


  {"auxButtonOnForeground", "AuxButtonOnForeground", XtRString, sizeof (char *),
   offset (auxButtonOnFG), XtRString, "white"},

  {"auxButtonOnBackground", "AuxButtonOnBackground", XtRString, sizeof (char *),
   offset (auxButtonOnBG), XtRString, "black"},

  {"auxButtonOffForeground", "AuxButtonOffForeground", XtRString, sizeof (char *),
   offset (auxButtonOffFG), XtRString, "black"},

  {"auxButtonOffBackground", "AuxButtonOffBackground", XtRString, sizeof (char *),
   offset (auxButtonOffBG), XtRString, "white"},

  {"numericColor", "NumericColor", XtRString, sizeof (char *),
   offset (numericColor), XtRString, "black"},

  {"numericWarningColor", "NumericWarningColor", XtRString, sizeof (char *),
   offset (numericWarningColor), XtRString, "black"},

  {"numericAlarmColor", "NumericAlarmColor", XtRString, sizeof (char *),
   offset (numericAlarmColor), XtRString, "black"},

  {"staticNumericColor", "StaticNumericColor", XtRString, sizeof (char *),
   offset (staticNumericColor), XtRString, "black"},

  {"wait_cursor", "Cursor", XtRCursor, sizeof (Cursor),
   offset (wait_cursor), XtRString, "watch"},

  {"cursor", "Cursor", XtRCursor, sizeof (Cursor),
   offset (cursor), XtRImmediate, NULL},

};
#undef offset

static XrmOptionDescRec optionDescList[] =
{
/*
  {"-geom", "*geom", XrmoptionSepArg, (caddr_t) 0},
*/
  {"-help", "*help", XrmoptionNoArg, "TRUE"},
  {"-version", "*version", XrmoptionNoArg, "TRUE"},
  {"-fg", "*foreground", XrmoptionSepArg, (caddr_t) 0},
  {"-bg", "*background", XrmoptionSepArg, (caddr_t) 0},
  {"-title", "*title", XrmoptionSepArg, (caddr_t) 0},
  {"-labelc", "*labelColor", XrmoptionSepArg, (caddr_t) 0},
  {"-usersc", "*UsersColor", XrmoptionSepArg, (caddr_t) 0},
  {"-timec", "*TimeOfDayColor", XrmoptionSepArg, (caddr_t) 0},
  {"-intervalc", "*IntervalColor", XrmoptionSepArg, (caddr_t) 0},
  {"-actintervalc", "*ActualIntervalColor", XrmoptionSepArg, (caddr_t) 0},
  {"-actintervalwc", "*ActualIntervalWarningColor", XrmoptionSepArg,
						 (caddr_t) 0},
  {"-actintervalac", "*ActualIntervalAlarmColor", XrmoptionSepArg, 
						 (caddr_t) 0},
  {"-titlebfg", "*title_barfgColor", XrmoptionSepArg, (caddr_t) 0},
  {"-titlebbg", "*title_barbgColor", XrmoptionSepArg, (caddr_t) 0},
  {"-fn", "*font", XrmoptionSepArg, (caddr_t) 0},
  {"-ms", "*pointerColor", XrmoptionSepArg, (caddr_t) 0},
  {"-uc", "*userColor", XrmoptionSepArg, (caddr_t) 0},
  {"-kc", "*kernelColor", XrmoptionSepArg, (caddr_t) 0},
  {"-bc", "*breakColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ic", "*ioColor", XrmoptionSepArg, (caddr_t) 0},
  {"-pc", "*pioColor", XrmoptionSepArg, (caddr_t) 0},
  {"-sc", "*swapColor", XrmoptionSepArg, (caddr_t) 0},

  {"-memusedc", "*memUsedColor", XrmoptionSepArg, (caddr_t) 0},
  {"-memusedwc", "*memUsedWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-memusedac", "*memUsedAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-muwt", "*memUsedWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-muat", "*memUsedAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-swapusedc", "*swapUsedColor", XrmoptionSepArg, (caddr_t) 0},
  {"-swapusedwc", "*swapUsedWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-swapusedac", "*swapUsedAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-suwt", "*swapUsedWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-suat", "*swapUsedAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-availswapusedc", "*availSwapUsedColor", XrmoptionSepArg, (caddr_t) 0},
  {"-availswapusedwc", "*availSwapUsedWarningColor", XrmoptionSepArg, 
				(caddr_t) 0},
  {"-availswapusedac", "*availSwapUsedAlarmColor", XrmoptionSepArg, 
				(caddr_t) 0},
  {"-asuwt", "*availSwapUsedWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-asuat", "*availSwapUsedAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},

  {"-bwt", "*busyWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-bat", "*busyAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-Bwt", "*breakWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-Bat", "*breakAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-wwt", "*waitWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-wat", "*waitAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-swt", "*swapWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-sat", "*swapAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-rca", "*readCacheAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-rcw", "*readCacheWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-wca", "*writeCacheAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-wcw", "*writeCacheWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nfilec", "*nfileColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ninodec", "*ninodeColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nprocc", "*nprocColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nregionc", "*nregionColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ncblocksc", "*ncblocksColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nfileac", "*nfileAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ninodeac", "*ninodeAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nprocac", "*nprocAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nregionac", "*nregionAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ncblocksac", "*ncblocksAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nfilewc", "*nfileWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ninodewc", "*ninodeWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nprocwc", "*nprocWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nregionwc", "*nregionWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-ncblockswc", "*ncblocksWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-nfilewt", "*nfileWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-ninodewt", "*ninodeWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nprocwt", "*nprocWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nregionwt", "*nregionWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-ncblockswt", "*ncblocksWarningThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nfileat", "*nfileAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-ninodeat", "*ninodeAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nprocat", "*nprocAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-nregionat", "*nregionAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-ncblocksat", "*ncblocksAlarmThreshhold", XrmoptionSepArg, (caddr_t) 0},
  {"-cachereadhitc", "*cacheReadHitColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachewritehitc", "*cacheWriteHitColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachereadmissc", "*cacheReadMissColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachewritemissc", "*cacheWriteMissColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachereadmisswc", "*cacheReadMissWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachewritemisswc", "*cacheWriteMissWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachereadmissac", "*cacheReadMissAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-cachewritemissac", "*cacheWriteMissAlarmColor", XrmoptionSepArg, (caddr_t) 0},


  {"-psmemc", "*psMemColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psmemgrowc", "*psMemGrowingColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psmemshrinkc", "*psMemShrinkingColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psmemnewc", "*psMemNnewColor", XrmoptionSepArg, (caddr_t) 0},
  {"-pscpuidlec", "*psCpuIdleColor", XrmoptionSepArg, (caddr_t) 0},
  {"-pscpuactivec", "*psCpuActiveColor", XrmoptionSepArg, (caddr_t) 0},
  {"-pscpunewc", "*psCpuNewColor", XrmoptionSepArg, (caddr_t) 0},
  {"-pscpurunc", "*psCpuRunColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psioidlec", "*psIoIdleColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psioactivec", "*psIoActiveColor", XrmoptionSepArg, (caddr_t) 0},
  {"-psionewc", "*psIoNewColor", XrmoptionSepArg, (caddr_t) 0},


  {"-disklosingc", "*diskspaceLosingColor", XrmoptionSepArg, (caddr_t) 0},
  {"-diskgainingc", "*diskspaceGainingColor", XrmoptionSepArg, (caddr_t) 0},
  {"-diskstablec", "*diskspaceStableColor", XrmoptionSepArg, (caddr_t) 0},

  {"-auxbtnonbgc", "*auxButtonOnBackground", XrmoptionSepArg, (caddr_t) 0},
  {"-auxbtnonffgc", "*auxButtonOnForeground", XrmoptionSepArg, (caddr_t) 0},
  {"-auxbtnoffbgc", "*auxButtonOffBackground", XrmoptionSepArg, (caddr_t) 0},
  {"-auxbtnofffgc", "*auxButtonOffForeground", XrmoptionSepArg, (caddr_t) 0},

  {"-numericc", "*numericColor", XrmoptionSepArg, (caddr_t) 0},
  {"-numericwc", "*numericWarningColor", XrmoptionSepArg, (caddr_t) 0},
  {"-numericac", "*numericAlarmColor", XrmoptionSepArg, (caddr_t) 0},
  {"-snumericc", "*staticNumericColor", XrmoptionSepArg, (caddr_t) 0}

};


typedef struct myusagelist
{
  char           *opt;
}               MyUsageList;

/*  NEED TO ADD THE FOLLOWING TO FUCTIONALITY


  { "-display displayname",  "X server to contact" },
  { "-geometry geom",        "size (in characters) and position" },
  { "-/+rv",                 "turn on/off reverse video" },
  { "-iconic",               "start iconic" },
  { "-bd color",             "border color" },
  { "-bw number",            "border width in pixels" },

*/

static MyUsageList usage_list[] =
{
  {"-help			print out this message"},
  {"-version		display current version identification"},
  {"-server "},
  {"  host:[win,win,..]	specifies a server to connect to and"},
  {"			resource window to pop up. Resource window"},
  {"			can be one of:cpu,wait,cache,other,pscpu,"},
  {"			psio,psmem,streams,nfs,sysinfo,vbt,disk,mem"},
  {"-geometry		size (in characters) and position"},
  {"-title			title for the xsw window"},
  {"-bg color		background color"},
  {"-fg color		foreground color"},
  {"-fn fontname		text font"},
  {"-labelc color		text label color"},
  {"-usersc color		User\'s label color"},
  {"-timec color		Time of Day label color"},
  {"-intervalc color	Current Interval color"},
  {"-actintervalc color	Actual Interval color"},
  {"-actintervalwc color	Actual Interval Warning color"},
  {"-actintervalac color	Actual Interval Alarm color"},

  {"-titlebfg color		text background color for window title bars"},
  {"-titlebbg color		text foreground color for window title bars"},

  {"-uc color		User CPU percentage scale color"},
  {"-kc color		Kernel CPU percentage scale color"},
  {"-bc color		Break CPU percentage scale color"},

  {"-ic color		I/O wait percentage scale color"},
  {"-pc color		Page I/O wait percentage scale color"},
  {"-sc color		Swap I/O wait percentage scale color"},

  {"-memusedc		Memory percent used scale color"},
  {"-memusedwc		Memory percent used warning scale color"},
  {"-memusedac		Memory percent used alarm scale color"},
  {"-muwt			Memory Warning percent Threshhold"},
  {"-muat			Memory Alarm percent Threshhold"},

  {"-swapusedc		Swap memory percent used scale color"},
  {"-swapusedwc		Swap memory percent used warning scale color"},
  {"-swapusedac		Swap memory percent used alarm scale color"},
  {"-suwt			Swap Warning percent Threshhold"},
  {"-suat			Swap Alarm percent Threshhold"},


  {"-availswapusedc		Avail. Swap memory percent used scale color"},
  {"-availswapusedwc 	Avail. Swap memory percent used warning scale color"},
  {"-availswapusedac	Avail. Swap memory percent used alarm scale color"},
  {"-asuwt			Avail. Swap Warning percent Threshhold"},
  {"-asuat			Avail. Swap Alarm percent Threshhold"},

  {"-rca percent		Read Cache Hit alarm percentage"},
  {"-wca percent		Write Cache Hit alarm percentage"},
  {"-rcw percent		Read Cache Hit warning percentage"},
  {"-wcw percent		Write Cache Hit warning percentage"},

  {"-nfilec color		NFILE percentage scale color"},
  {"-ninodec color		NINODE percentage scale color"},
  {"-nprocc color		NPROC percentage scale color"},
  {"-nregionc color		NREGION percentage scale color"},
  {"-ncblocksc color	NCBLOCKS percentage scale color"},

  {"-nfileac color		NFILE Alarm percentage scale color"},
  {"-ninodeac color		NINODE Alarm percentage scale color"},
  {"-nprocac color		NPROC Alarm percentage scale color"},
  {"-nregionac color	NREGION Alarm percentage scale color"},
  {"-ncblocksac color	NCBLOCKS Alarm percentage scale color"},

  {"-nfileat percent	NFILE Alarm percent Threshhold"},
  {"-ninodeat percent	NINODE Alarm percent Threshhold"},
  {"-nprocat percent	NPROC Alarm percent Threshhold"},
  {"-nregionat percent	NREGION Alarm percent Threshhold"},
  {"-nclbocksat percent	NCBLOCKS Alarm percent Threshhold"},

  {"-nfilewc color		NFILE Warning percentage scale color"},
  {"-ninodewc color		NINODE Warning percentage scale color"},
  {"-nprocwc color		NPROC Warning percentage scale color"},
  {"-nregionwc color	NREGION Warning percentage scale color"},
  {"-ncblockswc color	NCBLOCKS Warning percentage scale color"},

  {"-nfilewt percent	NFILE Warning percent Threshhold"},
  {"-ninodewt percent	NINODE Warning percent Threshhold"},
  {"-nprocwt percent	NPROC Warning percent Threshhold"},
  {"-ncblockswt percent	NCBLOCKS Warning percent Threshhold"},

  {"-psmemc color		Memory color"},
  {"-psmemgrowc color	PS Memory growing color"},
  {"-psmemshrinkc color	PS Memory shrinking color"},
  {"-psmemnewc color	PS Memory new color"},
  {"-pscpuidlec color	PS CPU idle color"},
  {"-pscpuactivec color	PS CPU active color"},
  {"-pscpunewc color	PS CPU new color"},
  {"-pscpurunc color	PS CPU running color"},
  {"-psioidlec color	PS IO idle color"},
  {"-psioactivec color	PS IO active color"},
  {"-psionewc color		PS IO new color"},

  {"-disklosingc color		Disk Space Losing color"},
  {"-diskgainingc color		Disk Space Stable color"},
  {"-diskstablec color		Disk Space Stable color"},

  {"-auxbtnonbgc color	Auxillary Buttons \"ON\" Background"},
  {"-auxbtnonffgc color	Auxillary Buttons \"ON\" Foreground"},
  {"-auxbtnoffbgc color	Auxillary Buttons \"OFF\" Background"},
  {"-auxbtnofffgc color	Auxillary Buttons \"OFF\" Foreground"},

  {"-numericc color		Numeric color"},
  {"-numericwc color	Numeric Warning color"},
  {"-numericac color	Numeric Alarm color"},
  {"-snumericc color	Static Numeric color"},
  {(char *) 0}
};


