/*
 *	@(#) xswboth.h 12.1 95/05/09 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S003, 24-Oct-93, rickra
 * 	 Added send_os_version_data 
 *
 * S002, 21-Sep-93, rickra
 * 	 Added send_disk_space_data
 *
 * S001, 27-May-93, rickra
 * 	 Added send_boot_time          
 *		send_bootstring_data 
 *		send_call_data
 *		send_mount_data
 *
 *
 * S000, 30-Sep-92, rickra
 * 	 Added copyright and modification history
 */

#include <sys/proc.h>
#include <sys/fs/s5dir.h>
#include <sys/user.h>


#define SOCKTYPE SOCK_STREAM
#define SOCKNAME "xsw"
#define PROTOCOL "tcp"
#define XSWPORT  2793

#define CLIENT_OK	1
#define CLIENT_NOT_OK	2

struct	netread {
	daddr_t	addresse;
	int	length;
};

struct	sysi86_struct {
	int	pid;
	int	length;
};

#define	send_user_data  	1

#define send_freemem_data	2
#define send_availsmem_data	3
#define send_sysinfo_data	4
#define send_minfo_data		5

#define send_tune_data		6
#define send_var_data		7
#define send_maxmem_data	8
#define send_nswap_data		9
#define send_bootinfo_data	10
#define send_files_data		11
#define send_inodes_data	12
#define send_procs_data		13
#define send_regions_data	14
#define send_cblocks_data	15
#define send_process_data	16

#define send_streams_data	17

#define send_sysi86_user_data 	18
#define send_mem_process_data	19
#define send_hz_data		20

#define send_nfs_data		21
#define send_nfs_available	22

#define send_floppy_disk_available	23
#define send_scsi_disk_available	24
#define send_scsi_tape_available	25
#define send_scsi_rom_available		26
#define send_esdi_disk_available	27
#define send_wd_disk_available		28
#define send_cart_tape_available	29

#define send_floppy_disk_data	30
#define send_scsi_disk_data	31
#define send_scsi_tape_data	32
#define send_scsi_rom_data	33
#define send_esdi_disk_data	34
#define send_wd_disk_data	35
#define send_cart_tape_data	36


#define send_boot_time		37
#define send_bootstring_data	38
#define send_call_data		39
#define send_mount_data		40


#define send_disk_space_data	41


#define send_os_version_data	42

#define send_kernel_read_data	1000
#define send_kmem_read_data	1001
#define send_mem_read_data	1002
#define send_swap_read_data	1003


#define send_quitting_data	9999

#define send_continue		10000

