.\"========================================================================
.\"
.\" Name - xsw.man
.\"
.\" Version:	1.0
.\"
.\" Description:  Man page for xsw 
.\"
.\"========================================================================
.\"
.TH XSWSRV 1X
.\"
.SH NAME
xswsrv  \- X System Watcher Server
.\"
.SH SYNTAX
\fIxswsrv\fR \ [options]
.\"
.SH DESCRIPTION
.PP
\fIxswsrv \fR is the server to xsw, an X based tool for system monitoring.
When \fIxswsrv \fR is invoked, it places itself in the background an dettacheds
it self from the tty.

.SH SECURITY 
.PP
To limit connections to \fIxswsrv\fP, a list of "systems" can limit connections.
\fIxswsrv\fP reads /etc/default/xswsrv for a list of system names that 
\fIxswsrv\fP can connect too. The format of the list is:

\fBCLIENT\fP=[<system name>]

Another means of limiting connections, would be to specify a specific port
that \fIxswsrv\fP binds to. This can be implemented using the command 
line arguments, or by using the /etc/default/xswsrv file option 

\fBPORT\fP=<port number>

\fIxswsrv\fP rereads this file when it recieves a hangup signal, SIGHUP.
Only system names will be added, deleted, or modified in this manner.
.in -5n
.SH OPTIONS
.PP
Command line options allow the user to set specific colors and threshold values. \fIxsw \fR can connect to an unlimited number of servers.
.sp
.TS
allbox doublebox;
lw(1.25i) sw(2i)
_    | _
lp-2 | lp-2.
\fBXsw Standard Options\fP
\fBCommand-line Option	Description\fP
\-i	Specifies that inet should spawn \fIxswsrv\fP.
\-u namelist	Specifies the namelist for the currently running system.
\-p port	Specifies the socket port to bind to.
.TE
.SH FILES 
.sp 2
.PP
/etc/default/xswsrv
.sp 2
.SH AUTHOR
.TS
doublebox;
c.
Rick Rasmussen
The Santa Cruz Operation
\fIrickra@sco.com\fP
.TE
.sp 2
.s 2
.SH SEE ALSO
xsw(1X)
