/*  xxGlobe   Global location chooser.
    Last modified 1998-04-05

    Copyright (C) 1998  David Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

class xxGlobe: public xxWindow {
public:
  xxGlobe (xxContext *context, StationIndex &in_stationIndex,
    xxTideContext *in_tidecontext);
  ~xxGlobe ();
  double center_longitude;
  void redrawGlobe ();
  void global_redraw();
  void dismiss();

protected:
  friend void xxGlobeButtonPressEventHandler (Widget w, XtPointer client_data,
			 XEvent *event, Boolean *continue_dispatch);
  friend void xxGlobeKeyboardEventHandler (Widget w, XtPointer client_data,
			 XEvent *event, Boolean *continue_dispatch);
  friend void listAllCallback (Widget w, XtPointer client_data,
    XtPointer call_data);
  friend void zoomOutCallback (Widget w, XtPointer client_data,
    XtPointer call_data);
  friend void xxGlobeHelpCallback (Widget w, XtPointer client_data,
    XtPointer call_data);
  Pixmap globepixmap;
  StationIndex *stationIndex;
  xxContext *rotatebutton, *picture, *dismissbutton,
    *listAllButton, *helpbutton, *zoomoutbutton;
  xxLocationList *locationlist;
  int translateCoordinates (Coordinates c_in, int *x, int *y, double
    center_longitude);
  void blast (int x, int y);

  unsigned size;
  int xorigin, yorigin, blastx, blasty, blastflag;
  Dimension internalHeight, internalWidth;
};
