/*  xxTextMode  Plain old text mode, in a window.
    Last modified 1998-04-05

    Copyright (C) 1998  David Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

class xxTextMode: public xxDrawable {
  friend void xxTextModeforwardCallback (Widget w, XtPointer client_data,
    XtPointer call_data);
  friend void xxTextModebackwardCallback (Widget w, XtPointer client_data,
    XtPointer call_data);
  friend void xxTextModeSaveCallback (Dstr &filename, void *in_ptr);
  friend void xxTextModeResizeHandler (Widget w, XtPointer client_data,
    XEvent *event, Boolean *continue_dispatch);

public:
  xxTextMode (xxTideContext *in_tidecontext, xxContext *in_xxcontext,
    Station *in_station);
  xxTextMode (xxTideContext *in_tidecontext, xxContext *in_xxcontext,
    Station *in_station, Timestamp t_in);
  ~xxTextMode();

  void redraw();
  void global_redraw();
  void dismiss();
  void help();
  void save();

protected:
  // Common code from multiple constructors.
  void construct ();

  Dimension origheight, origlabelheight, height;
  unsigned lines;
  void draw();
  void clearbuf();
  struct tideline {
    Timestamp tm;
    Dstr line;
    Station::EventType etype; // Used to avoid repetition
    struct tideline *next;
  };
  xxContext *label, *namelabel, *forwardbutton, *backwardbutton;
  struct tideline *firstline, *lastline;
  void predictexact (Station::Direction dir, struct tideline *tl);
};
